#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "solve.h"

#define name "matrix.dat"

int load_matrix_file(double *m, int size)
{
 FILE *f;
 int i,j;
  if (!(f=fopen(name,"r"))) return -1;
   for (i=0; i<size; i++)
    for (j=0; j<=size; j++)
     if (1!=fscanf(f,"%lf",m+i*(size+1)+j)) return -2 ;
  fclose(f);
 return 0;
}      

int load_matrix_con(double *m, int size)
{
 int i,j;
   for (i=0; i<size; i++)
    for (j=0; j<=size; j++)
     if (scanf("%lf",m+i*(size+1)+j)!=1) return -2 ;
 return 0;
}      

int load_matrix_func(double *m, int size)
{
 int i,j;
   for (i=0; i<size; i++)
    for (j=0; j<size; j++)
     m[i*(size+1)+j]=1./(i+j+1);
  for (i=0;i<size;i++)
  {
   m[i*(size+1)+size]=0;
    for (j=0; j<size; j+=2)
     m[i*(size+1)+size]+=m[i*(size+1)+j];
  }    
 return 0;
}      

void write_x(double *x,int size)
{
 int i;
  for (i=0;i<size;i++)
      printf("%lf  ",x[i]);
 printf("\n");      
}


int main()
{
 int size;
 int total_num;
 double *m;
 int way=0;
 double *x;
 int t;
 long int t_th,t_main;
 double y;
 printf("\nHow many threads?\n");
 if (1!=scanf("%d",&total_num)) return -20;
 printf("\nEnter size\n");
  if(1!=scanf("%d",&size)) return -1;// scanf
  while ((way!=1)&&(way!=2)&&(way!=3))
   {  
   printf("Where are the data? (1-file,2-console,3-function)\n"); 
    if(1!=scanf("%d",&way)) return -1;// scanf
   }
   
  if(!(m=(double*)malloc(size*(size+1)*sizeof(double)))) return -2; //malloc
  if(!(x=(double*)malloc(size*sizeof(double)))) return -2; //malloc
   switch (way)
   {
    case 1:
    {if (load_matrix_file(m,size)<0) return -3; break;}
    case 2:
    {if (load_matrix_con(m,size)<0) return -3; break;}
    case 3:
    {if (load_matrix_func(m,size)<0) return -3; break;}
   }
   
   if (solve(m,size,x,&t_th,&t_main,total_num))
    {
     printf("Virodilis`\n");
     return 1;
    } 

  printf("\nOtvet\n");
  write_x(x,size);
  printf("\nTime from threads=%ld Full_time=%ld\n",t_th,t_main);
  printf("Povtornij vvod matrix\n");
   switch (way)
   {
    case 1:
    {if (load_matrix_file(m,size)<0) return -3; break;}
    case 2:
    {if (load_matrix_con(m,size)<0) return -3; break;}
    case 3:
    {if (load_matrix_func(m,size)<0) return -3; break;}
   }
  nev(m,size,x,&y);
  printf("Nevazka=%le\n",y);
   if (way==3)
   {
    y=0;
    for (t=0;t<size;t++)
     y+= (((t+1)%2)-x[t])>0?(((t+1)%2)-x[t]):-(((t+1)%2)-x[t]);
    printf("Oshibka=%le\n",y);
    }
  free(x);
  free(m);     
  return 0; 
}
