
/* T-wrappers for tfun `init' */
struct __init_args {
};
struct __init_ress {
	T_Ptr<struct Pointer > pointer;
};
#define init(_pointer) { \
	Continuation<__init_args, __init_ress>* __cont = \
	new Continuation<__init_args, __init_ress>( \
	  __tfun_init, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	(*(_pointer)).bind(__cont); \
	__cont->ress.pointer = (_pointer); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `pr_nev' */
struct __pr_nev_args {
	T_Val<double> z;
};
struct __pr_nev_ress {
	T_Ptr<int > res;
};
#define pr_nev(_z,_res) { \
	Continuation<__pr_nev_args, __pr_nev_ress>* __cont = \
	new Continuation<__pr_nev_args, __pr_nev_ress>( \
	  __tfun_pr_nev, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.z = (_z); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `pr_ans' */
struct __pr_ans_args {
	T_Val<struct Answer> x;
};
struct __pr_ans_ress {
	T_Ptr<int > res;
};
#define pr_ans(_x,_res) { \
	Continuation<__pr_ans_args, __pr_ans_ress>* __cont = \
	new Continuation<__pr_ans_args, __pr_ans_ress>( \
	  __tfun_pr_ans, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.x = (_x); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `pr_all' */
struct __pr_all_args {
	T_Val<struct Pointer> pointer;
};
struct __pr_all_ress {
	T_Ptr<int > res;
};
#define pr_all(_pointer,_res) { \
	Continuation<__pr_all_args, __pr_all_ress>* __cont = \
	new Continuation<__pr_all_args, __pr_all_ress>( \
	  __tfun_pr_all, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.pointer = (_pointer); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `gauss' */
struct __gauss_args {
	T_Val<struct Pointer> results;
	T_Val<int> size;
};
struct __gauss_ress {
	T_Ptr<struct Answer > x_;
	T_Ptr<int > res;
};
#define gauss(_results,_size,_x_,_res) { \
	Continuation<__gauss_args, __gauss_ress>* __cont = \
	new Continuation<__gauss_args, __gauss_ress>( \
	  __tfun_gauss, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.results = (_results); \
	__cont->args.size = (_size); \
	(*(_x_)).bind(__cont); \
	__cont->ress.x_ = (_x_); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `nev' */
struct __nev_args {
	T_Val<struct Pointer> pointer;
	T_Val<int> size;
	T_Val<struct Answer> x_;
};
struct __nev_ress {
	T_Ptr<double > z_;
};
#define nev(_pointer,_size,_x_,_z_) { \
	Continuation<__nev_args, __nev_ress>* __cont = \
	new Continuation<__nev_args, __nev_ress>( \
	  __tfun_nev, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.pointer = (_pointer); \
	__cont->args.size = (_size); \
	__cont->args.x_ = (_x_); \
	(*(_z_)).bind(__cont); \
	__cont->ress.z_ = (_z_); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `count' */
struct __count_args {
	T_Val<int> rank_;
	T_Ptr<struct Matrix> m_;
	T_Val<struct Arr_List> _array;
};
struct __count_ress {
	T_Ptr<struct List > _list;
	T_Ptr<struct Matrix > outM;
};
#define count(_rank_,_m_,__array,__list,_outM) { \
	Continuation<__count_args, __count_ress>* __cont = \
	new Continuation<__count_args, __count_ress>( \
	  __tfun_count, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.rank_ = (_rank_); \
	__cont->args.m_ = (_m_); \
	__cont->args._array = (__array); \
	(*(__list)).bind(__cont); \
	__cont->ress._list = (__list); \
	(*(_outM)).bind(__cont); \
	__cont->ress.outM = (_outM); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `tmain1' */
struct __tmain1_args {
};
struct __tmain1_ress {
	T_Ptr<int > res;
};
#define tmain1(_res) { \
	Continuation<__tmain1_args, __tmain1_ress>* __cont = \
	new Continuation<__tmain1_args, __tmain1_ress>( \
	  __tfun_tmain1, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	__cont->try_fixed(); \
}

