#ifndef TPLAYER_H
#define TPLAYER_H

#include "params.h"

typedef struct
        {
         char value[FILE_NAME_SIZE];
        }
FileName;

struct em
        {                     /* estimated move */
         int   estim;
         char  move;
         char  closed; /* 0..1 */
        };

#define EM_INIT(EM, SELECTING_MAX) \
do {                                                    \
    (EM).estim = ((SELECTING_MAX) ? MIN_ESTIM : MAX_ESTIM);	\
    (EM).move = 0;                                      \
    (EM).closed = 0;                                    \
} while (0)                                             \

#define EM_ADD(EM, SELECTING_MAX, ESTIM, MOVE, FINISHED_LABEL) \
do {                                                    \
    if (SELECTING_MAX) {                                \
	if ((EM).estim < (ESTIM)) {                     \
            (EM).estim = (ESTIM);                       \
            (EM).move = (MOVE);                         \
            if ((EM).estim == MAX_ESTIM) {              \
                (EM).closed = 1;                        \
                goto FINISHED_LABEL;                    \
            }                                           \
        }                                               \
    } else {                                            \
        if ((EM).estim > (ESTIM)) {                     \
            (EM).estim = (ESTIM);                       \
            (EM).move = (MOVE);                         \
            if ((EM).estim == MIN_ESTIM) {              \
                (EM).closed = 1;                        \
                goto FINISHED_LABEL;                    \
            }                                           \
	}                                               \
    }                                                   \
} while (0)                                             \

#define EM_PRINT(EM) \
do { \
    fprintf (stderr, "closed:%d move:%c%d estim:%-8d me:%d who:%d level:%-5d\n", \
             (EM).closed, \
             "LRTB"[MOVE_DIR ((EM).move)], \
             MOVE_IDX ((EM).move) + 1, \
             (EM).estim, \
             me, who, level); \
} while (0) \


int em_sort_max (const void *ap, const void *bp)
{
#define AP ((struct em*)ap)
#define BP ((struct em*)bp)
    if (AP->closed > BP->closed) {
	return -1;
    }
    if (AP->closed < BP->closed) {
	return 1;
    }
    return BP->estim - AP->estim;
}

int em_sort_min (const void *ap, const void *bp)
{
#define AP ((struct em*)ap)
#define BP ((struct em*)bp)
    if (AP->closed > BP->closed) {
        return -1;
    }
    if (AP->closed < BP->closed) {
        return 1;
    }
    return AP->estim - BP->estim;
}


struct History
        {
         unsigned mas[((START_LEVEL+MAX_LEVEL+1)/MOVES_IN_WORD)+1];

        };
struct t_stream
	{
	 struct t_stream tptr next;
	 struct em value;
	};

#define Stream struct t_stream tptr

struct Array_t_stream
        {
         Stream stream[MOVE_MAX];
        };

#endif
