//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/langs/tcc/attribute.cc,v $
// $Revision: 1.9 $
// $Date: 2001/08/23 20:24:13 $

/* Semantic attribute calculation */

#include "node.h"

class prescope {
public:
  long attrib;
  prescope() : attrib(0) {}
//  static hash_map<const char*, prescope, hash<const char*>, eqstr> syms;
};
hash_map<const char*, prescope, hash<const char*>, eqstr> prescope_syms;


void node::calc_attrib(scope *sc, long &attrib) {
  switch(tag) {
  case TAG_TFUN:
    attrib |= ATTR_TFUN;
    break;
  case TAG_TVAL:
    attrib |= ATTR_TVAL;
    break;
  case TAG_TOUT:
    attrib |= ATTR_TOUT/*FIXME |ATTR_TVAL*/;
    break;
  case TAG_TPTR:
    attrib |= ATTR_TPTR;
    break;
  case TAG_CONST:
    attrib |= ATTR_CONST;
    break;
  case TAG_TMEMO:
    attrib |= ATTR_TMEMO;
    break;
  case TAG_SYMDEF:
    //FIXME: function will defined inside itself !
    sc->define(this);
    this->attrib |= attrib;
    // Add attribs from prescope
    this->attrib |= prescope_syms[text].attrib;
    prescope_syms[text].attrib = 0;
    break;
  case TAG_SYMREF: {
      node* symdef = sc->lookup(text);
      if (symdef) {
	this->attrib |= symdef->attrib;
	symdef->refs.push_back(this);
	def = symdef;
      }
    }
    break;
  case TAG_SYMPREDEF:
    prescope_syms[text].attrib |= attrib;
    break;
  case TAG_FUNDEF:
    // Function should be defined for current scope
    sc->define(find_first(TAG_SYMDEF));
  case TAG_SCOPE:
    sc = new scope(sc);
    attrib = 0;
    break;
  }

  if (!childs.empty()) { 
    list<node*>::iterator it = childs.begin();
    while (it != childs.end()) { 
      (*(it))->calc_attrib(sc,attrib); 
      it++; 
    } 
  } else {
    // Reset attribute after SYMDEF
    if (!strcmp(text,";") || !(strcmp(text,"(")))
      attrib = 0;
    if (!strcmp(text,",") && find_up(TAG_FPAR))
      attrib = 0;
  }
}
