//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/langs/tcc/dataflow.cc,v $
// $Revision: 1.2 $
// $Date: 2001/08/14 07:10:23 $

/* Data Flow Analyzer */

#include "node.h"

void node::strictness_set_tready(node* dflowa) {
  node *n = this;
  while (n && n != dflowa && !(n->attrib & ATTR_DENTRY)) n = n->parent;
  if (n == dflowa) attrib |= ATTR_TREADY;
}

void node::strictness() {
  if ((attrib & ATTR_TVAL) && !(attrib & ATTR_LVALUE) && tag == TAG_SYMREF) {

    /* Make all further references for this area strict */

    node *dflowa = this;
    while (!(dflowa->attrib & ATTR_DFLOWA)) {
      dflowa = dflowa->parent;
      if (!dflowa) 
	error("out of dataflow area for `%s'", text);
    }

    list<node*>::iterator it = def->refs.begin();
    while ((*it) != this) it++; it++;
    while (it != def->refs.end()) {
      (*it)->strictness_set_tready(dflowa);
      it++;
    }
  }

  if (!childs.empty()) { 
    list<node*>::iterator it = childs.begin();
    while (it != childs.end()) { 
      (*it)->strictness(); 
      it++; 
    } 
  }
}
