//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_call_info.hh,v $
// $Revision: 1.5 $
// $Date: 2001/08/14 06:46:43 $

#ifndef __gr_call_info_hh__
#define __gr_call_info_hh__

#include "gr_computation_space.hh"
#include "gr_comm_layer.hh"

namespace grace
{

#define GR_CI_LOCAL  0x0001
#define GR_CI_FIXED  0x0002
#define GR_CI_SYSTEM 0x0004
#define GR_CI_UPLOAD 0x0008
#define GR_CI_QUEUE  0x0010

struct CallInfo {
  unsigned flags;
  CompSpaceID id;
  //
  //! Originator ID
  CompSpaceID src_id ;

  inline CallInfo() :
    flags (0)
  {}

  inline CallInfo(CompSpaceID _id, 
		  unsigned _flags = GR_CI_FIXED|GR_CI_SYSTEM) :
    flags (_flags),
    id (_id)
  {}
};

extern CallInfo call_info_default;

}

#endif // __gr_call_info_hh__
