//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_external_process.hh,v $
// $Revision: 1.4 $
// $Date: 2001/02/02 12:51:40 $

#ifndef __gr_external_process_hh__
#define __gr_external_process_hh__

#include "gr_common.hh"
#include "gr_computation_state.hh"
#include "gr_core.hh"

namespace grace
{

//
//! Computation state for external process

template <>
class ComputationState<ExternalProcess> :
  public GenericComputationState
{

public:

  //
  //! Constructor
  inline ComputationState () ;
  //
  //! Destructor
  inline ~ComputationState () ;
  //
  //! Save state
  inline void save () {}
  //
  //! Restore state
  inline void restore () {}
  //
  //! Compute a node
  inline void compute (Node* _node) ;
  //
  //! Wait for further computation
  inline void wait () {}

private:

};

//
//! A computation state factory for external process

template <>
class ComputationStateFactory<ExternalProcess> :
  public GenericComputationStateFactory
{

public:

  //
  //! Constructor
  ComputationStateFactory () :
    GenericComputationStateFactory (ExternalProcess)
  {}
  //
  //! Destructor
  ~ComputationStateFactory () {}
  //
  //! Create a computation state
  inline ComputationState<ExternalProcess>* create (Node* _node) ;

};

extern ComputationStateFactory<ExternalProcess>* external_factory ;

}

#endif // __gr_external_process_hh__
