#include "gr_fast_process.hh"
#include "gr_node.ih"
#include "gr_continuation.ih"

namespace grace
{

size_t const fast_process_default_heap_size = 4 * pxx::page_size ;

void ComputationState<FastProcess>::trampoline (Node* _node)
{
  dmesg("FastProcess::trampoline\n");
  ContinuationBase* cont = _node->get_continuation();
  dmesg("FastProcess::trampoline: continuation at %p\n", cont);
  cont->add_ref();
  (*cont->function)(cont->get_args(), cont->get_ress());
  dmesg("%u: computed %p\n", current_worker->get_pid(), _node);
  _node->finish_computation();
  cont->del_ref();
//  Node* n;
//  while ((n = _cont->node->out.get()) != null) {
//    printf("!!! dependence between %p and %p\n", n, _cont->node);
//  }
  __libc_longjmp(current_worker->jbuf, 1);
}

}
