#include "gr_memo.ih"

namespace grace {

unsigned MemoTableEntryBase::hash(void *_key, size_t _size) 
{
    unsigned char *p = (unsigned char*)_key;
    size_t size_left = _size;
    unsigned int hash_val = 0;
#define do_all_steps_for(type) \
    while(size_left >= sizeof(type)) { \
      hash_val ^= *(type*)p; \
      p += sizeof(type); size_left -= sizeof(type); \
    }
    do_all_steps_for(unsigned int); 
    do_all_steps_for(unsigned short); 
    do_all_steps_for(unsigned char);
#undef do_all_steps_for    
    return hash_val;
  }

MemoTableEntryBase **
MemoTableEntryBase::lookup(void *_key, size_t _size) 
{
  MemoTableEntryBase **table_entry = 
    table + (hash(_key,_size) % MEMO_TABLE_SIZE);
  MemoTableEntryBase **p;
  for (p = table_entry; *p != null; p = &(*p)->next) 
    if ((*p)->size == _size && memcmp((*p)->key,_key,_size) == 0)
      break;
  return p;
}

MemoTableEntryBase** MemoTableEntryBase::table;

pxx::Spinlock* MemoTableEntryBase::memo_spinlock;

}
