//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_options.hh,v $
// $Revision: 1.10 $
// $Date: 2002/01/30 11:49:23 $

#ifndef __gr_options_hh__
#define __gr_options_hh__

#include "gr_common.hh"

namespace grace
{

struct Options {
  //
  //! If we want persistency and checkpointing
  bool persistent ;
  //
  //! Whether we want to print some more mesaages
  bool verbose ;
  //
  //! Whether we want to print profiling summary
  bool show_profiling ;
  //
  //! Whether we want to print detailed profiling messages
  bool profile_verbose ;
  //
  //! Specifies a number of worker processes (if 0 - automatic)
  unsigned nworkers ;
  //
  //! Prenatal queue low watermark
  unsigned low_wm ;
  //
  //! Prenatal queue high watermark
  unsigned high_wm ;
  //
  //! Permanently notifies if worker is free
  unsigned notify_empty ;
  //
  //! Check for stack overflow
  bool check_stack ;
  //
  //! Stack size (in pages) for t-functions computation
  unsigned stack_size ;

  inline Options () :
    persistent (false),
    verbose (false),
    show_profiling (false),
    profile_verbose (false),
    nworkers (0),
    low_wm (2),
    high_wm (4),
    notify_empty (true),
    check_stack(false),
    stack_size (4)
{}

} ;

extern Options options ;

}

#endif // __gr_options_hh__
