//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_shared_chunk_allocator.hh,v $
// $Revision: 1.4 $
// $Date: 2001/01/23 01:26:49 $

#ifndef __gr_shared_chunk_allocator_hh__
#define __gr_shared_chunk_allocator_hh__

#include "pxx_i_allocator.hh"
#include "pxx_chunk_allocator.hh"
#include "pxx_spinlock.hh"
#include "pxx_sync.hh"

namespace grace
{

class SharedChunkAllocator :
  public pxx::ChunkAllocator,
  protected pxx::Spinlock
{

public:

  inline SharedChunkAllocator (
    pxx::I_Allocator& _allocator, size_t const _chunksize
  ) :
    pxx::ChunkAllocator (_allocator, _chunksize)
  {}

  inline ~SharedChunkAllocator ()
  {}

  inline void* allocate ()
  {
    synchronize(Spinlock, self);
    return pxx::ChunkAllocator::allocate();
  }

  inline void deallocate (void* _ptr)
  {
    synchronize(Spinlock, self);
    pxx::ChunkAllocator::deallocate(_ptr);
  }

};

}

#endif // __gr_shared_chunk_allocator_hh__
