#include "gr_core.hh"
#include "gr_worker.ih"
#include "gr_node.ih"
#include "gr_computation_state.ih"
#include "gr_fast_process.ih"
#include "gr_continuation.ih"
#include "gr_tval.ih"
#include "gr_tptr.ih"
#include "gr_tarray.ih"

//---------------------------------------------------------------------------

namespace grace
{

struct __f__args
{
//  mutable T_Array<int> fibs ;
  T_Val<int> n ;
};

struct __f__ress
{
  T_Ptr<int> res ;
};

int cfib (int n)
{
#if 1
  if (n < 2) return n;
  else return cfib(n - 1) + cfib(n - 2);
#else
  usleep(300000);
  return 1;
#endif
}

void fib (__f__args const* _args, __f__ress* _ress)
{
dmesg("!!!!! FIB(%d)\n", (int const&)_args->n);
//  if (_args->n < 20) _ress->res = _args->n;
  if (false) {
//  if (((_args->fibs)[_args->n]).is_ready()) {
//    *(_ress->res) = (_args->fibs)[_args->n];
  } else {
    if (_args->n < 2) {
  dmesg("Small!!!\n");
      *(_ress->res) = /*(_args->fibs)[_args->n] =*/ _args->n;
    } else if (_args->n < 20){
  dmesg("C call!!!\n");
      *(_ress->res) = /*(_args->fibs)[_args->n] =*/ cfib(_args->n - 1) + cfib(_args->n - 2);
dmesg("0001\n");
    } else {
      T_Val<int> res1;
      T_Val<int> res2;
      Continuation<__f__args, __f__ress>* cont1 =
        new Continuation<__f__args, __f__ress>(
          fib, new ComputationStateFactory<FastProcess>
        );
      cont1->argsp->n = _args->n - 1;
//      cont1->argsp->fibs = _args->fibs;
      res1.bind(cont1);
      cont1->ressp->res = &res1;
      prenatal_queue->put_front((GenericContinuation*)cont1);
  //    dmesg("%u: fib: res1 = %d\n", current_worker->get_pid(), (int const&)res1);
      Continuation<__f__args, __f__ress>* cont2 =
        new Continuation<__f__args, __f__ress>(
          fib, new ComputationStateFactory<FastProcess>
        );
      cont2->argsp->n = _args->n - 2;
//      cont2->argsp->fibs = _args->fibs;
      res2.bind(cont2);
      cont2->ressp->res = &res2;
      prenatal_queue->put_front((GenericContinuation*)cont2);
      dmesg("%u: fib: res1 = %d\n", current_worker->get_pid(), (int const&)res1);
      dmesg("%u: fib: res2 = %d\n", current_worker->get_pid(), (int const&)res2);
      dmesg("fib: res = %d (%d + %d)\n", res1 + res2, (int const&)res1, (int const&)res2);
  /*
      if (!((_args->fibs)[_args->n]).is_ready()) {
        vmesg("fibs[%d] is not ready\n", (int const&)(_args->n));
      } else {
        vmesg("fibs[%d] is ready\n", (int const&)(_args->n));
      }
  */
      *(_ress->res) = /*(_args->fibs)[_args->n] =*/ res1 + res2;
    }
  }
}

}

using namespace grace ;

int tmain (int argc, char* argv[])
{
//  T_Array<int> fibs(100);
  T_Val<int> res;
  Continuation<__f__args, __f__ress>* cont =
    new Continuation<__f__args, __f__ress>(
      fib, new ComputationStateFactory<FastProcess>
    );
  cont->argsp->n = 23;
//  cont->argsp->fibs = fibs;
  res.bind(cont);
  cont->ressp->res = &res;
  prenatal_queue->put_front((GenericContinuation*)cont);
  vmesg("res = %d\n", (int const&)res);
  return 0;
}

