//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_timer.hh,v $
// $Revision: 1.4 $
// $Date: 2001/02/20 22:09:26 $

#ifndef __gr_timer_hh__
#define __gr_timer_hh__

#include "gr_common.hh"

#include <sys/time.h>

namespace grace
{

class Timer
{

private:

  char const* msg ;
  struct timeval start_time ;
  struct timeval end_time ;

public:

  inline Timer (char const* _msg = "") :
    msg (_msg)
  {
    vmesg("Starting timer...\n");
    gettimeofday(&start_time, null);
  }

  inline ~Timer ()
  {
    gettimeofday(&end_time, null);
    double elapsed =
      (double)(end_time.tv_sec - start_time.tv_sec) +
      (double)(end_time.tv_usec - start_time.tv_usec)/1000000;
    fprintf(stderr, "--------------------------------------------------\n");
    fprintf(stderr, "%u: %s: %f sec\n", getpid(), msg, elapsed);
    fprintf(stderr, "--------------------------------------------------\n");
  }

};

}

#endif // __gr_timer_hh__
