//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_worker.hh,v $
// $Revision: 1.24 $
// $Date: 2001/08/25 09:30:18 $

#ifndef __gr_worker_hh__
#define __gr_worker_hh__

#include <setjmp.h>
#include <stdlib.h>

namespace grace
{

//! A worker process implementation

class Worker
{

private:

  //
  //! A PID of a worker process
  pid_t pid ;
  //
  //! Busy status
  int busy ;

public:

  //
  //! setjmp() buffer
  // FIXME: should not be public
  jmp_buf jbuf ;

public:

  //
  //! Constructor
  Worker (pid_t _pid) ;
  //
  //! Destructor
  ~Worker () ;
  //
  //! Get a PID of current worker process
  pid_t get_pid () ;
  //
  //! Main worker process loop
  void run () ;
  //
  //! Set buzy status
  inline bool set_busy(int) ;
  //
  //! Check(wait) for permission to work
  inline bool is_work_enabled() ;
  //
  //! Stop(block) few workers
  static void stop_workers(int) ;
  //
  //! Continue(unblock) few workers ;
  static void cont_workers(int) ;
};

}

#endif // __gr_worker_hh__
