//
// Copyright (C) 2000, 2001 Andrey Slepuhin <pooh@msu.ru>
//
// libp++ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// libp++ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with libp++; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/pxx_common.cc,v $
// $Revision: 1.9 $
// $Date: 2001/03/30 13:40:44 $
// Author: Andrey Slepuhin <pooh@msu.ru>

#include "pxx_common.hh"

#include <cstdarg>
#include <unistd.h>

namespace pxx
{

void (*terminate) (int _error_code) = null ;

void fatal (char* _fmt, ...)
{
  va_list ap;
  va_start(ap, _fmt);
  vfprintf(stderr, _fmt, ap);
  fprintf(stderr, "\n");
  va_end(ap);
  if (terminate != null) (*terminate)(-1);
  else exit(-1);
}

size_t page_size ;
size_t orders[256] ;
size_t rounds[sizeof(size_t) * 8] ;

class Init
{

public:

  Init ()
  {
    unsigned i;
    page_size = getpagesize();
    orders[0] = 0;
    for (i = 1; i < 256; i++) {
      unsigned s = i;
      orders[i] = 0;
//      if (s != 0) s--;
      while (s) {
        s >>= 1;
        orders[i]++;
      }
      orders[i]--;
    }
    for (i = 0; i < sizeof(rounds) / sizeof(rounds[0]); i++) {
      rounds[i] = 1 << i;
    }
  }

};

Init init ;

}
