//
// Copyright (C) 2000, 2001 Andrey Slepuhin <pooh@msu.ru>
//
// libp++ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// libp++ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with libp++; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/pxx_heap.hh,v $
// $Revision: 1.5 $
// $Date: 2001/01/23 01:26:49 $
// Author: Andrey Slepuhin <pooh@msu.ru>

#ifndef __pxx_heap_hh__
#define __pxx_heap_hh__

#include "pxx_common.hh"

namespace pxx
{

class Heap
{

protected:
  //
  // heap start address
  void* const start ;
  //
  // heap maximum size
  size_t const max_size ;
  //
  // an order of maximum size
  size_t max_order ;
  //
  // heap current size
  size_t current_size ;
  //
  // an order of current size
  size_t current_order ;
  //
  //
  int fd ;
  //
  //
  bool need_remap ;

public:
  //
  // constructor
  Heap (
    void* const _start,
    size_t const _max_size,
    size_t _init_size = 0,
    int _fd = 0,
    bool _need_remap = true
  ) ;
  //
  // destructor
  ~Heap () ;
  //
  // expands a heap
  void expand (unsigned _order = 1) ;

};

}

#endif // __pxx_heap_hh__

