//
// Copyright (C) 2000, 2001 Andrey Slepuhin <pooh@msu.ru>
//
// libp++ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// libp++ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with libp++; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/pxx_i_allocator.hh,v $
// $Revision: 1.3 $
// $Date: 2001/01/23 01:26:49 $
// Author: Andrey Slepuhin <pooh@msu.ru>

#ifndef __pxx_i_alllocator_hh__
#define __pxx_i_alllocator_hh__

#include "pxx_common.hh"

namespace pxx
{

//
// generic allocator interface
class I_Allocator
{

public:

  //
  // virtual destructor
  virtual ~I_Allocator () {}
  //
  // allocate memory block of _size bytes
  virtual void* allocate (size_t _size) = 0;
  //
  // free memory block at _ptr
  virtual void deallocate (void* _ptr) = 0;
  //
  // resize memory block at _ptr to _size bytes
  virtual void* reallocate (void* _ptr, size_t _size) = 0;

};

}

#endif // __pxx_i_alllocator_hh__

