#ifndef __pxx_pipe_hh__
#define __pxx_pipe_hh__

#include "pxx_common.hh"
#include "pxx_sys_error.hh"

#include <unistd.h>

namespace pxx
{

//
//! Unix pipe

class Pipe
{

private:
  //
  //! File descriptors
  int fds[2] ;

public:
  //
  //! Constructor
  inline Pipe () throw (SysError) ;
  //
  //! Destructor
  inline ~Pipe () ;
  //
  //! Read from a pipe
  inline size_t read (void* _buf, size_t _count) throw (SysError) ;
  //
  //! Write to a pipe
  inline size_t write (void const* _buf, size_t _count) throw (SysError) ;


};

}

#endif // __pxx_pipe_hh__
