#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
//#include <tc.h>mary

#include "gr_video.h"

#include "method0.h"
#include "method1.h"
#include "method2.h"
#include "method3.h"
#include "method4.h"
#include "method5.h"
#include "method6.h"
#include "method7.h"

//mary
#define tmesg(X...) fprintf (stderr,X)
#define tvalidate(X) tdrop(X)

int server_fd;
int s_client_fd;
int client_fd;


typedef struct
{
  InfoMethod0 info0;
  InfoMethod1 info1;
  InfoMethod2 info2;
  InfoMethod3 info3;
  InfoMethod4 info4;
  InfoMethod5 info5;
  InfoMethod6 info6;
  InfoMethod7 info7;
} InfoMethods;

/*mary
typedef struct
{
  tval FullSight fs;
} TFullSight;
*/

typedef struct
{
  tval InfoMethod0 info0;
  tval InfoMethod1 info1;
  tval InfoMethod2 info2;
  tval InfoMethod3 info3;
  tval InfoMethod4 info4;
  tval InfoMethod5 info5;
  tval InfoMethod6 info6;
  tval InfoMethod7 info7;
} TInfoMethods;


void socket_write(int fd, const void* buffer, size_t count)
{
  int rest = count;
  int written = 0;
  int ret = 0;

  while( rest != 0)
  {
    ret = write(fd, (unsigned char*)buffer+written, rest);
    written += ret;
    rest -= ret;
  }
//     tmesg("   socket_write: %d bytes written\n", written);
}

void socket_read(int fd, void* buffer, size_t count)
{
  int rest = count;
  int reading = 0;
  int ret = 0;

  while( rest != 0)
  {
    ret = read(fd, (unsigned char*)buffer + reading, rest);
    reading += ret;
    rest -= ret;
  }
//     tmesg("   socket_read: %d bytes read\n", reading);
}

void prepare_socket()
{
   //variables for socket frame server
   const char* const server_name = "frame";
   struct sockaddr_un s_name;
   struct sockaddr_un s_client_name;
   socklen_t client_name_len;

   //variables for socket aim client
   const char* const client_name = "aim";
   struct sockaddr_un c_name;

   //create socket server to get frame information
   server_fd = socket(PF_LOCAL, SOCK_STREAM, 0);
   s_name.sun_family = AF_LOCAL;
   strcpy(s_name.sun_path, server_name);
   bind(server_fd, (struct sockaddr*)&s_name, SUN_LEN(&s_name));

   //waite for frame client to respond
   tmesg("Main: waiting for frame client to respond\n");
   listen(server_fd, 1);
   s_client_fd = accept(server_fd, (struct sockaddr*)&s_client_name, &client_name_len);

   //create socket client to pass aim information
   client_fd = socket(PF_LOCAL, SOCK_STREAM, 0);
   c_name.sun_family = AF_LOCAL;
   strcpy(c_name.sun_path, client_name);

   //connecte to aim server
   tmesg("Main: connecting to aim server\n");
   while(connect(client_fd, (struct sockaddr*)&c_name, SUN_LEN(&c_name))){};
}


tfun int tmethod0(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &pBitmap, InfoMethod0 &in, 
                  tout FullSight &fullSight, tout InfoMethod0 &out)
{
  tptr FullSight f_ptr = &fullSight; tptr InfoMethod0 o_ptr = &out;
 
  //prepare valid Frame Info
  FrameInfo localFI = frameInfo;
  InfoMethod0 localIN = in;
  localFI.m_pBits = (void*)pBitmap.pix;  

  tmesg("tmethod0 is running...\n");

  if(cInfo.isNewClick == 1)
  {
    localIN.prev_pos.center = cInfo.point;
    localIN.Corr_value = 0;
  }

  method0(localFI, localIN, f_ptr, o_ptr);

  tdrop(f_ptr);
  tdrop(o_ptr);

  return 0;
}


tfun int tmethod1(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod1 &in, 
                   tout FullSight &fullSight, tout InfoMethod1 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod1 o_ptr = &out;  

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod1 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod1 is running...\n");
	
   if(cInfo.isNewClick==1)
   {
     localIN.prev_pos.center = cInfo.point;
     localIN.Corr_value = 0;
   }

   method1(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}


tfun int tmethod2(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod2 &in, 
                   tout FullSight &fullSight, tout InfoMethod2 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod2 o_ptr = &out;   

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod2 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod2 is running...\n");

   if(cInfo.isNewClick==1)
   {
     localIN.sNewPosition.center = cInfo.point;
   }

   method2(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}


tfun int tmethod3(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod3 &in, 
                   tout FullSight &fullSight, tout InfoMethod3 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod3 o_ptr = &out;

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod3 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod3 is running...\n");

   if(cInfo.isNewClick==1)
   {
     localIN.sNewPosition.center = cInfo.point;
   }

   method3(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}


tfun int tmethod4(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod4 &in, 
                   tout FullSight &fullSight, tout InfoMethod4 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod4 o_ptr = &out;

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod4 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod4 is running...\n");

   if(cInfo.isNewClick==1)
   {
     localIN.sNewPosition.center = cInfo.point;
   }

   method4(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);
   
   return 0;
}


tfun int tmethod5(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod5 &in, 
                   tout FullSight &fullSight, tout InfoMethod5 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod5 o_ptr = &out;

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod5 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod5 is running...\n");

   if(cInfo.isNewClick==1)
   {
     localIN.sNewPosition.center = cInfo.point;
   }

   method5(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}


tfun int tmethod6(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod6 &in, 
                   tout FullSight &fullSight, tout InfoMethod6  &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod6 o_ptr = &out;

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   InfoMethod6 localIN = in;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod6 is running...\n");

   method6(localFI, localIN, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}

tfun int tmethod7(ControlInfo &cInfo, FrameInfo &frameInfo, TBitmap &tBitmap, InfoMethod7 &in, 
                   tout FullSight &fullSight, tout InfoMethod7 &out)
{
   tptr FullSight f_ptr = &fullSight; tptr InfoMethod7 o_ptr = &out;

   // prepare valid FrameInfo
   FrameInfo localFI = frameInfo;
   localFI.m_pBits = (void*)tBitmap.pix;

   tmesg("tmethod7 is running...\n");

   method7(localFI, in, f_ptr, o_ptr);

   tdrop(f_ptr);
   tdrop(o_ptr);

   return 0;
}



void run_methods(ControlInfo cInfo, FrameInfo frameInfo, TBitmap *pBitmap,
                 InfoMethods* pInInfo, FullSight* pSight, InfoMethods* pOutInfo)
{
  tval FullSight fs0;
  tval FullSight fs1;
  tval FullSight fs2;
  tval FullSight fs3;
  tval FullSight fs4;
  tval FullSight fs5;
  tval FullSight fs6;
  tval FullSight fs7;

  tval InfoMethod0 info0;
  tval InfoMethod1 info1; 
  tval InfoMethod2 info2;
  tval InfoMethod3 info3;
  tval InfoMethod4 info4;
  tval InfoMethod5 info5;
  tval InfoMethod6 info6;
  tval InfoMethod7 info7;      

  FullSight fullSight[8];
  TInfoMethods toutinfo;

  int i;

  tmesg("run_methods: processing frame\n");

  //tmethod0(cInfo, frameInfo, *pBitmap, pInInfo->info0, fs0, info0);
  tmethod1(cInfo, frameInfo, *pBitmap, pInInfo->info1, fs1, info1);
  tmethod2(cInfo, frameInfo, *pBitmap, pInInfo->info2, fs2, info2);
  //tmethod3(cInfo, frameInfo, *pBitmap, pInInfo->info3, fs3, info3);    
  //tmethod4(cInfo, frameInfo, *pBitmap, pInInfo->info4, fs4, info4);
  //tmethod5(cInfo, frameInfo, *pBitmap, pInInfo->info5, fs5, info5);
  //tmethod6(cInfo, frameInfo, *pBitmap, pInInfo->info6, fs6, info6);
  //tmethod7(cInfo, frameInfo, *pBitmap, pInInfo->info7, fs7, info7);


  //pOutInfo->info0 = info0;
  pOutInfo->info1 = info1;
  pOutInfo->info2 = info2;
  //pOutInfo->info3 = info3;
  //pOutInfo->info4 = info4;
  //pOutInfo->info5 = info5;
  //pOutInfo->info6 = info6;
  //pOutInfo->info7 = info7;

  //fullSight[0] = fs0;
  fullSight[1] = fs1;
  fullSight[2] = fs2;
  //fullSight[3] = fs3;
  //fullSight[4] = fs4;
  //fullSight[5] = fs5;
  //fullSight[6] = fs6;
  //fullSight[7] = fs7;

  tmesg("run_methods: processing done\n");
  *pSight = fullSight[2];

}

tfun int main(int argc, char* argv[])
{
   ControlInfo cInfo;

   FrameInfo curFrame;
   TBitmap* pbitmap;
   int bitmap_size;

   FullSight fullSight;

   InfoMethods InputInfo, OutputInfo;

   prepare_socket();

   pbitmap = (TBitmap*)malloc(sizeof(TBitmap));

   while(1)
   {
      socket_read(s_client_fd, &cInfo, sizeof(ControlInfo));
      if(cInfo.isExit==1)
        break;
      socket_read(s_client_fd, &curFrame, sizeof(FrameInfo));
      socket_read(s_client_fd, &bitmap_size, sizeof(int));
      socket_read(s_client_fd,&(pbitmap->pix), bitmap_size);   

      run_methods(cInfo, curFrame, pbitmap, &InputInfo, &fullSight, &OutputInfo);
      InputInfo = OutputInfo;

      socket_write(client_fd, &fullSight, sizeof(FullSight));
   };

   free(pbitmap);

   //removing local socket files
   close(s_client_fd);
   close(server_fd);
   close(client_fd);
   unlink("frame");
   return 0;
}
