#ifndef I_TYPES_H
#define I_TYPES_H

/******************************************************************************
*	Defines and constants
******************************************************************************/

#define MIN_FRAME_SIZE 5   // minimal size (in pixels) of the frame part for
                           // object catching

#define MAX_FRAME_SIZE 1024   // maximal size (in pixels) of the frame (X or Y)

#define MAX_OBJ_SHIFT 1.3    // maximal object shift (in pixels) between two
                           // sequential frames based on object size;
                           // i.e. if MAX_OBJ_SHIFT=2 the object can't moves
                           // far then half of object size

#define OBJ_SCALE_FACTOR 13   // if 10it's mean that object size (in pixels)
                              // should be less then one tens (here) of
                              // minimal frame dimension


/******************************************************************************
*	Typedefs
******************************************************************************/

typedef enum
   {
   eFalse,
   eTrue
   } eBool;  // simulates BOOL/bool type from C++

typedef enum
   {
   eUnknown,
   eSimple,
   eComplex
   } eObjType;  // object type exerts influence on processing technology

typedef struct
   {
   unsigned char r,g,b,l;           // red, green, blue, lightness
   } ColorRGB; // is the point in the RGB-color space

#endif
