/************************************************************
*
*     patterns for classificator 
*     
*       $Id: patterns.h,v 1.3 2003/06/28 18:54:20 school Exp school $
*       
*       OS : linux
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#ifndef PATTERNS_H
#define PATTERNS_H

#define MARK 'O'
#define NOMARK '.'

#define X 5
#define Y 7
#define N 10

#define IN X*Y

///////////////////////////////////

static data_t PATTERNS[N][Y][X+1] = 
{{  ".OOO.",
    "O...O",
    "O...O",
    "O...O",
    "O...O",
    "O...O",
    ".OOO."  },

 {  "..O..",
    ".OO..",
    "O.O..",
    "..O..",
    "..O..",
    "..O..",
    "..O.."  },

 {  ".OOO.",
    "O...O",
    "....O",
    "...O.",
    "..O..",
    ".O...",
    "OOOOO"  },

 {  ".OOO.",
    "O...O",
    "....O",
    ".OOO.",
    "....O",
    "O...O",
    ".OOO."  },

 {  "...O.",
    "..OO.",
    ".O.O.",
    "O..O.",
    "OOOOO",
    "...O.",
    "...O."  },

 {  "OOOOO",
    "O....",
    "O....",
    "OOOO.",
    "....O",
    "O...O",
    ".OOO."  },

 {  ".OOO.",
    "O...O",
    "O....",
    "OOOO.",
    "O...O",
    "O...O",
    ".OOO."  },

 {  "OOOOO",
    "....O",
    "....O",
    "...O.",
    "..O..",
    ".O...",
    "O...."  },

 {  ".OOO.",
    "O...O",
    "O...O",
    ".OOO.",
    "O...O",
    "O...O",
    ".OOO."  },

 {  ".OOO.",
    "O...O",
    "O...O",
    ".OOOO",
    "....O",
    "O...O",
    ".OOO."  }};

///////////////////////////////////

static data_t TARGET[N][OUT_SIZE] = 
{
   {HI,LO,LO,LO,LO,LO,LO,LO,LO,LO},
   {LO,HI,LO,LO,LO,LO,LO,LO,LO,LO},
   {LO,LO,HI,LO,LO,LO,LO,LO,LO,LO},
   {LO,LO,LO,HI,LO,LO,LO,LO,LO,LO},
   {LO,LO,LO,LO,HI,LO,LO,LO,LO,LO},
   {LO,LO,LO,LO,LO,HI,LO,LO,LO,LO},
   {LO,LO,LO,LO,LO,LO,HI,LO,LO,LO},
   {LO,LO,LO,LO,LO,LO,LO,HI,LO,LO},
   {LO,LO,LO,LO,LO,LO,LO,LO,HI,LO},
   {LO,LO,LO,LO,LO,LO,LO,LO,LO,HI}
};

#endif
