#ifndef _LDATA_H_
#define _LDATA_H_

#include <iostream>
#include <fstream>

// ----------------------------------------------------------------------------

//  (11.07.2003)
//  
//     
//
//  use_static_priority    --- (0, 1)    
//                                     ;
//
//  use_reverse_query      --- (0, 1)     
//                                     ;
//                                 
//  use_only_reverse_query --- (0, 1)    ;
//
//  (18.07.2003)
//
//  use_local_vicinity     --- (0, 1)    
//                                     ;
//
//  (08.09.2003)
//
//  use_plan               --- (0, 1)    
//                                    ( ); 
//

struct LocOptParams 
{
  int use_static_priority;
  int use_reverse_query;
  int use_only_reverse_query;
  int use_local_vicinity;     // (18.07.2003)
  int use_plan;               // (08.09.2003)

  int depth;                  // solve recurse depth - for debug only
  
  LocOptParams(): use_static_priority(0),
                  use_reverse_query(0),
		  use_only_reverse_query(0),
		  use_local_vicinity(0),       // (18.07.2003)
		  use_plan(0)                  // (08.09.2003) 
    {}	  
};	

// ----------------------------------------------------------------------------

#include "t_stl.h"
//#include "t_fstream.h" //   
#include "tautomat.h"
#include "tdata.h"

// ----------------------------------------------------------------------------

void copy_string(const char *, char *);

long read_graph(ifstream &G); 

// (10.07.2003)
//
//  r --- (0, 1)      ?
//
// long read_query(t_ifstream &Q);
//
// long read_query(t_ifstream &Q, int r);
//
// (25.07.2003)
//
// c  ---   constraint (local vicinity constraint)
// uc --- (0, 1)  constraint   ?

long read_query(ifstream &Q, int r, long &c, int uc);

// ----------------------------------------------------------------------------

typedef t_set<TDataItem>  TDataSet;

struct DomainItem {
  TDataItem x; //   .
  TDataItem i; //    V (0, 1) ?
  TDataItem t; //    x (0, 1) ?
  TDataItem p; //   x (28.03.2003).
  
  TDataSet V;  //      x.
};	

typedef t_list<DomainItem> Domain;

// ----------------------------------------------------------------------------

struct DomainListItem {

  long pe_size; // (11.09.2003)
                //       
	
  Domain D;

  DomainListItem(long s = 0L): pe_size(s) // (11.09.2003)
  {}	                                  //
};	

typedef t_list<DomainListItem> DomainList;

// ----------------------------------------------------------------------------

void get_query_vertices(const Query &Q, TDataSet &X);

void get_graph_vertices(const Graph &G, TDataSet &X);

// ----------------------------------------------------------------------------

void get_neighbourhood(
  const Query &Q, TDataItem x, TDataSet &Ox);

long degree(const Query &Q, TDataItem x);

// (11.07.2003)

void get_neighbourhood_r(
  const Query &Q, TDataItem x, TDataSet &Ox);

long degree_r(const Query &Q, TDataItem x);

// ----------------------------------------------------------------------------

#define DOMAIN_BORDER -1

ts::TPtr<struct TData> domain2tdomain(const Domain &D);

void tdomain2domain(ts::TPtr<struct TData> &tD, Domain &D);

// ----------------------------------------------------------------------------

void print(const Domain &D, bool full_info = false);

// ----------------------------------------------------------------------------

#endif // end of _LDATA_H_
