#ifndef __PLAN_H__
#define __PLAN_H__

// ----------------------------------------------------------------------------

#include "t_stl.h"
//#include "t_fstream.h" //   
#include "tautomat.h"
#include "tdata.h"

// ----------------------------------------------------------------------------
//
//  (08.09.2003)
//
//        :
//
//  p_item      (f_1, t_1; r_1)
//    
//                 ...  
//  
//              (f_n, t_n; r_n), 
//
//  
//
//  1) p_item ---  ( )  ;
//
//  2)   k, l: 1 <= k,l <= n  :
//
//     a.  r_k == r_l == 0,        f_k == f_l;
//
//     b.  r_k == r_l == 1,        t_k == t_l;
//
//     c.  r_k != r_l  r_l == 0,  t_k == f_l;
//
//     d.  r_k != r_l  r_l == 1,  f_k == t_l.
//
//    :
//
//  <   >  < 1>
//
//                                     ...
//
//                                   < N> 
//
//  < i>  
//
//  < > < > < 1>
//  
//                                   ...
//
//                                 < n>     
//
// ----------------------------------------------------------------------------

#if 0

struct LocSPlanEdge
{
  TDataItem from;
  TDataItem to;
  TDataItem reverse; 
};	

typedef t_multimap<TDataItem, LocSPlanEdge> LocSPlan;

typedef pair<LocSPlan::iterator, LocSPlan::iterator> LocSPlanPair;

// ----------------------------------------------------------------------------

struct SPlan: public LocSPlanEdge
{
  TDataItem p_item;
  
  struct SPlan tptr next;
};	

// ----------------------------------------------------------------------------

struct SPlan tptr loc2tplan(LocSPlan &lp);

void t2locplan(struct SPlan tptr tp, LocSPlan &lp);

void print_loc_plan(const LocSPlan &lp);

void read_plan(t_ifstream &f, LocSPlan &lp);

#endif // end of 0

// ****************************************************************************

struct SearchPlanEdge
{
  TDataItem item,     
            from,
            to,
            reverse;
};	

typedef t_list<SearchPlanEdge> SearchPlan;

typedef pair<SearchPlan::iterator, SearchPlan::iterator> SearchPlanPair;

//
//  SearchPlan      multimap
//

SearchPlanPair equal_range(SearchPlan &SP, TDataItem i);

long read_search_plan(ifstream &f);

long print_search_plan(const SearchPlan &SP);

long count(SearchPlan &SP, TDataItem i);

// ****************************************************************************

#endif // end of __PLAN_H__
