//
// GRACE compatable STL classes
//

#ifndef __T_STL_H__
#define __T_STL_H__

#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <string>
#include "t_allocator.h"

template <class T, class _Cmp=std::less<T>, class _A=t_allocator<T> >
class t_set : public std::set<T, _Cmp, _A>
{ 
	public:

		  // void *operator new(size_t sz) { return talloc(sz); }

};

template <class Key, class T,
	   	class _Cmp=std::less<Key>,
	   	class _A=t_allocator<std::pair<const Key, T> > >
class t_map	: public std::map<Key, T, _Cmp, _A>
{ };

template <class Key, class T,
        class _Cmp=std::less<Key>,
        class _A=t_allocator<std::pair<const Key, T> > >
class t_multimap : public std::multimap<Key, T, _Cmp, _A>
{ };


template <class T, class _A=t_allocator<T> >
class t_list : public std::list<T, _A>
{
	public:
		// void *operator new(size_t sz) { return talloc(sz); }
};


template <class T, class _A=t_allocator<T> >
class t_deque : public std::deque<T,_A>
{ };

template <class T, class _Cmp=t_deque<T> >
class t_queue : public std::queue<T,_Cmp>
{ };

template <class T, class _Cmp=t_deque<T> >
class t_stack : public std::stack<T,_Cmp>
{ };

/*
class t_string :
	public std::basic_string<char, std::char_traits<char>, t_allocator<char> >
{
	public:
		t_string(const char *s);
};
*/


#ifdef CYGNUS
typedef std::basic_string<char, std::string_char_traits<char>, t_allocator<char> > t_string;
#else
typedef std::basic_string<char, std::char_traits<char>, t_allocator<char> > t_string;
#endif
#endif // end of __T_STL_H__
