#ifndef _TDATA_H_
#define _TDATA_H_

// ----------------------------------------------------------------------------

struct OptParams {
//  long dbq[100];

  int use_static_priority;    // (11.07.2003)
  int use_reverse_query;      //
  int use_only_reverse_query; //
  int use_local_vicinity;     // (18.07.2003)
  int use_plan;               // (08.09.2003)
  int depth;                  // solve recurse depth - for debug only
};

struct File {
  char filename[100];
};	

// ----------------------------------------------------------------------------

#define TDATA_MAX_SIZE 256

typedef long TDataItem;

struct TData {
  long size;
  TDataItem array[TDATA_MAX_SIZE];
  
  ts::TPtr<struct TData>  next;
};	

struct TDataLoc {
  long size;	
  TDataItem array[TDATA_MAX_SIZE];
};
	
// ----------------------------------------------------------------------------

class TDataIterator {

  ts::TPtr<struct TData> TD;
  
  long position;

  public:

  TDataIterator(ts::TPtr<struct TData> D);

  TDataIterator &operator= (const TDataIterator &I);
  
  TDataItem operator()();

  TDataIterator &operator++ (int);

  bool end();
};

// ----------------------------------------------------------------------------

class TDataCreator {

  ts::TPtr<struct TData> TD;
	
  struct TDataLoc TDl;
  
  public:
  
  TDataCreator();

  ts::TPtr<struct TData> operator()();

  void add(TDataItem a);

  void close();
};
	
#endif // end of _TDATA_H_
