#include <stdio.h>
#include <inttypes.h>
#include <netinet/in.h>

struct sbmphead {
  uint16_t Signature;
  uint32_t FileLength;
  uint32_t Zero;
  uint32_t Ptr;
  uint32_t Version;
  uint32_t Width;
  uint32_t Height;
  uint16_t Planes;
  uint16_t BitsPerPixel;
  uint32_t Compression;
  uint32_t SizeImage;
  uint32_t XPelsPerMeter;
  uint32_t YPelsPerMeter;
  uint32_t ClrUsed;
  uint32_t ClrImportant;
};

#define uint16_swap(n) ((((n) & 0xff) << 8) + (((n) >> 8) & 0xff))
#define uint32_swap(n) (((uint16_swap((n) & 0xffff) << 16) + \
                        uint16_swap(((n) >> 16) & 0xffff)))

#define uint16_to_le(n) (uint16_swap(htons(n)))
#define uint32_to_le(n) (uint32_swap(htonl(n)))

struct sbmphead bmphead;

int main (int argc, char* argv[])
{
  FILE *in_mas, *in_pal, *out_bmp;
  int i, j, mas;
  unsigned char c;
  int Width;
  int Height;
  uint32_t adobte = 0;

  in_mas = fopen(argv[1], "r");
  in_pal = fopen(argv[2], "rb");
  out_bmp = fopen(argv[3], "wb");

  fscanf(in_mas, "%d", &Width);
  fscanf(in_mas, "%d", &Height);

  bmphead.Signature = uint16_to_le(0x4d42);
  bmphead.Zero = uint32_to_le(0);
  bmphead.Ptr = uint32_to_le(54 + 256 * 4);
  bmphead.Version = uint32_to_le(0x28);
  bmphead.Planes = uint16_to_le(1);
  bmphead.BitsPerPixel = uint16_to_le(8);
  bmphead.Compression = uint32_to_le(0);

  bmphead.Width = uint32_to_le((uint32_t)Width);
  bmphead.Height = uint32_to_le((uint32_t)Height);
  bmphead.SizeImage = uint32_to_le(Width * Height);
  bmphead.FileLength = uint32_to_le(54 + 256 * 4 + Width * Height);
  bmphead.XPelsPerMeter = uint32_to_le(0);
  bmphead.YPelsPerMeter = uint32_to_le(0);
  bmphead.ClrUsed = uint32_to_le(256);
  bmphead.ClrImportant = uint32_to_le(256);

  fwrite(&(bmphead.Signature),sizeof(uint16_t),1,out_bmp);
  fwrite(&(bmphead.FileLength),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Zero),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Ptr),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Version),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Width),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Height),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.Planes),sizeof(uint16_t),1,out_bmp);
  fwrite(&(bmphead.BitsPerPixel),sizeof(uint16_t),1,out_bmp);
  fwrite(&(bmphead.Compression),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.SizeImage),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.XPelsPerMeter),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.YPelsPerMeter),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.ClrUsed),sizeof(uint32_t),1,out_bmp);
  fwrite(&(bmphead.ClrImportant),sizeof(uint32_t),1,out_bmp);

  for (i = 0; i < 256; i++) {
    fread( (char *)&c,1,1,in_pal);
//  c=i;
    fwrite((char *)&c,1,1,out_bmp);

    fread( (char *)&c,1,1,in_pal);
//  c=i;
    fwrite((char *)&c,1,1,out_bmp);

    fread( (char *)&c,1,1,in_pal);
//  c=i;
    fwrite((char *)&c,1,1,out_bmp);

    fread( (char *)&c,1,1,in_pal);
//  c=0;
    fwrite((char *)&c,1,1,out_bmp);

  }


  for (i = 0; i < Height; i++) {
    for (j = 0; j < Width; j++) {
      fscanf(in_mas, "%d", &mas);
      if (mas < 0) mas = 0;
      if (mas > 255) mas = 255;
      c = (unsigned char)mas;
      fwrite (&c, 1, 1, out_bmp);
    }
    c = 0;
    if (bmphead.Width % 4 == 0) continue;
    fwrite(&adobte, 1, 4 - bmphead.Width % 4, out_bmp);
  }
  fclose(in_mas);
  fclose(in_pal);
  fclose(out_bmp);

  return 0;
}
