#ifndef CONST_H
#define CONST_H
         
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>   

//Количество запускаемых Т-функций
#define TFUN_NUM 32
//Количество пластин (должно быть 4)
#define FOUR 4
//Константы
#define POL 0.5
#define A1 1.0 
#define ZERO 0.
//момент инерции вертушки
#define AJ 5.0
//шаг между вихрями на пластине
#define DS 0.1
#define DP 2*DS
#define D0 DS
//число вихрей на 1 пластине
#define NK 5
//число вихрей, сходящих с одной кромки (должно быть 2)
#define NC 2
//радиус вертушки
#define RV 1.0
//радиус цилиндра
#define R (RV-NK*DS)
//число присоединенных вихрей на цилиндре
#define N ((int)(2*M_PI*R/DS+1))
//угол между вихрями
#define DAL (2.*M_PI/N)
//Радиус дискретизации
#define EPS (0.5*D0)
//Выделенное направление в начальный момент времени
#define AL0 (30.*M_PI/180)
//Время счета 
#define TIME (75.)
//шаг по времени
#define DT (DS/(NC-1.0)) 
//Максимальное число шагов
#define IR_MAX (int)((TIME/DT)+10)
//#define IR_MAX 345
//Безразмерный момент инерции
#define J 2.5
//Коэффициент трения оси
#define TR 0
//скорость потока на бесконечности
#define VE 1.0
//Время, до которого скорость потока на бесконечности возрастает 
#define TA sqrt(VE)
//скорость потока
#define VEL(ta) ((ta)<=TA?(VE-(TA-(ta))*(TA-(ta))):VE)
//Коэффициенты размера зоны безопасности
#define DZ 0.7
//#define DZE DZ
//Размеры зоны безопасности
#define E0 (DZ*DS)
//#define E0E (DZ*DS)
//расстояние между вихрями на цилиндре
#define DY (2*M_PI*R/N)
#define HS DY
//Размерность матрицы системы
#define MATR (4*NK+N+1)
//Режим открытия файлов
#define FMODE "w"
//Макросы индексации массивов (должны быть такими)
#define BF(i,j) ((i)*NC+(j))
//#define F(i,j,k) ((i)*NC*IR_MAX+(j)*IR_MAX+k)
//Тоже вариант
#define F(i,j,k) ((k)*NC*FOUR+(i)*NC+(j))
#define K(i,j) ((i)*NK+(j))
#define P(i,j) ((i)*P_MAX+(j))

//Режим отладки
#undef DEBUG
//#define DEBUG
//Дополнительные сообщения
#undef VERB
//#define VERB
//Сохранение результатов в файлах
#undef SAVE
//#define SAVE
//Различные функции speed* и speed*f
#undef SPEEDF
//#define SPEEDF

extern double t1,t2,t3,t4,temp;

#endif
