//Соответствует source4. Продвинутая индексация
/*
	Программа для рассчета двумерного нестационарного 
	отрывного обтекания несжимемой средой вертушки
	(симметричной системы четырех пластин,
	неподвижно закрепленных на круговом цилиндре ортогонально
	к его поверхности) модифицированным методом дискретных
	вихрей с учетом конечной толщины свободных вихревых слоев
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include "consts.h"
#include "gauss.h"
//#include "gelg.h"
#include "utils.h"
#include "move.h"

 double t1=0.,t2=0.,t3=0.,t4=0.,temp;

tfun int main(int argc,char *argv[])
{
 double *xt,*yt;	//контрольные точки на цилиндре
 double *xb,*yb;	//вихри на цилиндре
 double *xtk,*ytk;	//контрольные точки на пластинах
 double *xbk,*ybk;	//вихри на пластинах
 double *xbf,*ybf;	//сходящие вихри
 double *x1,*y1;	//свободные вихри
// double *xn,*yn;	//координаты свободных вихрей при пересчете
 double *al,*alold;	//новые и старые углы
 double al0=AL0,al0old;	//старый и новый углы выделенного направления
 double *ga,*ga1;	//циркуляции вихрей на цилиндре (новые и старые)
 double *gak,*gak1;	//циркуляции вихрей на пластине (новые и старые)
 double q;		//регуляризующий источник
 double *dg;		//циркуляции свободных вихрей
 double *p,*pk;		//перепад давления
 int i,j,k,ki,kj,m,is,ip,ic;	//счетчики
 double aldt=0;		//угловая скорость (=0 в начальный момент времени)
 double ta=0;		//текущее время
 int ir=0;		//номер шага
 double *matr, *gam;	//матрица системы и правая часть
 double *matr1, *gam1;	//матрица системы и правая часть (сохранение)
 double dx,dy;		//отклонения родающихся вихрей от пластины
 double xom,wn;		//временные переменные
 double sum;		//для задания системы
 double amzs;		//сумма моментов аэродинамических сил
 double wx,wy;		//компоненты индуцированной скорости
 double *c,*amz;	//аэродинамические характиристики
 double cx;		//коэффициент сопротивления 
 double cy;		//коэффициент подъемной силы
 double sum31;		//суммарное изменение циркуляции

 //double error=0.,amznew=0.,free=0.;
 
#ifdef SAVE
 int l;			//счетчик
 //double xkfluid,ro2,xbeg,xkfold,dxkf,xksum,dxks,xksold;
 //int NDP=4*(int)(1./DP+0.5),P_MAX=2*NDP+1;
 //int ix,iy,kn,icn,isn;
 
 //double *pv,*dpx,*dpy,*cyrc,*absg;
 //int *npv;
 //double *wxcom,*wycom;
 
 //int nxg,nyg;
 
 FILE *f1,*f2,*f3,*f4,*f5,*f7,/**f8,*/*f9,*f10,*f11,*f12,*f13,*f14,*f15,
 *f16,*f17,*f18,*f19,*f20,*f21,*f22,*f23,*f24,*f25,*f26,*f27,*f28,
 *f29,*f30,*f31,*fp;//files
 
 /* FILE *f32,*f33,*f34,*f35,*f36,*f37,*f38,*f38,*f40,*f41,*f42,*f43,*f44,
 *f45,*f46,*f47,*f48,*f47,*f50,*f51,*f52,*f53,*f54,*f55,*f56,*f57,*f58,
 *f59,*f60,*f61,*f62,*f63,*f64,*f65,*f66,*f67,*f68; */
#endif
//Выделение памяти
xt=(double*)malloc(N*sizeof(double));
yt=(double*)malloc(N*sizeof(double));
xb=(double*)malloc(N*sizeof(double));
yb=(double*)malloc(N*sizeof(double));
ga=(double*)malloc(N*sizeof(double));
ga1=(double*)malloc(N*sizeof(double));
xtk=(double*)malloc(NK*FOUR*sizeof(double));
ytk=(double*)malloc(NK*FOUR*sizeof(double));
xbk=(double*)malloc(NK*FOUR*sizeof(double));
ybk=(double*)malloc(NK*FOUR*sizeof(double));
gak=(double*)malloc(NK*FOUR*sizeof(double));
gak1=(double*)malloc(NK*FOUR*sizeof(double));
xbf=(double*)malloc(NC*FOUR*sizeof(double));
ybf=(double*)malloc(NC*FOUR*sizeof(double));
x1=(double*)malloc(FOUR*IR_MAX*NC*sizeof(double));
y1=(double*)malloc(FOUR*IR_MAX*NC*sizeof(double));
//xn=(double*)malloc(FOUR*IR_MAX*NC*sizeof(double));
//yn=(double*)malloc(FOUR*IR_MAX*NC*sizeof(double));
dg=(double*)malloc(FOUR*IR_MAX*NC*sizeof(double));
al=(double*)malloc(FOUR*sizeof(double));
alold=(double*)malloc(FOUR*sizeof(double));
c=(double*)malloc(FOUR*sizeof(double));
amz=(double*)malloc(FOUR*sizeof(double));
pk=(double*)malloc(FOUR*NK*sizeof(double));
p=(double*)malloc(5*(N+1)*sizeof(double));		//FIXME
matr=(double*)malloc(MATR*MATR*sizeof(double));
gam=(double*)malloc(MATR*sizeof(double));
matr1=(double*)malloc(MATR*MATR*sizeof(double));
gam1=(double*)malloc(MATR*sizeof(double));

if (!xt || !yt || !xb || !yb || !ga || !ga1 || !xtk || !ytk || !xbk || !ybk
 	|| !xbf || !ybf || !c || !amz /*|| !xn || !yn*/ || !p
 	|| !gak || !gak1 || !x1 || !y1 || !dg || !al || !alold
 	|| !pk || !matr || !gam|| !matr1 || !gam1)
 	{
 	 fprintf(stderr,"End of memory\n");
 	 return 1;
	}
#ifdef SAVE
/*
pv=(double*)malloc(P_MAX*P_MAX*sizeof(double));
npv=(int*)malloc(P_MAX*P_MAX*sizeof(int));
cyrc=(double*)malloc(P_MAX*P_MAX*sizeof(double));
dpx=(double*)malloc(P_MAX*P_MAX*sizeof(double));
dpy=(double*)malloc(P_MAX*P_MAX*sizeof(double));
absg=(double*)malloc(P_MAX*P_MAX*sizeof(double));
wxcom=(double*)malloc(FOUR*NC*IR_MAX*sizeof(double));
wxcom=(double*)malloc(FOUR*NC*IR_MAX*sizeof(double));

if ( !pv || !npv || !cyrc || !dpx || !dpy || !absg !wxcom || !wycom)
	{
 	 fprintf(stderr,"End of memory\n");
 	 return 1;
	}
*/

//Открытие файлов

//mkdir("data",0700);
f1=fopen("data/wncy1.dat",FMODE);
f2=fopen("data/xytcy1.dat",FMODE);
f3=fopen("data/xyvcy1.dat",FMODE);
f4=fopen("data/gacy1.dat",FMODE);
f5=fopen("data/freecy1.dat",FMODE);
f7=fopen("data/test.dat",FMODE);

//f8=fopen("data/testbad.dat",FMODE);

f9=fopen("data/c1.dat",FMODE);
f10=fopen("data/c2.dat",FMODE);
f11=fopen("data/c3.dat",FMODE);
f12=fopen("data/c4.dat",FMODE);
f13=fopen("data/mz1.dat",FMODE);
f14=fopen("data/mz2.dat",FMODE);
f15=fopen("data/mz3.dat",FMODE);
f16=fopen("data/mz4.dat",FMODE);
f17=fopen("data/a10.dat",FMODE);
f18=fopen("data/om.dat",FMODE);
f19=fopen("data/alom.dat",FMODE);
f20=fopen("data/mz.dat",FMODE);
f21=fopen("data/freecy11.dat",FMODE);
f22=fopen("data/freecy12.dat",FMODE);
f23=fopen("data/freecy13.dat",FMODE);
f24=fopen("data/freecy14.dat",FMODE);
f25=fopen("data/freecy15.dat",FMODE);
f26=fopen("data/freecy16.dat",FMODE);
f27=fopen("data/freecy17.dat",FMODE);
f28=fopen("data/freecy18.dat",FMODE);
f29=fopen("data/cx.dat",FMODE);
f30=fopen("data/cy.dat",FMODE);
f31=fopen("data/testvort.dat",FMODE);
fp=fopen("fifo",FMODE);

/*
f32=fopen("data/kfluid.dat",FMODE);
f33=fopen("data/kbody.dat",FMODE);
f34=fopen("data/ksum.dat",FMODE);
f35=fopen("data/dksum.dat",FMODE);
f36=fopen("data/mznew.dat",FMODE);
f37=fopen("data/dg.dat",FMODE);
f38=fopen("data/dssum.dat",FMODE);
f39=fopen("data/momsum.dat",FMODE);
f40=fopen("data/error.dat",FMODE);
f41=fopen("data/pv.dat",FMODE);
f42=fopen("data/xyvc.dat",FMODE);
f43=fopen("data/xyvp1.dat",FMODE);
f44=fopen("data/xyvp2.dat",FMODE);
f45=fopen("data/xyvp3.dat",FMODE);
f46=fopen("data/xyvp4.dat",FMODE);
f47=fopen("data/vxy.dat",FMODE);
f48=fopen("data/vabs.dat",FMODE);
f49=fopen("data/xyvcvec.dat",FMODE);
f50=fopen("data/xyvp1vec.dat",FMODE);
f51=fopen("data/xyvp2vec.dat",FMODE);
f52=fopen("data/xyvp3vec.dat",FMODE);
f53=fopen("data/xyvp4vec.dat",FMODE);
f54=fopen("data/xycom.dat",FMODE);
f55=fopen("data/xycomvec.dat",FMODE);
f56=fopen("data/cyrc.dat",FMODE);
f57=fopen("data/p1.dat",FMODE);
f58=fopen("data/p2.dat",FMODE);
f59=fopen("data/p3.dat",FMODE);
f60=fopen("data/p4.dat",FMODE);
f61=fopen("data/p5.dat",FMODE);
f62=fopen("data/gradp.dat",FMODE);
f63=fopen("data/absgradp.dat",FMODE);
f64=fopen("data/pcyl1.dat",FMODE);
f65=fopen("data/pcyl2.dat",FMODE);
f66=fopen("data/sumvc.dat",FMODE);
f67=fopen("data/pstart.dat",FMODE);
f68=fopen("data/pvxy.dat",FMODE);
*/

if ( !f1 || !f2 || !f3 || !f4 || !f5 || !f7 || /*!f8 ||*/ !f9 
|| !f10 || !f11 || !f12 || !f13 || !f14 || !f15 || !f16 || !f17 
|| !f18 || !f19 || !f20 || !f21 || !f22 || !f23 
|| !f24 || !f25 || !f26 || !f27 || !f28 || !f29 || !f30 || !f31 || !fp)
/*
|| !f32 || !f33 || !f34 || !f35 || !f36 || !f37 || !f38 || !f39 ||
|| !f40 || !f41 || !f42 || !f43 || !f44 || !f45 || !f46 || !f47 ||
|| !f48 || !f49 || !f50 || !f51 || !f52 || !f53 || !f54 || !f55 ||
|| !f56 || !f57 || !f58 || !f59 || !f60 || !f61 || !f62 || !f63 ||
|| !f64 || !f65 || !f66 || !f67 || !f68 
*/
 {
  fprintf(stderr,"Ошибка открытия файлов\n");
  return 2;
 }
/* 
fprintf(f56,"Title = noname.vp2\n");
fprintf(f56,"Variables = x, y, p\n");
fprintf(f41,"Title = noname.vp2\n");
fprintf(f41,"Variables = x, y, p\n");
fprintf(f48,"Title = noname.vp2\n");
fprintf(f48,"Variables = x, y, p\n");
fprintf(f63,"Title = noname.vp2\n");
fprintf(f63,"Variables = x, y, p\n");
fprintf(f47,"Title = noname.vp2\n");
fprintf(f47,"Variables = x, y, u, v\n");
fprintf(f62,"Title = noname.vp2\n");
fprintf(f62,"Variables = x, y, p, u, v\n");
fprintf(f68,"Title = noname.vp2\n");
fprintf(f68,"Variables = x, y, p, u, v\n");
*/
#endif
/***************************Инициализация******************/
//Задание начальных углов пластин
 for (i=0;i<FOUR;i++)
 {
  al[i]=AL0+i*(2*M_PI/FOUR);
#ifdef VERB
  printf("Угол %d = %lf\n",i,al[i]);
#endif
 }     
//Задание контрольных точек и вихрей на цилиндре
 for (i=0;i<N;i++)//10
   {
    xt[i]=R*cos(AL0+DAL*(i+1));//FIXME comp
    yt[i]=R*sin(AL0+DAL*(i+1));//FIXME comp
    xb[i]=R*cos(AL0+DAL*(i+POL));
    yb[i]=R*sin(AL0+DAL*(i+POL));
#ifdef VERB
    printf("на цилиндре i=%d xt=%lf yt=%lf xb=%lf yb=%lf\n",
    i,xt[i],yt[i],xb[i],yb[i]);
#endif
   }//10
//Задание контрольных точек и вихрей на пластинах
 for (k=0;k<FOUR;k++)//11
  for (i=0;i<NK;i++)
   {
    xtk[K(k,i)]=(R+(i+POL)*DS)*cos(al[k]);//+ comp
    ytk[K(k,i)]=(R+(i+POL)*DS)*sin(al[k]);//+ comp
    xbk[K(k,i)]=(R+(i+1)*DS)*cos(al[k]);//+1 comp
    ybk[K(k,i)]=(R+(i+1)*DS)*sin(al[k]);//+1 comp
#ifdef VERB
    printf("пластинах k=%d i=%d xtk=%lf, ytk=%lf xbk=%lf ybk=%lf\n",
    k,i,xtk[K(k,i)],ytk[K(k,i)],xbk[K(k,i)],ybk[K(k,i)]);
#endif
   }//11
//Задание положения рождающихся вихрей
 for (k=0;k<FOUR;k++)
  for (i=0;i<NC;i++)//1401
   {            
    xom=0.5*D0-i*D0/(NC-1);
    dx=(-sin(al[k]))*xom;
    xbf[BF(k,i)]=xbk[K(k,NK-1)]+dx;
    dy=cos(al[k])*xom;
    ybf[BF(k,i)]=ybk[K(k,NK-1)]+dy;
   }//1401
//Задание начальных циркуляций
 for (i=0;i<NK*FOUR;i++)
  gak[i]=0;
 for (i=0;i<N;i++)
  ga[i]=0;

/***********Основной цикл********************/
 do//1
 {

  temp=MPI_Wtime();
 
  ta+=DT;
  //сохранение старых циркуляций присоединенных вихрей
  memcpy(gak1,gak,FOUR*NK*sizeof(double));
  memcpy(ga1,ga,N*sizeof(double));

  //задание матрицы системы, полученной из условия непротекания 
  //в контрольных точках
  k=0;
   for (ki=0;ki<FOUR;ki++)//16
    for (i=0;i<NK;i++)//17
    {
     for (kj=0;kj<FOUR;kj++)//18
      for (j=0;j<NK;j++)//19
      {
       if (NK-1==i)
	{
	  sum=0;
	   for (ic=0;ic<NC;ic++)//1701
 	    {
	     speed(xbf[BF(ki,ic)],ybf[BF(ki,ic)],xtk[K(kj,j)],ytk[K(kj,j)],&wx,&wy);
	     sum+=-wx*sin(al[kj])+wy*cos(al[kj]);
	    }
	  matr[k]=sum;
	}
	else
	{
	speed(xbk[K(ki,i)],ybk[K(ki,i)],xtk[K(kj,j)],ytk[K(kj,j)],&wx,&wy);
	matr[k]=-wx*sin(al[kj])+wy*cos(al[kj]);
	}
       k++;
      }//19 18
     for (j=0;j<N;j++)//20
      {
	if (NK-1==i)
	{
	  sum=0;
	    for (ic=0;ic<NC;ic++)//1702
	     {
	      speed(xbf[BF(ki,ic)],ybf[BF(ki,ic)],xt[j],yt[j],&wx,&wy);
	      sum+=wx*xt[j]+wy*yt[j];
	     }//1702
	  matr[k]=sum;
	}
	else
	{
	  speed(xbk[K(ki,i)],ybk[K(ki,i)],xt[j],yt[j],&wx,&wy);
	  matr[k]=wx*xt[j]+wy*yt[j];
	}
       k++;
      }//20

     matr[k]= ((NK-1==i)?NC:1.0);
     k++;
   }//16 17

 for (i=0;i<N;i++)//21
 {
  for (kj=0;kj<FOUR;kj++)//22
   for (j=0;j<NK;j++)//23
   {
   speed(xb[i],yb[i],xtk[K(kj,j)],ytk[K(kj,j)],&wx,&wy);
   matr[k]=-wx*sin(al[kj])+wy*cos(al[kj]);
   k++;
   }//22 23
   for (j=0;j<N;j++)//24
   {
   speed(xb[i],yb[i],xt[j],yt[j],&wx,&wy);
   matr[k]=wx*xt[j]+wy*yt[j];
   k++;
   }//24
   matr[k]=1.;
   k++;
 }//21
   for (kj=0;kj<FOUR;kj++)//25
    for (j=0;j<NK;j++)//26
    {
    matr[k]=0.;
    k++;
    }//25 26
   for (j=0;j<N;j++)//27
   {
    matr[k]=1./(2*M_PI*R);
    k++;
   }//27
   matr[k]=0.;
  //End of matrix initialization;
 //Задание правой части системы
 m=0;
  for (kj=0;kj<FOUR;kj++)//28
   for (j=0;j<NK;j++)//29
   {
    gam[m]=VEL(ta)*sin(al[kj]);
    gam[m]+=aldt*sqrt(xtk[K(kj,j)]*xtk[K(kj,j)]+ytk[K(kj,j)]*ytk[K(kj,j)]);
     for (k=0;k<FOUR;k++)//210
      for (ic=0;ic<NC;ic++)//210
       for (is=0;is<ir;is++)//210
        {
#ifdef SPEEDF
	 speedf(x1[F(k,ic,is)],y1[F(k,ic,is)],
	 	xtk[K(kj,j)],ytk[K(kj,j)],&wx,&wy);
#endif
#ifndef SPEEDF
	 speed(x1[F(k,ic,is)],y1[F(k,ic,is)],
	 	xtk[K(kj,j)],ytk[K(kj,j)],&wx,&wy);
#endif
	 wn=-wx*sin(al[kj])+wy*cos(al[kj]);
	 gam[m]-=wn*dg[F(k,ic,is)];
	}//210
     m++;
    }//28 29
   for (j=0;j<N;j++)//30
   {
    gam[m]=-VEL(ta)*xt[j];
    for (k=0;k<FOUR;k++)//211
     for (ic=0;ic<NC;ic++)
      for (is=0;is<ir;is++)	//FIXME : possible bug in is index
       {
#ifdef SPEEDF
       speedf(x1[F(k,ic,is)],y1[F(k,ic,is)],
       				xt[j],yt[j],&wx,&wy);
#endif
#ifndef SPEEDF
       speed(x1[F(k,ic,is)],y1[F(k,ic,is)],
       				xt[j],yt[j],&wx,&wy);
#endif
       gam[m]-=(wx*xt[j]+wy*yt[j])*dg[F(k,ic,is)];
       }//211
       m++;
    }//30
    //Суммарная циркуляция равна 0
    gam[m]=0;
     for (k=0;k<FOUR;k++)
      for (ic=0;ic<NC;ic++)
       for (is=0;is<ir;is++)//230
       {
        gam[m]-=dg[F(k,ic,is)];
       }//230
//40 лишний
//Решение системы
memcpy(matr1,matr,MATR*MATR*sizeof(double));
memcpy(gam1,gam,MATR*sizeof(double));
#ifdef VERB
printf("Система\n");
 for (i=0;i<MATR*MATR;i++)
  printf("[%d]=%lf  \n",i,matr[i]);
printf("\nПравая часть\n");
 for (i=0;i<MATR;i++)
  printf("[%d]=%lf  \n",i,gam[i]);
#endif
Gauss(matr,gam,MATR);
//gelg(matr,gam,MATR,1);
#ifdef VERB
printf("Решение\n");
 for (i=0;i<MATR;i++)
  printf("[%d]=%lf  \n",i,gam[i]);
printf("Ошибка в решении составила ERR=%le\n",m_err(gam,matr1,gam1,MATR));
#endif

	temp=MPI_Wtime()-temp;
        t1+=temp;
        temp=MPI_Wtime();

//запись найденных значений циркуляций вихрей на пластинах
k=0;
for (ki=0;ki<FOUR;ki++)//48
 for (i=0;i<NK;i++)  //49
 {
  gak[K(ki,i)]=gam[k];
  k++;
 }//48 49
//запись найденных значений циркуляций вихрей на цилиндре
 for (i=0;i<N;i++)//50
 {
  ga[i]=gam[k];
  k++;
 }//50
//запись найденного значения интенсивности регуляризующего источника
 q=gam[k];
//Сдвиг опущен
/*Вставка нового элемента. Запись циркуляций рождающихся на данном шаге по
времени свободных вихрей*/
  for (k=0;k<FOUR;k++)
   for (ic=0;ic<NC;ic++) //1901
   dg[F(k,ic,ir)]=gak[K(k,NK-1)];
   //1901
/*Задание положения рождающихся на данном шаге по времени свободных вихрей*/
  for (k=0;k<FOUR;k++)//2001
   for (ic=0;ic<NC;ic++)
    {
     x1[F(k,ic,ir)]=xbf[BF(k,ic)];
     y1[F(k,ic,ir)]=ybf[BF(k,ic)];
    }//2001
#ifdef SAVE
/*Проверка условия непротекания и условия сохранения суммарной циркуляции*/
 sum=0;
 fprintf(f1,"%d\n",ir);
 fprintf(f4,"%d\n",ir);
  for (kj=0;kj<FOUR;kj++)//58
    for (j=0;j<NK;j++)//59
    {
     ospeed(xtk[K(kj,j)],ytk[K(kj,j)],
      		xb,yb,xbk,ybk,x1,y1,ga,gak,dg,ta,ir,q,
	     &wx,&wy);
     wn=-wx*sin(al[kj])+wy*cos(al[kj]);
     xom=aldt*sqrt(xtk[K(kj,j)]*xtk[K(kj,j)]+ytk[K(kj,j)]*ytk[K(kj,j)]);
     fprintf(f1,"%lf %lf %lf \n",xtk[K(kj,j)],ytk[K(kj,j)],wn-xom);
     fprintf(f4,"%lf %lf %lf \n",xbk[K(kj,j)],ybk[K(kj,j)],gak[K(kj,j)]);
     sum+=(NK-1==j?NC:1)*gak[K(kj,j)];
     }//58 59
  for (k=0;k<N;k++)//60 
   {
    ospeed(xt[k],yt[k],
      		xb,yb,xbk,ybk,x1,y1,ga,gak,dg,ta,ir,q,
      		&wx,&wy);
    wn=wx*xt[k]+wy*yt[k];
    fprintf(f1,"%lf %lf %lf\n",xt[k],yt[k],wn);
    fprintf(f4,"%lf %lf %lf\n",xb[k],yb[k],ga[k]);
    sum+=ga[k];
   }//60
  for (k=0;k<FOUR;k++)
   for (ic=0;ic<NC;ic++)
    for (is=0;is<ir;is++)//61 62
     sum+=dg[F(k,ic,is)];//61 62
  fprintf(f4,"%lf\n",q);
  fprintf(f4,"%lf\n",sum);
/********/
#endif

#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
//вызов подпрограммы вычисления сил и моментов
 aer(ga1,gak1,ga,gak,xb,yb,xtk,ytk,xbk,ybk,x1,y1,q,dg,ir,al,aldt,ta,p,pk,
	 c,amz,&cx,&cy,&sum31);
/* 
	Новый способ вычисления моментов (вынести в отдельную функцию)
{
	double azmc=0.,azmc1=0.,amzp=0.,amzp1=0.,amzf=0.;
        double ro2c,x2cold,y2cold,ro2cold,scold;
        double ro2p,x2pold,y2pold,ro2pold,spold;
        double gat,gat1,ro2f;
        
        for (i=0;i<N;i++) {	//881
 		ro2c=xb[i]*xb[i]+yb[i]*yb[i];
                x2cold=xbold[i]*xbold[i];
                y2cold=ybold[i]*ybold[i];
                ro2cold=x2cold+y2old;
                scold=xbold[i]*wxbold[i]*ybold[i]*wybold[i];
                 //FIXME : Why do we need gat,gat1?
                if (i==N-1) {
                	gat=ga[N-1]+ga[0]/2.;
                        gat1=ga1[n-1]+ga[0]/2.;
                }
                else {
                	gat=ga[i]+ga[i+1]/2.;
                        gat1=ga1[i]+ga[i+1]/2.;
                }
                amzc+=ro2c*ga[i];
                amzc-=ro2cold*ga1[i];
                amzc1+=scold*ga1[i];
                xbold[i]=xb[i];       //FIXME : how to init xbold,ybold?
                ybold[i]=yb[i];
                ospeedf(xbold[i],ybold[i],&wx,&wy);
                wxold[i]=wx;	//FIXME : how to init wxbold,wybold?
                wyold[i]=wy;
                //ospeedf(xbold[i],ybold[i],&wx,&wy); FIXME :again call ospeedf?
                error+=(wx*wx+wy*wy)*ga[i];
   	}//881
        
        for (ki=0;ki<FOUR;ki++)
        for (i=0;i<NK-1;i++)  { //883
        	ro2p=xbk[K(ki,i)]*xbk[K(ki,i)]+ybk[K(ki,i)]*ybk[K(ki,i)]
                x2pold=xbkold[K(ki,i)]*xbkold[K(ki,i)];
                y2pold=ybkold[K(ki,i)]*ybkold[K(ki,i)];
                ro2pold=x2pold+y2pold;
                spold=xbkold[K(ki,i)]*wxbkold[K(ki,i)]+ybkold[K(ki,i)]*
                wybkold[K(ki,i)];
        	amzp+=ro2p*gak[K(ki,i)];
                amzp-=ro2pold*gak1[K(ki,i)];
                amzp1+=spold*gak1[K(ki,i)];
                  //FIXME : all same troubles as upper
                xbkold[K(ki,i)]=xbk[K(ki,i)];
                ybkold[K(ki,i)]=ybk[K(ki,i)];
                ospeedf(xbkold[K(ki,i)],ybkold[K(ki,i)],&wx,&wy);
                wxbkold[K(ki,i)]=wx;
                wybkold[K(ki,i)]=wy;
  		//ospeedf(xbkold[K(ki,i)],ybkold[K(ki,i)],&wx,&wy);
                error+=(wx*wx+wy8wy)*gak[K(ki,i)];
    	}//883
        for (ki=0;ki<FOUR;ki++)
        for (ic=0;ic<NC;ic++) { //885
        	ro2f=x1[F(ki,ic,ir)]*x1[F(ki,ic,ir)]+y1[F(ki,ic,ir)]*
                y1[F(ki,ic,ir)];
                amzf+=ro2f*dg[F(ki,ic,ir)]; 
                //FIXME : last index ir ? or 1 ? or 0 ?
        }//885
        amznew=(amzc+amzp+amzf)/(2*DT);
        amznew-=(amzc1+amzp1);
}
*/
/*Вывод результатов*/
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif

if (ir % 10 == 0) {
	for (ip=0;ip<FOUR;ip++)//373
 		printf("ir=%d ta=%lf c[%d]=%lf al0=%le\n",ir+1,ta,ip,c[ip],al0);
   	//373
        printf("Test : x1[%d,%d,%d] = %lf y1[%d,%d,%d] = %lf\n",0,0,0,
    	x1[F(0,0,0)],0,0,0,y1[F(0,0,0)]);
	printf("\n");
}
#ifdef SAVE
//Запись в файл текущего коэффициента нормальной силы
 fprintf(f9,"%lf %lf\n",ta,c[0]);
 fprintf(f10,"%lf %lf\n",ta,c[1]);
 fprintf(f11,"%lf %lf\n",ta,c[2]);
 fprintf(f12,"%lf %lf\n",ta,c[3]);
//Запись в файл текущего коэффициента азимутального момента 
 fprintf(f13,"%lf %lf\n",ta,amz[0]);
 fprintf(f14,"%lf %lf\n",ta,amz[1]);
 fprintf(f15,"%lf %lf\n",ta,amz[2]);
 fprintf(f16,"%lf %lf\n",ta,amz[3]);
//вычисление и запись в файл текущего суммарного момента 
 amzs=0;
  for (ip=0;ip<FOUR;ip++)
   amzs+=amz[ip];
 fprintf(f20,"%lf %lf\n",ta,amzs);
//fprintf(f36,"%lf %lf\n",ta,amzs); 

//Запись в файл коэффициента сопротивления 
//и коэффициена подъемной силы
 fprintf(f29,"%lf %lf\n",ta,cx);
 fprintf(f30,"%lf %lf\n",ta,cy);
//Запись в файл текущего угла наклона пластины 
 fprintf(f17,"%lf %lf\n",ta,al0*180./M_PI);
//Запись в файл текущей угловой скорости
 fprintf(f18,"%lf %lf\n",ta,aldt*180./M_PI);
//Запись в файл текущего состояния системы в фазовой плоскости
 fprintf(f19,"%lf %lf\n",al0*180./M_PI,aldt*180./M_PI);

/*
//Запись в файл кинетического момента среды
xkfluid=0.;
xbeg=VEl(ta)*ta;
for (i=0;i<N;i++) { //777
	ro2=(xb[i]-xbeg)*(xb[i]-xbeg)+yb[i]*yb[i];
        xkfluid+=ga[i]*ro2;
} //777
for (ki=0;ki<FOUR;ki++)
for (i=0;i<NK-1;i++) { //778
	ro2=(xbk[K(ki,i)]-xbeg)*(xbk[K(ki,i)]-xbeg)+ybk[K(ki,i]*ybk[K(ki,i)];
        xkfluid+=gak[K(ki,i)]*ro2;
} //778
for (i=0;i<ir;i++)
for (ic=0;ic<NC;ic++)
for (k=0;k<FOUR;k++) { //779
	ro2=(x1[F(k,ic,i)]-xbeg)*(x1[F(k,ic,i)]-xbeg)+
        y1[F(k,ic,i)]*y1[F(k,ic,i)];
        xkfluid+=dg[F(k,ic,i)]*ro2;
} //779
xkfluid*=-0.5;
dxkf=(xkfluid-xkfold)/DT;
xkfold=xkfluid;
fprintf(f32,"%lf %lf\n",ta,xkfluid);

//запись в файл кинетического момента вертушки
fprintf(f33,"%lf %lf\n",ta,AJ*aldt);
//запись в файл суммарного кинетического момента
xksum=xkfluid+AJ*aldt;
fprintf(f34,"%lf %lf\n",ta,xksum);
dxks=(xksum-xksold)/DT;
xksold=xksum;
fprintf(f38,"%lf %lf\n",ta,dxks);
fprintf(f39,"%lf %lf\n",ta,xbeg*cy);
//запись в файл производной кинетического момента
fprintf(f36,"%lf %lf\n",ta,dxkf);

//вычисление мгновенного поля давлений,его градиента, плотности завихренности
if (ir==490) {
	for (k=0;k<N;k++) 
        	fprintf(f64,"%lf %lf\n",R*(AL0+DAL*(k+1)),p[4*(N+1)+k]); //567
 	fprintf(f64,"%lf %lf\n",R*(AL0+DAL*(N+1)),p[4*(N+1)+N]);
}
if (ir==570) {
	for (k=0;k<N;k++) 
        	fprintf(f65,"%lf %lf\n",R*(AL0+DAL*(k+1)),p[4*(N+1)+k]); //568
        fprintf(f64,"%lf %lf\n",R*(AL0+DAL*(N+1)),p[4*(N+1)+N]); 
}
if ((ir>=485) && (ir<=575) && (ir %10 == 0)) {
	double xf1,yf1,wxf1,wyf1,xf2,yf2,wxf2,wyf2,xg,yg,wxf21,wyf21;
 	double s1,s2,rof,rog,wxcf,wycf,wxc,wyc,wxt,wyt,xcur,ycur,fi;
 	double wxpf,wypf,wxp1,wyp1,wxp2,wyp2,wxp,wyp;
	double vcx,vcy,vabs,pstart;
        
        for (ix=0;ix<2*NDP+1;ix++)
        for (iy=0;iy<2*NDP+1;iy++) { //550
        	pv[P(ix,iy)]=0.;
                npv[P(ix,iy)]=0;
                cyrc[P(ix,iy)]=0.;	//FIXME : memset?
                dpx[P(ix,iy)]=0.;
                dpy[P(ix,iy)]=0.;
        } //550
        for (k=0;k<FOUR;k++)
        for (ic=0;ic<NC;ic++)
        for (is=0;is<ir;is++) {//547
        	ospeed(x1[F(k,ic,is)],y1[F(k,ic,is)],&wxf2,&wyf2);
                wxcom[F(k,ic,is)]=wxf2;
                wycom[F(k,ic,is)]=wyf2;
        } //547
        for (k=0;k<FOUR;k++)
        for (ic=0;ic<NC;ic++)
        for (is=0;is<ir;is++) {//551
        	xf1=x1[F(k,ic,is)];
                yf1=y1[F(k,ic,is)];
                xg=xf1*cos(ALO)+yf1*sin(AL0);
                yg=-xf1*sin(AL0)+yf1*cos(AL0);
                if ((xg>=-NDP*DP)) && (xg<=NDP*DP))
                if ((yg>=-NDP*DP)) && (yg<=NDP*DP)) {
                	nxg=(int)((xg+NDP*DP)/DP)+1;
                        nyg=(int)((yg+NDP*DP)/DP)+1;
                        ospeed(xf1,yf1,&wxf1,&wyf1);
                        pv[P(nxg,nyg)]-=0.5*(wxf1*wxf1+wyf1*wyf1);
                        for (kn=0;kn<FOUR;kn++)
                        for (icn=0;icn<NC;icn++)
                        for (isn=0;isn<ir;isn++) { //552
                        	if ((kn==k) && (icn==ic) && (isn==is)) continue;
                                
                                xf2=x1[F(kn,icn,isn)];
                                yf2=y1[F(kn,icn,isn)];
                                
                                //commented ospeed(xf2,yf2,&wxf2,&wyf2);
                                wxf2=wxcom[F(kn,icn,isn)];
                                wyf2=wycom[F(kn,icn,isn)];
                                
                                speedf(xf2,yf2,xf1,yf1,&wxf21,&wyf21);
                                pv[P(nxg,nyg)]+=dg[F(kn,icn,isn)]*
                                (wxf2*wxf21+wyf2*wyf21);
                                rof=sqrt(xf1-xf2)*(xf1-xf2)+(yf1-yf2)*(yf1-yf2));
                                if (rof<2.*DS)) {
                                	wxf21=0.;
                                        wyf21=0.;
                                }
                                s1=2*(wxf1-wxf2)*wxf21*wyf21-(wyf1-wyf2)*
                                (wxf21*wxf21-wyf21*wyf21);
                                s2=-2*(wyf1-wyf2)*wxf21*wyf21-(wxf1-wxf2)*
                                (wxf21*wxf21-wyf21*wyf21);
                                s1*=dg[F(kn,icn,isn)];
                                s2*=dg[F(kn,icn,isn)];
                                dpx[P(nxg,nyg)]+=s1;
                                dpy[P(nxg,nyg)]+=s2;
                        } //552
                        for (i=0;i<N;i++) { //553
                        	speed(xb[i],yb[i],xf1,yf1,&wxcf,&wycf);
                                wxc=-vortc[i]*sin(AL0+DAL*(i+POL));
                                wyc=vortc[i]*cos(AL0+DAL*(i+POL));
                                pv[P(nxg,nyg)]+=wxc*wxcf+wyc*wycf;
                                rof=sqrt((xf1-xb[i])*(xf1-xb[i])+
                                (yf1-yb[i])*(yf1-yb[i]);
                                if (rof<2*DS) {
                                	wxcf=0.;
                                        wycf=0.;
                                }
                                wxt=wxf1*ga[i];
                                wyt=wyf1*ga[i];
                                s1=2*(wxt-wxc)*wxcf*wycf-(wyt-wyc)*
                                (wxcf*wxcf-wycf*wycf);
                                s2=-2(wyt-wyc)*wxcf*wycf-(wxt-wxc)*
                                (wxcf*wxcf-wycf*wycf);
                                dpx[P(ngx,ngy)]+=s1;
                                dpy[P(ngx,ngy)]+=s2;
                        } //553
        		for (kn=0;kn<FOUR;kn++)
          		for (i=0;i<NK-1;i++) { //554
                        	speed(xbk[K(kn,i)],ybk[K(kn,i)],xf1,yf1,&wxpf,
                                &wypf);
                                rof=sqrt(xbk[K(kn,i)]*xbk[K(kn,i)]+
                                ybk[K(kn,i)]*ybk[K(kn,i)]);
                                wxp1=vortp[K(kn,i)]*cos(al[kn]);
                                wyp1=vortp[K(kn,i)]*sin(al[kn]);
                                wxp2=-aldt*rof*gak[K(kn,i)]*sin(al[kn]);
                                wyp2=aldt*rof*gak[K(kn,i)]*cos(al[kn]);
                                wxp=wxp1+wxp2;
                                wyp=wyp1+wyp2;
                                pv[P(nxg,nyg)]+=wxp*wxpf+wyp*wypf;
                                rof=sqrt((xf1-xbk[K(kn,i)])*(xf1-xbk[K(kn,i)])+
                                (yf1-ybk[K(kn,i)])*(yf1-ybk[K(kn,i)]);
                                if (rof<2*DS) {
                                	wxpf=0.;
                                        wypf=0.;
                                }
                                wxt=wxf1*gak[K(kn,i)];
                                wyt=wyf1*gak[K(kn,i)];
                                s1=2*(wxt-wxp)*wxpf*wypf-(wyt-wyp)*
                                (wxpf*wxpf-wypf*wypf);
                                s2=-2*(wyt-wyp)*wxpf*wypf-(wxt-wxp)*
                                (wxpf*wxpf-wypf*wypf);
                                dpx[P(nxg,nyg)]+=s1;
                                dpy[P(nxg,nyg)]+=s2;
                        } //554	
                        cyrc[P(nxg,nyg)]+=dg[F(k,ic,is)];
                        npv[P(nxg,nyg)]+=1;
            	}
        }//551
        fprintf(f56,"Zone T = Body, I=168, J=1, F=POINT\n");
        fprintf(f41,"Zone T = Body, I=168, J=1, F=POINT\n");
        fprintf(f48,"Zone T = Body, I=168, J=1, F=POINT\n");
        fprintf(f47,"Zone T = Body, I=168, J=1, F=POINT\n");
        fprintf(f68,"Zone T = Body, I=168, J=1, F=POINT\n");
        fprintf(f62,"Zone T = Body, I=168, J=1, F=POINT\n");
        
        for (k=0;k<FOUR;k++) { //571
        	xbeg=R*cos(al[k]);
                ybeg=R*sin(al[k]);
                fprintf(f56,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f41,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f48,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f47,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
        	fprintf(f68,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
                fprintf(f62,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
        	
                  //FIXME : I use fin instead of beg 
                xbeg=(R+NK*DS)*cos(al[k]);
                ybeg=(R+NK*DS)*sin(al[k]);
                fprintf(f56,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f41,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f48,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f47,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
        	fprintf(f68,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
                fprintf(f62,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
        	
                xbeg=R*cos(al[k]);
                ybeg=R*sin(al[k]);
                fprintf(f56,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f41,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f48,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f47,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
        	fprintf(f68,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
                fprintf(f62,"%lf %lf %lf %lf %lf\n",xbeg,ybeg,0.,0.,0.);
        	
                rof=M_PI/2./N;
                for (i=0;i<=N;i++) { //572 FIXME : <=N ??
                	fi=al[k]+i*rof;
                        xcur=R*cos(fi);
                        ycur=R*sin(fi);
                        fprintf(f56,"%lf %lf %lf\n",xcur,ycur,0.);
                	fprintf(f41,"%lf %lf %lf\n",xcur,ycur,0.);
                	fprintf(f48,"%lf %lf %lf\n",xcur,ycur,0.);
                	fprintf(f47,"%lf %lf %lf %lf\n",xcur,ycur,0.,0.);
        		fprintf(f68,"%lf %lf %lf %lf %lf\n",xcur,ycur,0.,0.,0.);
                	fprintf(f62,"%lf %lf %lf %lf %lf\n",xcur,ycur,0.,0.,0.);
        	} //572
  	} //571
        
        fprintf(f56,"Zone T=Cavern, I=80, J=80, F=Point\n");
        fprintf(f41,"Zone T=Cavern, I=80, J=80, F=Point\n");
        fprintf(f48,"Zone T=Cavern, I=80, J=80, F=Point\n");
        fprintf(f47,"Zone T=Cavern, I=80, J=80, F=Point\n");
        fprintf(f68,"Zone T=Cavern, I=80, J=80, F=Point\n");
        fprintf(f62,"Zone T=Cavern, I=80, J=80, F=Point\n");
        
        for (ix=0;ix<2*NDP;ix++)
        for (iy=0;iy<2*NDP;iy++) { //555
        	xg=(-NDP+ix+0.5)*DP;	//FIXME : +0.5
                yg=(-NDP+iy+0.5)*DP;
                xf1=xg*cos(AL0)-yg*sin(AL0);
                yf1=xg*sin(AL0)+yg*cos(AL0);
                if ((xg>=-NDP*DP)) && (xg<=NDP*DP))
                if ((yg>=-NDP*DP)) && (yg<=NDP*DP)) {
                	nxg=(int)((xg+NDP*DP)/DP)+1;
                        nyg=(int)((yg+NDP*DP)/DP)+1;
                        rog=sqrt(xf18xf1+yf1*yf1);
                        if ((npv[P(nxg,nyg)]==0) && (rog>-1.)) {
                        	ospeed(xf1,yf1,&wxf1,&wyf1);
                                pv[P(nxg,nyg)]-=0.5*(wxf1*wxf1+wyf1*wyf1);
                        	for (kn=0;kn<FOUR;kn++)
                        	for (icn=0;icn<NC;icn++)
                        	for (isn=0;isn<ir;isn++) { //556
                                	xf2=x1[F(kn,icn,isn)];
                                	yf2=y1[F(kn,icn,isn)];
                                
                                	//commented ospeed(xf2,yf2,&wxf2,&wyf2);
                                	wxf2=wxcom[F(kn,icn,isn)];
                                	wyf2=wycom[F(kn,icn,isn)];
                                
                                	speedf(xf2,yf2,xf1,yf1,&wxf21,&wyf21);
                                	pv[P(nxg,nyg)]+=dg[F(kn,icn,isn)]*
                                	(wxf2*wxf21+wyf2*wyf21);
                                	rof=sqrt(xf1-xf2)*(xf1-xf2)+(yf1-yf2)*(yf1-yf2));
                                	if (rof<2.*DS)) {
                                		wxf21=0.;
                                        	wyf21=0.;
                                	}
                                	s1=2*(wxf1-wxf2)*wxf21*wyf21-(wyf1-wyf2)*
                                	(wxf21*wxf21-wyf21*wyf21);
                                	s2=-2*(wyf1-wyf2)*wxf21*wyf21-(wxf1-wxf2)*
                                	(wxf21*wxf21-wyf21*wyf21);
                                	s1*=dg[F(kn,icn,isn)];
                                	s2*=dg[F(kn,icn,isn)];
                                	dpx[P(nxg,nyg)]+=s1;
                                	dpy[P(nxg,nyg)]+=s2;
                         	} //566
                          	for (i=0;i<N;i++) { //557
                        		speed(xb[i],yb[i],xf1,yf1,&wxcf,&wycf);
                                	wxc=-vortc[i]*sin(AL0+DAL*(i+POL));
                                	wyc=vortc[i]*cos(AL0+DAL*(i+POL));
                                	pv[P(nxg,nyg)]+=wxc*wxcf+wyc*wycf;
                                	rof=sqrt((xf1-xb[i])*(xf1-xb[i])+
                                	(yf1-yb[i])*(yf1-yb[i]);
                                	if (rof<2*DS) {
                                		wxcf=0.;
                                        	wycf=0.;
                                	}
                                	wxt=wxf1*ga[i];
                                	wyt=wyf1*ga[i];
                                	s1=2*(wxt-wxc)*wxcf*wycf-(wyt-wyc)*
                                	(wxcf*wxcf-wycf*wycf);
                                	s2=-2(wyt-wyc)*wxcf*wycf-(wxt-wxc)*
                                	(wxcf*wxcf-wycf*wycf);
                                	dpx[P(ngx,ngy)]+=s1;
                                	dpy[P(ngx,ngy)]+=s2;
                        	} //557
                                for (kn=0;kn<FOUR;kn++)
          			for (i=0;i<NK-1;i++) { //558
                        		speed(xbk[K(kn,i)],ybk[K(kn,i)],xf1,yf1,&wxpf,
                                	&wypf);
                                	rof=sqrt(xbk[K(kn,i)]*xbk[K(kn,i)]+
                                	ybk[K(kn,i)]*ybk[K(kn,i)]);
                                	wxp1=vortp[K(kn,i)]*cos(al[kn]);
                                	wyp1=vortp[K(kn,i)]*sin(al[kn]);
                                	wxp2=-aldt*rof*gak[K(kn,i)]*sin(al[kn]);
                                	wyp2=aldt*rof*gak[K(kn,i)]*cos(al[kn]);
                                	wxp=wxp1+wxp2;
                                	wyp=wyp1+wyp2;
                                	pv[P(nxg,nyg)]+=wxp*wxpf+wyp*wypf;
                                	rof=sqrt((xf1-xbk[K(kn,i)])*(xf1-xbk[K(kn,i)])+
                                	(yf1-ybk[K(kn,i)])*(yf1-ybk[K(kn,i)]);
                                	if (rof<2*DS) {
                                		wxpf=0.;
                                        	wypf=0.;
                                	}
                                	wxt=wxf1*gak[K(kn,i)];
                                	wyt=wyf1*gak[K(kn,i)];
                                	s1=2*(wxt-wxp)*wxpf*wypf-(wyt-wyp)*
                                	(wxpf*wxpf-wypf*wypf);
                                	s2=-2*(wyt-wyp)*wxpf*wypf-(wxt-wxp)*
                                	(wxpf*wxpf-wypf*wypf);
                                	dpx[P(nxg,nyg)]+=s1;
                                	dpy[P(nxg,nyg)]+=s2;
                        	} //558
                                npv[P(nxg,nyg)]+=1;
             		}
                        if (rog>=-1.) {
                        	//запись давлений
                                pv[P(nxg,nyg)]/=npv[P(nxg,nyg)];	
        			dpx[P(nxg,nyg)]=dpx[P(nxg,nyg)]/npv[P(nxg,nyg)]*2*M_PI;
                                dpy[P(nxg,nyg)]=dpy[P(nxg,nyg)]/npv[P(nxg,nyg)]*2*M_PI;
 				absg[P(nxg,nyg)]=sqrt(dpx[P(nxg,nyg)]*dpx[P(nxg,nyg)]+
     				dpy[P(nxg,nyg)]*dpy[P(nxg,nyg)]);
                                //запись плотности завихренности
                                fprintf(f56,"%lf %lf %lf\n",xf1,yf1,cyrc[P(nxg,nyg)];
                                //запись поля скоростей
                                ospeed(xf1,yf1,&vcx,&vcy);
                                fprintf(f47,"%lf %lf %lf %lf\n",xf1,yf1,vcx,vcy);
                                //запись модуля скорости
                                vabs=sqrt(vcx8vcx+vcy*vcy);
                                fprintf(f48,"%lf %lf %lf\n",xf1,yf1,vabs);
         		}
                        else {
                        	fprintf(f41,"%lf %lf %lf\n",xf1,yf1,0.);
                                fprintf(f47,"%lf %lf %lf %lf\n",xf1,yf1,0.,0.);
                                fprintf(f48,"%lf %lf %lf\n",xf1,yf1,0.);
                                fprintf(f56,"%lf %lf %lf\n",xf1,yf1,0.);
                        }
           	}
     	} //555
        pstart=0.;
        xf1=-50.;
        yf1=0.;
        ospeed(xf1,yf1,&xf1,&wyf1);
        pstart-=0.5*wxf1*wxf1+wyf1*wyf1;
        for (kn=0;kn<FOUR;kn++)
        for (icn=0;icn<NC;icn++)
        for (isn=0;isn<ir;isn++) { //564
        	xf2=x1[F(kn,icn,isn)];
         	yf2=y1[F(kn,icn,isn)];
                                
         	//commented ospeed(xf2,yf2,&wxf2,&wyf2);
         	wxf2=wxcom[F(kn,icn,isn)];
         	wyf2=wycom[F(kn,icn,isn)];
                                
         	speedf(xf2,yf2,xf1,yf1,&wxf21,&wyf21);
         	pstart+=dg[F(kn,icn,isn)]*(wxf2*wxf21+wyf2*wyf21);
        } //564 
        for (i=0;i<N;i++) { //565
        	speed(xb[i],yb[i],xf1,yf1,&wxcf,&wycf);
         	wxc=-vortc[i]*sin(AL0+DAL*(i+POL));
          	wyc=vortc[i]*cos(AL0+DAL*(i+POL));
           	pstart+=wxc*wxcf+wyc*wycf;
        } //565
        for (kn=0;kn<FOUR;kn++)
        for (i=0;i<NK-1;i++) { //566
        	speed(xbk[K(kn,i)],ybk[K(kn,i)],xf1,yf1,&wxpf,&wypf);
          	rof=sqrt(xbk[K(kn,i)]*xbk[K(kn,i)]+
           	ybk[K(kn,i)]*ybk[K(kn,i)]);
            	wxp1=vortp[K(kn,i)]*cos(al[kn]);
             	wyp1=vortp[K(kn,i)]*sin(al[kn]);
              	wxp2=-aldt*rof*gak[K(kn,i)]*sin(al[kn]);
               	wyp2=aldt*rof*gak[K(kn,i)]*cos(al[kn]);
                wxp=wxp1+wxp2;
                wyp=wyp1+wyp2;
                pstart+=wxp*wxpf+wyp*wypf;
        } //566
        fprintf(f67,"%lf %lf\n",ta,pstart);
        
        for (ix=0;ix<2*NDP;ix++)
        for (iy=0;iy<2*NDP;iy++) { //563
        	xg=(-NDP+ix+0.5)*DP;	//FIXME : +0.5
                yg=(-NDP+iy+0.5)*DP;
                xf1=xg*cos(AL0)-yg*sin(AL0);
                yf1=xg*sin(AL0)+yg*cos(AL0);
                if ((xg>=-NDP*DP)) && (xg<=NDP*DP))
                if ((yg>=-NDP*DP)) && (yg<=NDP*DP)) {
                	nxg=(int)((xg+NDP*DP)/DP)+1;
                        nyg=(int)((yg+NDP*DP)/DP)+1;
                        fprintf(f41,"%lf %lf %lf\n",xf1,yf1,p[P(nxg,nyg)]-pstart);
                        ospeed(xf1,yf1,&vcx,&vcy);
                        fprintf(f68,"%lf %lf %lf %lf %lf\n",xf1,yf1,
                        p[P(,nxg,nyg)]-pstart,vcx,vcy);
                        fprintf(f62,"%lf %lf %lf %lf %lf\n",xf1,yf1,
                        absg[P(,nxg,nyg)],dpx[P(,nxg,nyg)],dpy[P(,nxg,nyg)]);
                }
        } //563
        for (i=0;i<N;i++) { //560
        	fprintf(f42,"%lf %lf %lf\n",xb[i],yb[i],0.); 
                fprintf(f49,"%lf %lf %lf %lf\n",xb[i],yb[i],0.,0.);
        } //560
        fprintf(f42,"%lf %lf %lf\n",xb[0],yb[0],0.);
        fprintf(f49,"%lf %lf %lf %lf\n",xb[0],yb[0],0.,0.);
        for (i=0;i<=NK;i++) { //559 FIXME : <=NK
        	double xtmp,ytmp;
                xtmp=(R+i*DS)*cos(al[0]);
                ytmp=(R+i*DS)*sin(al[0]);
        	fprintf(f43,"%lf %lf %lf\n",xtmp,ytmp,0.);
                fprintf(f50,"%lf %lf %lf %lf\n",xtmp,ytmp,0.,0.);
                xtmp=(R+i*DS)*cos(al[1]);
                ytmp=(R+i*DS)*sin(al[1]);
        	fprintf(f44,"%lf %lf %lf\n",xtmp,ytmp,0.);
                fprintf(f51,"%lf %lf %lf %lf\n",xtmp,ytmp,0.,0.);
                xtmp=(R+i*DS)*cos(al[2]);
                ytmp=(R+i*DS)*sin(al[2]);
        	fprintf(f45,"%lf %lf %lf\n",xtmp,ytmp,0.);
                fprintf(f52,"%lf %lf %lf %lf\n",xtmp,ytmp,0.,0.);
                xtmp=(R+i*DS)*cos(al[3]);
                ytmp=(R+i*DS)*sin(al[3]);
        	fprintf(f46,"%lf %lf %lf\n",xtmp,ytmp,0.);
                fprintf(f53,"%lf %lf %lf %lf\n",xtmp,ytmp,0.,0.);
	} //559
        for (k=1;k<FOUR;k++) { //561
        	xbeg=R*cos(al[k]);
        	ybeg=R*sin(al[k]);
                fprintf(f54,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f55,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
		xbeg=(R+NK*DS)*cos(al[k]);
        	ybeg=(R+NK*DS)*sin(al[k]);
                fprintf(f54,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f55,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
		xbeg=R*cos(al[k]);
        	ybeg=R*sin(al[k]);
                fprintf(f54,"%lf %lf %lf\n",xbeg,ybeg,0.);
                fprintf(f55,"%lf %lf %lf %lf\n",xbeg,ybeg,0.,0.);
		rof=M_PI/2./N;
                for (i=0;i<=N;i++) { //562 FIXME : <=N
                	fi=al[k]+i*rof;
                        xcur=r*cos(fi);
                        ycur=r*sin(fi);
                        fprintf(f54,"%lf %lf %lf\n",xcur,ycur,0.);
                	fprintf(f55,"%lf %lf %lf %lf\n",xcur,ycur,0.,0.);
		} //562
  	} //561
}  //end if
                                
//Запись в файл суммарного изменения циркуляции
 fprintf(f31,"%lf %lf\n",ta,sum31);

/**************/
#endif

//Увеличение текущего угла наклона пластин
 al0old=al0;
 al0+=aldt*DT;
  for (ip=0;ip<FOUR;ip++) //455
   {
   alold[ip]=al[ip];
   al[ip]+=aldt*DT;
   }//455
/*Изменение текущей угловой скорости вертушки под действием азимутального
 момента аэродинамических сил*/
 if (ta<=TA) 
  aldt=0;
  else
  {
  amzs=0;
   for (ip=0;ip<FOUR;ip++)//457
    amzs+=amz[ip];//457
  aldt+=1.0/J*DT*(amzs-TR*J*aldt);  //FIXME : TR*J=AJ ?
  }
//вычисление новых кординат контрольных точек и вихрей на цилиндре
 for (i=0;i<N;i++)//1000
 {
  xt[i]=R*cos(al0+DAL*i);
  yt[i]=R*sin(al0+DAL*i);
  xb[i]=R*cos(al0+DAL*(i+POL));
  yb[i]=R*sin(al0+DAL*(i+POL));
 }//1000
//вычисление новых кординат контрольных точек и вихрей на пластинах
 for (k=0;k<FOUR;k++)
  for (i=0;i<NK;i++)//1111
   {
    xtk[K(k,i)]=(R+(i+POL)*DS)*cos(al[k]);
    ytk[K(k,i)]=(R+(i+POL)*DS)*sin(al[k]);
    xbk[K(k,i)]=(R+(i+1)*DS)*cos(al[k]);
    ybk[K(k,i)]=(R+(i+1)*DS)*sin(al[k]);
   }//1111
//вычисление новых кординат вихрей на кромках 
 for (k=0;k<FOUR;k++)
  for (i=0;i<NC;i++)//1411
   {            
    xom=0.5*D0-i*D0/(NC-1);
    dx=(-sin(al[k]))*xom;
    xbf[BF(k,i)]=xbk[K(k,NK-1)]+dx;
    dy=cos(al[k])*xom;
    ybf[BF(k,i)]=ybk[K(k,NK-1)]+dy;
   }//1411
/*********************/

	//getrusage(RUSAGE_SELF,&usage);
   	//temp=usage.ru_utime.tv_sec*1000000+usage.ru_utime.tv_usec-temp;
        
    	//t2+=temp;
                
     	//getrusage(RUSAGE_SELF,&usage);
      	//temp=usage.ru_utime.tv_sec*1000000+usage.ru_utime.tv_usec;

 move(x1,y1,al,alold,xb,yb,xbk,ybk,ga,gak,dg,q,ir,ta/*,xn,yn*/
#ifdef SAVE
,f7
#endif
	);
        
        //getrusage(RUSAGE_SELF,&usage);
   	//temp=usage.ru_utime.tv_sec*1000000+usage.ru_utime.tv_usec-temp;
        
    	//t3+=temp;
        
//now we copy in fuction move
//FIXME: сколько копировать? (зависит от индексации) - 
//   memcpy(x1,xn,FOUR*IR_MAX*NC*sizeof(double));//510
//   memcpy(y1,yn,FOUR*IR_MAX*NC*sizeof(double));//510
/*********pipe*******
 printf("ready\xD");
*/
#ifdef SAVE
fprintf(fp," %le \n",al[0]);
for (i=0;i<=ir;i++)
 for (k=0;k<FOUR;k++)
  for (ic=0;ic<NC;ic++)
   fprintf(fp," %le %le \n",x1[F(k,ic,i)],y1[F(k,ic,i)]);
   fprintf(fp,"\n");
//fprintf(f40,"%lf %le\n",ta,xksum+0.5*error*DT*DT);
#endif
/*********end pipe*********/

  ir++;
} while (ta<TIME);
#ifdef SAVE
printf("Сохранение результатов\n");
//Сохраниение результатов
for (i=0;i<=ir;i++)
  for (k=0;k<FOUR;k++)
 for (l=0;l<NC;l++)
   fprintf(f5,"%lf %lf\n",x1[F(k,l,i)],y1[F(k,l,i)]);
fprintf(f5,"\n");
//execl("sync",NULL);
for (i=0;i<=ir;i++)
 {
  fprintf(f21,"%lf %lf\n",x1[F(1,1,i)],y1[F(1,1,i)]);
  fprintf(f22,"%lf %lf\n",x1[F(1,2,i)],y1[F(1,2,i)]);
  fprintf(f23,"%lf %lf\n",x1[F(2,1,i)],y1[F(2,1,i)]);
  fprintf(f24,"%lf %lf\n",x1[F(2,2,i)],y1[F(2,2,i)]);
  fprintf(f25,"%lf %lf\n",x1[F(3,1,i)],y1[F(3,1,i)]);
  fprintf(f26,"%lf %lf\n",x1[F(3,2,i)],y1[F(3,2,i)]);
  fprintf(f27,"%lf %lf\n",x1[F(4,1,i)],y1[F(4,1,i)]);
  fprintf(f28,"%lf %lf\n",x1[F(4,2,i)],y1[F(4,2,i)]);
 }
for (kj=0;kj<FOUR;kj++)//580
{
 for (j=0;j<NK;j++)//590
  {
   fprintf(f2,"%lf %lf\n",xtk[K(kj,j)],ytk[K(kj,j)]);
    if (j<NK-1)
     fprintf(f3,"%lf %lf\n",xbk[K(kj,j)],ybk[K(kj,j)]);
  }//590
 for (j=0;j<NC;j++)//591
  fprintf(f3,"%lf %lf \n",xbf[BF(kj,j)],ybf[BF(kj,j)]);//591
}//580
 for (k=0;k<N;k++)//600
  {
   fprintf(f2,"%lf %lf\n",xt[k],yt[k]);
   fprintf(f3,"%lf %lf\n",xb[k],yb[k]);
   //rof=R*(al0+DAL*(k+1));
   //fprintf(f61,"%lf %lf\n",rof,p[4*(N+1)+k]);  
  }//600
/*  
rof=R*(AL0+DAL*(N+1))
fprintf(f61,"%lf %lf\n",rof,p[4*(N+1)+N]);
for (k=0;k<FOUR;k++)
for (is=0;is<ir;is++) { //700
	fprintf(f37,"%lf %lf\n",dg[F(k,0,is)],dg[F(k,1,is)]);
        free+=dg[F(k,0,is)]+dg[F(k,1,is)]);
}
printf("Free = %lf\n",free);
*/
#endif

//Освобождение памяти
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(xt);
::free(yt);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(xb);
::free(yb);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(ga);
//::free(ga1);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(xtk);
::free(ytk);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(xbk);
::free(ybk);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(gak);
::free(gak1);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(x1);
::free(y1);
//::free(xn);
//::free(yn);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(dg);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(al);
::free(alold);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(p);
::free(pk);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(matr);
::free(matr1);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(gam);
::free(gam1);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(xbf);
::free(ybf);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(c);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
::free(amz);
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
#ifdef SAVE
fclose(f1); fclose(f2); fclose(f3); fclose(f4); fclose(f5); fclose(f7); //fclose(f8); 
fclose(f9); fclose(f10); fclose(f11); fclose(f12); fclose(f13); fclose(f14); fclose(f15); 
fclose(f16); fclose(f17); fclose(f18); fclose(f19); fclose(f20); fclose(f21); fclose(f22); 
fclose(f23); fclose(f24); fclose(f25); fclose(f26); fclose(f27); fclose(f28); fclose(f29); 
fclose(f30); fclose(f31);
 fclose(fp);
#endif
#ifdef DEBUG
printf("line=%d\n",__LINE__);
#endif
printf("Hello ir_max %d\n",IR_MAX);
printf("Time results :\nt1 = %lf\nt2 = %lf\nt3 = %lf\n",t1,t2,t3);

return 0;
}//main
