/*Подпрограмма вычисления перепада давлений и коэффициентов нормальной силы C 
и азимутального момента AMZ.*/
void aer(
//input
double *ga1,	//старые циркуляции на цилиндре
double *gak1,	//старые циркуляции на пластинах
double *ga,	//циркуляция вихрей на цилиндре
double *gak,	//циркуляция вихрей на пластины
//double *xt,
//double *yt,	//контрольные точки на цилиндре
double *xb,
double *yb,	//вихри на цилиндре
double *xtk,
double *ytk,	//контрольные точки на пластине
double *xbk,
double *ybk,	//вихри на пластине
double *x1,
double *y1,	//координаты свободных вихрей
double q,
double *dg,	//циркуляции свободных вихрей
int ir,		//текущий шаг
double *al,	//углы пластин
double aldt,	//угловая скорость
double ta,
double *p,
double *pk,	//вектора перепада давления
//output
double * c,
double * amz,
double *cx,	//коэффициент сопротивления 
double *cy,	//коэффициент подъемной силы
double *sum31	//суммарное изменение циркуляции
);

void ospeed(
//input
double xx, double yy,	//координаты точки
double *xb, double *yb, //вихри на цилиндре
double *xbk, double *ybk,	//вихри на пластинах
double *x1, double *y1,	//свободные вихри
double *ga, double *gak, double *dg,	//циркуляции на цилиндре, пластине и свободные
double ta,	//текущее время
int ir,
double q,	//регуляризирующий источник
//output -- компоненты скорости
double *w1, double *w2);

//Скорость, индуцированная вихрем в точке
void speed(
double xb, double yb,	//вихрь
double xt, double yt,	//точка
double *wx, double *wy	//скорость
);

//Скорость без зоны дискретности
void speed2(
double xb, double yb,	//вихрь
double xt, double yt,	//точка
double *wx, double *wy);	//скорость

double m_err(double *ans, double *matr, double *b, int size);
