
                     
                  /*  apgs.cpp  */

#include "cav.h"
#include "timer.h"
#include <math.h>
#include <stdio.h>

extern double kdL(unsigned i, double x);
extern double ekm(double m, double *em);
extern void nrnz(unsigned j, double x,double *nr, double *nz);
extern double *r,*z,*dz,*dr,*s,*ds,*ka,*kb,*kc,*s5,*e0,*e1,*w0,*w1,*w11,*w2;
extern unsigned N,N1,M,MN,MN1,mn1,K;
extern double ag[],x1[], x2[], x3[];
extern double mLn2,ctg,mpi,m2pi;        

                     /* 4 */
                   /* apgr.cpp */

//static Timer tt("args");

void apgr()
{
	//	FILE *out;
	double d1,d,dd;
	unsigned i,k1;
	
//	tt.startT(1);
	i=N;
	do { 
		K=i++;
	} while(z(i) <= 0.0);  
	if(K<N+4) 
		K=N+4;
	k1=K-1; 
        for(i=0; i<MN;i++) {
	       	dr(i)=r(i+1)-r(i); 
		dz(i)=z(i+1)-z(i);
	}
	kc(0)=ctg*dr(0);
	for(i=0;i<N1;i++) {
		ka(i)=kb(i)=0.0;
		kc(i)=ctg*dr(i);
	}
	for(i=N;i<K;i++) {
		d=dz(i)-kc(i);
                dd=1.0+dr(i+1)/dr(i);
	        d1=(z(i+2)-z(i)-dd*kc(i))/(dd*dd);
		ka(i)=(d1-d)/(dd-1.0);
		kb(i)=d-ka(i);
		kc(i+1)=(3.0*ka(i)+2.0*kb(i)+kc(i))*dr(i+1)/dr(i);
	}			
	kc(K)=dz(K)*dr(k1)/(3.0*ka(k1)+2.0*kb(k1)+kc(k1));
	for(i=K;i<mn1;i++) {
	        d=dr(i)-kc(i);
	        dd=1.0+(dz(i+1)/dz(i));	
		d1=(r(i+2)-r(i)-dd*kc(i))/(dd*dd);
                ka(i)=(d1-d)/(dd-1.0);
		kb(i)=d-ka(i);
		kc(i+1)=(3.0*ka(i)+2.0*kb(i)+kc(i))*dz(i+1)/dz(i);
	}
	ka(mn1)=kc(mn1)-2.0*dr(mn1);
	kb(mn1)=3.0*dr(mn1)-2.0*kc(mn1);
        for(i=mn1,s(MN)=0.0; i>0; i--) {
    		ds(i)=kdL(i,1.0); s5(i)=kdL(i,0.5);
        	s(i)=s(i+1)-ds(i);
	}
	ds(0)=kdL(0,1.0);
	s(0)=s(1)-ds(0);
       	s5(0)=kdL(0,0.5);
//	tt.stopT(1);
}

	        /* 5 */
	       /* gaus.cpp */


// ,      
// dr(j), dz(j), ka(j), kb(j), kc(j), s5(i), ds(i), z(MN), r(j), x1[L], x2[L], x3[L], z(j), ds(j), ag[L]
// ,      
// e0(j), e1(j), w2(j), w1(j), w11(j), w0(j)

void gaus(unsigned i, unsigned j, int n, double r0, double z0, double z1)
{
	double nr5,nz5,nrL,nzL,D5e,D5w0,D5w1,D5w11,D5w2,B,B1,B0,D1,D,DL,d2,r02,a,b,rL,zL,rL2,aL,a1L,Lg,a1,ab,a1b,m,m1,km,em,km1,em1,Y,D5e1;
	int L;

//	if (i==0 && j==0 )
//                printf("---------------------all--------------------\n");
	
//	if (i==16 && j==0)
//		printf("%d %d %d %le %le %le\n",i,j,n,r0,z0,z1);

//	tt.startT();
        D5e=D5e1=D5w0=D5w1=D5w11=D5w2=0.0;
	e0(j)=e1(j)=w2(j)=w1(j)=w11(j)=w0(j)=0.0;

	if(j<K) { 
		d2=dr(j)*dr(j); 
		B0=dr(j);
	} else { 
		d2=dz(j)*dz(j); 
		B0=-dz(j);
	}
        r02=r0*r0;
	if(j==i) {
		nrnz(j,0.5,&nr5,&nz5);
		a=0.75*ka(j)+kb(j)+kc(j);
        	D=0.5*sqrt(a*a+d2);
	        D5e=D;
	        D5e1=D*s5(i)/ds(i);
		D5w2=D*nr5/r0;
		D5w1=D5w2*s5(i);
		D5w11=D5w1*s5(i)/(2.0*ds(i));
		D5w0=D5w2*(z(MN)-z0);
	}

//	if (i==0 && j==0 ) 
//              printf("n=%d j=%d e=%lf w0=%lf w1=%lf w11=%lf w2=%lf e1=%lf\n",n,j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));

//	nrnz(j,x1[L],&nrL,&nzL);

	for(L=0; L<n; L++) {
		
//		tt.startT();
//	if (i==0 && j==0 ) 
//                printf("n=%d j=%d e=%lf w0=%lf w1=%lf w11=%lf w2=%lf e1=%lf\n",n,j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));

	
		if(j<K) {
		       rL=r(j)+x1[L]*dr(j);
		       zL=z(j)+ka(j)*x3[L]+kb(j)*x2[L]+kc(j)*x1[L];
		}
		else {
               	       zL=z(j)+x1[L]*dz(j);
		       rL=r(j)+ka(j)*x3[L]+kb(j)*x2[L]+kc(j)*x1[L];
		}
		
//		tt.startT(1);
	

//          	
		nrnz(j,x1[L],&nrL,&nzL);
// ----------------------------------------------------------
	       
//	        if (i==16 && j==0)
//			printf("%lf %lf %lf %lf %lf %lf %lf %lf\n",ka(j),kb(j),kc(j),dr(j),dz(j),x1[L],nrL,nzL);	
//		tt.stopT(1);
		
		a=3.0*ka(j)*x2[L]+2.0*kb(j)*x1[L]+kc(j);
        	D=sqrt(a*a+d2);
	        rL2=rL*rL;
                aL=z0-zL;
    		a1L=z1-zL;
	        a=r02+rL2+aL*aL; 
//		if (i==16 && j==0)
//			printf("%d %le %le %le %le\n",L,a,r02,rL2,aL);
    		a1=r02+rL2+a1L*a1L;
	        b=2.0*r0*rL; 
                ab=sqrt(a+b); 
	 	a1b=sqrt(a1+b);

//		if (i==16 && j==0)
//			printf("%d %le %le\n",L,a,b);

		m=2.0*b/(a+b);  
	   	m1=2.0*b/(a1+b);
	        
//		tt.stopT();
//
//		tt.startT(1);
		
		km=ekm(m,&em); 
	  	km1=ekm(m1,&em1);
		
//		if (i==16 && j==0)
//			printf("%d %le %le\n",L,m,m1);
	
		
//		tt.stopT(1);
//		
//		tt.startT();
		
		km/=ab;
  		km1/=a1b;
      		em/=ab;  
    		em1/=a1b;
	        Lg=log(fabs(x1[L]-0.5));
	        DL=rL*D;
 		e0(j)+=((DL*km+D5e*Lg)-DL*km1)*ag[L];


//		if (i==0 && j==0)
//			printf("%lf %lf %lf %lf %lf %lf\n",DL,km,D5e,Lg,km1,ag[L]);
//		tt.startT();

		b=kdL(j,x1[L]);

//		tt.stopT();

		DL*=b/ds(j);
		e1(j)+=((DL*km+D5e1*Lg)-DL*km1)*ag[L];
		if(j==i) {
			Y=ka(j)*(x2[L]+0.5*x1[L]+0.25)+kb(j)*(x1[L]+0.5)+kc(j);
 		        D1=Y*Y+d2;
			B=2.0*rL*B0*(ka(j)*(2.0*x1[L]+0.5)+kb(j))/(D*D1);
		}
		else 
			B=2.0*rL*(aL*nzL+(r0-rL)*nrL)/(a-b);
  	        B1=2.0*rL*(a1L*nzL+(r0-rL)*nrL)/(a1-b);
 	        Y=(nrL+B)*em-(nrL+B1)*em1+nrL*km1;
	        DL=Y*D;
	        km*=nrL*D;
		w2(j)+=(DL-(km+D5w2*Lg))*ag[L];	  
      		w1(j)+=(DL*b-(km*b+D5w1*Lg))*ag[L];
	        a=b*b/(2.0*ds(j));
		w11(j)+=(DL*a-(km*a+D5w11*Lg))*ag[L];
	  	b=z(MN)-zL;
 	 	w0(j)+=(DL*b-(km*b+D5w0*Lg))*ag[L];
//	     	if (i==16 && j==0 ) 
//			printf("L=%d i=%d j=%d e=%le w0=%le w1=%le w11=%le w2=%le e1=%le\n",L,i,j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));

//		tt.stopT();
		
	}
	
//	if (i==0 && j==0 ) 
//              printf("j=%d e=%lf w0=%lf w1=%lf w11=%lf w2=%lf e1=%lf\n",j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));
//     	if (i==16 && j==0 ) 
//		printf("i=%d j=%d e=%le w0=%le w1=%le w11=%le w2=%le e1=%le\n",i,j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));

	if(j==i) {
		e0(j)+=D5e*mLn2;
		e1(j)+=D5e1*mLn2;
		w0(j)-=D5w0*mLn2;
		w1(j)-=D5w1*mLn2;
   		w11(j)-=D5w11*mLn2;
	        w2(j)-=D5w2*mLn2;
	}
	e0(j)/=mpi;
       	w0(j)/=m2pi;
       	w1(j)/=m2pi;
        w11(j)/=m2pi;
	w2(j)/=m2pi;
       	e1(j)/=mpi;
//	if (i==16 && j==0 ) 
//		printf("i=%d j=%d e=%le w0=%le w1=%le w11=%le w2=%le e1=%le\n",i,j,e0(j),w0(j),w1(j),w11(j),w2(j),e1(j));
	
//	if (i==0 && j==0 )
//                printf("---------------------all--------------------\n");

//	tt.stopT();
//	tt.showData(0);
}


	
  
