
                     
                  /*  apgs1.cpp  */

#include "cav.h"
#include "timer.h"
#include <math.h>
#include <stdio.h>

extern double kdL(unsigned i, double x);
extern double ekm(double m, double *em);
extern void nrnz(unsigned j, double x,double *nr, double *nz);
extern double *r,*z,*dz,*dr,*s,*ds,*ka,*kb,*kc;
extern unsigned N,M,MN,MN1,MN2,mn1,K;
extern double ag[],x1[],x2[],x3[];
extern double mLn2,ctg,mpi,m2pi;        

                     /* 4 */
                   /* apgr1.cpp */

//static Timer tt("args1");

void apgr1()
{
      double d1,d,dd;
      unsigned i,k1;

//      tt.startT(1);
      k1=K-1; 
      for(i=0; i<MN;i++) {
	      dr(i)=r(i+1)-r(i);
	      dz(i)=z(i+1)-z(i);
      }
      kc(0)=ctg*dr(0);                   
      for(i=0;i<K;i++) {
	      d=dz(i)-kc(i);
              dd=1.0+dr(i+1)/dr(i);
	      d1=(z(i+2)-z(i)-dd*kc(i))/(dd*dd);
	      ka(i)=(d1-d)/(dd-1.0);
	      kb(i)=d-ka(i);
	      kc(i+1)=(3.0*ka(i)+2.0*kb(i)+kc(i))*dr(i+1)/dr(i);
      }
      kc(K)=dz(K)*dr(k1)/(3.0*ka(k1)+2.0*kb(k1)+kc(k1));
      for(i=K;i<mn1;i++) {
	      d=dr(i)-kc(i);
	      dd=1.0+(dz(i+1)/dz(i));	
	      d1=(r(i+2)-r(i)-dd*kc(i))/(dd*dd);
              ka(i)=(d1-d)/(dd-1.0);
	      kb(i)=d-ka(i);
	      kc(i+1)=(3.0*ka(i)+2.0*kb(i)+kc(i))*dz(i+1)/dz(i);
      }
      ka(mn1)=kc(mn1)-2.0*dr(mn1);
      kb(mn1)=3.0*dr(mn1)-2.0*kc(mn1);
      for(i=mn1,s(MN)=0.0; i>0; i--) {
    	      ds(i)=kdL(i,1.0);
              s(i)=s(i+1)-ds(i);
      }
      ds(0)=kdL(0,1.0);
      s(0)=s(1)-ds(0);
//      tt.stopT(1);
}
	
  		   /*  5  */
		/*  gaus1.cc  */

void gaus1(unsigned i, unsigned j, int n, double r0, double z0,double z1)
{
	double nr5,nz5,nrL,nzL,D5e,D5w0,D5w1,D5w11,D5w2,B,B1,B0,D1,D,DL,d2,r02,a,b,rL,zL,rL2,aL,a1L,Lg,a1,ab,a1b,m,m1,km,em,km1,em1,Y;	    
	int L;

//	tt.startT();
        D5e=D5w0=D5w1=D5w11=D5w2=0.0;
  	e0(j)=w2(j)=w1(j)=w11(j)=w0(j)=0.0;
	if(j<K) { 
		d2=dr(j)*dr(j); 
		B0=dr(j);
	} else { 
		d2=dz(j)*dz(j); 
		B0=-dz(j);
	}
        r02=r0*r0;
	if(j==i) {
		nrnz(j,0.5,&nr5,&nz5);
		b=kdL(j,0.5);
		a=0.75*ka(j)+kb(j)+kc(j);
	        D=0.5*sqrt(a*a+d2);
		D5e=D*nz5;
	        D5w2=D*nr5/r0;
		D5w1=D5w2*b;
		D5w11=D5w1*b;
		D5w0=D5w2*(z(MN)-z0);
	}
	for(L=0; L<n; L++) {
		if(j<K) {
		       rL=r(j)+x1[L]*dr(j);
		       zL=z(j)+ka(j)*x3[L]+kb(j)*x2[L]+kc(j)*x1[L];
		} else {
               	       zL=z(j)+x1[L]*dz(j);
		       rL=r(j)+ka(j)*x3[L]+kb(j)*x2[L]+kc(j)*x1[L];
		}
	        nrnz(j,x1[L],&nrL,&nzL);
	        a=3.0*ka(j)*x2[L]+2.0*kb(j)*x1[L]+kc(j);
	        D=sqrt(a*a+d2);
	        rL2=rL*rL;
                aL=z0-zL;
    		a1L=z1-zL;
	        a=r02+rL2+aL*aL; 
	    	a1=r02+rL2+a1L*a1L;
	        b=2.0*r0*rL; 
                ab=sqrt(a+b); 
	 	a1b=sqrt(a1+b);
	        m=2.0*b/(a+b);
	 	m1=2.0*b/(a1+b);
	        km=ekm(m,&em); 
	  	km1=ekm(m1,&em1);
	        km/=ab;  
    		km1/=a1b;
		em/=ab;  
    		em1/=a1b;
		Lg=log(fabs(x1[L]-0.5));
		DL=rL*D*nzL;
		e0(j)+=(DL*km+D5e*Lg)-DL*km1;
		if(j==i) {
			Y=ka(j)*(x2[L]+0.5*x1[L]+0.25)+kb(j)*(x1[L]+0.5)+kc(j);
 		        D1=Y*Y+d2;
			B=2.0*rL*B0*(ka(j)*(2.0*x1[L]+0.5)+kb(j))/(D*D1);
		} else 
			B=2.0*rL*(aL*nzL+(r0-rL)*nrL)/(a-b);
	        B1=2.0*rL*(a1L*nzL+(r0-rL)*nrL)/(a1-b);
 	        Y=(nrL+B)*em-(nrL+B1)*em1+nrL*km1;
   	        DL=Y*D;
        	km*=nrL*D;
		w2(j)+=DL-(km+D5w2*Lg);	  
	        b=kdL(j,x1[L]);
                w1(j)+=DL*b-(km*b+D5w1*Lg);
      		w11(j)+=DL*b*b-(km*b*b+D5w11*Lg);
	  	b=z(MN)-zL;
	  	w0(j)+=DL*b-(km*b+D5w0*Lg);
	}
	e0(j)/=n; w0(j)/=n; w1(j)/=n; w11(j)/=n; w2(j)/=n;
	if(j==i) {
		e0(j)+=D5e*mLn2;
		w0(j)-=D5w0*mLn2;
		w1(j)-=D5w1*mLn2;
   		w11(j)-=D5w11*mLn2;
	        w2(j)-=D5w2*mLn2;
	}
	e0(j)/=mpi; 
	w0(j)/=m2pi; 
	w1(j)/=m2pi;
        w11(j)/=m2pi;
	w2(j)/=m2pi;
///	tt.stopT();
}

