
          /* hcv.cpp */ 


#include "cav.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
//#include <mpi.h>

//#include <conio.h>
//#include <iostream.h>
int initialized=0;
int unInitialized=0;

extern double fCx(double sgm);
extern double step(int *iter,double dif,double dmp);
extern double Gf1(double x);
extern double ck(double x);
extern void   nk1();
          
	unsigned M,N,mn1,MN,MN1,MN2,k2,NY,K,im,mn2,N1;
	double *a,*b,*r,*dr,*z,*dz,*s,*ds,*u,*e0,*w0,*w1,*w2,
		      *w11,*ka,*kb,*kc,*e1,*s5,*fn;
	double mLn2,mpi,m2pi,mpi_2,Cx,sn,cn,ctg,dif,dif1,L,um,uma,umi,alf;
	double x2[20],x3[20],ag[20];
        int nL,IT,T; 	 
		 
	double x1[20]={ 0.00343570040745253760693880576434,
                          0.0180140363610431043661669344014,
                          0.0438827858743370470661237793984,
                          0.0804415140888905883027354691492,
                          0.126834046769924603692847464822,
                          0.181973159636742487273581651887,
                          0.244566499024586450997817974522,
                          0.313146955642290219663725911488,
                          0.386107074429177460959751902316,
                          0.461736739433251333122679795301,
                          0.538263260566748666877320204699,
                          0.613892925570822539040248097684,
                          0.686853044357709780336274088512,
                          0.755433500975413549002182025478,
                          0.818026840363257512726418348113,
                          0.873165953230075396307152535178,
                          0.919558485911109411697264530851,
                          0.956117214125662952933876220602,
                          0.981985963638956895633833065599,
                          0.996564299592547462393061194236};

//	int mpiRank=0,mpiSize=1;


void initialize(double* _dmp,int* _ITE)
{
	double dmp,kk;
	int k,ITE,i;
	FILE* in;

	if (initialized==1)
		return ;
	
//	printf("Initializing data at rank %d\n",ts::myRank);
	
	mLn2=log(2.0)+1.0;
	mpi=4.0*atan(1.0);
 	m2pi=2.0*mpi;
  	mpi_2=mpi/2.0;  
	
	in=fopen("nd.dat","r");
	if (!in) {
		printf(" Error: can not open file at rank %d\n",ts::myRank);
		return;
	}
 	fscanf(in,"%lf %lf %lf %lf\n",&alf,&dif,&dif1,&dmp);
 	fscanf(in,"%u %u %d %d %d\n",&N,&M,&IT,&ITE,&nL);
 	fscanf(in,"%lf %d\n",&L,&T);
 	fclose(in);
	for(k=0;k<nL;k++) {
		   x2[k]=x1[k]*x1[k];
		   x3[k]=x1[k]*x2[k];
	}
	for(k=0;k<nL;k++) ag[k]=ag[19-k]=ck(x1[k]);  

	MN=N+M; MN1=MN+1; N1=N+1;
	MN2=MN+2; 
	mn1=MN-1;mn2=MN-2;
	k2=MN2*MN2;

	r=(double *)calloc(MN2,sizeof(double));
 	dr=(double *)calloc(MN2,sizeof(double));
	z=(double *)calloc(MN2,sizeof(double));
	dz=(double *)calloc(MN2,sizeof(double));
	u=(double *)calloc(MN2,sizeof(double));
	s=(double *)calloc(MN2,sizeof(double));
	ds=(double *)calloc(MN2,sizeof(double));
	s5=(double *)calloc(MN2,sizeof(double));
	fn=(double *)calloc(MN2,sizeof(double));
	ka=(double *)calloc(MN2,sizeof(double));
	kb=(double *)calloc(MN2,sizeof(double));
	kc=(double *)calloc(MN2,sizeof(double));
	w0=(double *)calloc(MN2,sizeof(double));
	w1=(double *)calloc(MN2,sizeof(double));
	w2=(double *)calloc(MN2,sizeof(double));
	w11=(double *)calloc(MN2,sizeof(double));
	e0=(double *)calloc(MN2,sizeof(double));
	e1=(double *)calloc(MN2,sizeof(double));
	b=(double *)calloc(MN2,sizeof(double));
	a=(double *)calloc(k2,sizeof(double));

//	printf("INIT\n");
//	om1(a,b,32);
//	printf("INIT\n");
	
	
	kk=mpi*alf/180.0;
	sn=sin(kk); cn=cos(kk); ctg=cn/sn;
	for(i=0;i<N1;i++) fn(i)=-sn; 
        u(0)=0.0;
     	
        nk1();

	initialized=1;
	*_dmp=dmp;
	*_ITE=ITE;

	return ;
}

void unInitialize(void)
{
	if (unInitialized==1)
		return; 

	free((void *) r);  free((void *) dr);free((void *) z); 
	free((void *) dz); free((void *) u); free((void *) fn); 
	free((void *) s);  free((void *) ds);free((void *) ka); 
	free((void *) kb); free((void *) kc);free((void *) b);
	free((void *) e0); free((void *) w1);free((void *) w2);
	free((void *) w11);free((void *) a); free((void *) w0);  
 	free((void *) e1); free((void *) s5);

	unInitialized=1;
}

tfun int main(int argc, char* argv[])
{ 
	double er,Cxm,kk,sgm,sgma,sgmi,dmp;
	int iter,itt,ITE,k;
	unsigned i;
	FILE *in,*out;
       
	int rank,maxRank=ts::realsuperSize;
	struct timeval tv;
	long total_tv_sec=0;
	long total_tv_usec=0;
	long tmp_tv_sec;
	long tmp_tv_usec;
	
	
	// MPI
/*	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&mpiSize);
	MPI_Comm_rank(MPI_COMM_WORLD,&mpiRank);
*/	
/*	mLn2=log(2.0)+1.0;
	mpi=4.0*atan(1.0);
 	m2pi=2.0*mpi;
  	mpi_2=mpi/2.0;  

 	in=fopen("nd.dat","r");
 	fscanf(in,"%lf %lf %lf %lf\n",&alf,&dif,&dif1,&dmp);
 	fscanf(in,"%u %u %d %d %d\n",&N,&M,&IT,&ITE,&nL);
 	fscanf(in,"%lf %d\n",&L,&T);
 	fclose(in); */
  /*******************************************************************************/
/*  		     
  	for(k=0;k<nL;k++) {
		   x2[k]=x1[k]*x1[k];
		   x3[k]=x1[k]*x2[k];
	}
	for(k=0;k<nL;k++) ag[k]=ag[19-k]=ck(x1[k]);  
		 
	MN=N+M; MN1=MN+1; N1=N+1;
	MN2=MN+2; 
	mn1=MN-1;mn2=MN-2;
	k2=MN2*MN2;

	r=(double *)calloc(MN2,sizeof(double));
 	dr=(double *)calloc(MN2,sizeof(double));
	z=(double *)calloc(MN2,sizeof(double));
	dz=(double *)calloc(MN2,sizeof(double));
	u=(double *)calloc(MN2,sizeof(double));
	s=(double *)calloc(MN2,sizeof(double));
	ds=(double *)calloc(MN2,sizeof(double));
	s5=(double *)calloc(MN2,sizeof(double));
	fn=(double *)calloc(MN2,sizeof(double));
	ka=(double *)calloc(MN2,sizeof(double));
	kb=(double *)calloc(MN2,sizeof(double));
	kc=(double *)calloc(MN2,sizeof(double));
	w0=(double *)calloc(MN2,sizeof(double));
	w1=(double *)calloc(MN2,sizeof(double));
	w2=(double *)calloc(MN2,sizeof(double));
	w11=(double *)calloc(MN2,sizeof(double));
	e0=(double *)calloc(MN2,sizeof(double));
	e1=(double *)calloc(MN2,sizeof(double));
	b=(double *)calloc(MN2,sizeof(double));
	a=(double *)calloc(k2,sizeof(double));

	kk=mpi*alf/180.0;
	sn=sin(kk); cn=cos(kk); ctg=cn/sn;
	for(i=0;i<N1;i++) fn(i)=-sn; 
        u(0)=0.0;
       	
        nk1();
  */
	initialize(&dmp,&ITE);

//	printf("%d %d\n",MN2,k2);

//	/*if (mpiRank==0)*/ {
//		out=fopen("nack.dat","w");
//		for(i=0;i<MN1;i++) 
//			fprintf(out,"%d %lf %lf\n",i,r(i),z(i));
 //		fclose(out);
//	}
	
//	b=(double *)calloc(MN2,sizeof(double));
//	a=(double *)calloc(k2,sizeof(double));
//	printf("%d %d alloced\n",MN2,k2);
	
//	om1(a,b,32);
	
	im=0;er=1.0;itt=0;
	while (/*er>dif &&*/ itt<ITE) {
//		if (mpiRank==0)
			printf("Step\n");
		
		gettimeofday(&tv,NULL);
		tmp_tv_sec=tv.tv_sec;
		tmp_tv_usec=tv.tv_usec;
		
		er=step(&iter,dif,dmp);

		gettimeofday(&tv,NULL);
		total_tv_sec+=tv.tv_sec-tmp_tv_sec;
		total_tv_usec+=tv.tv_usec-tmp_tv_usec;

		if (total_tv_usec>1000000) {
			total_tv_sec++;
			total_tv_usec-=1000000;
		}
		if (total_tv_usec<0) {
			total_tv_sec--;
			total_tv_usec+=1000000;
		}
//		printf("dif=%lf dmp=%lf er=%lf\n",dif,dmp,er);
		
		itt+=iter;
/*		if (mpiRank==0) */{
			out=fopen("res.dat","a+");
    			fprintf(out,"%lf %lf %lf %u %d\n",alf,u(N),er,im,itt);
			fclose(out);
		}
	}
	
/*	if (mpiRank==0)*/ {
		printf("After cycle\n");
	        sgm=u(N)*u(N)-1.0;
		Cx=fCx(sgm);
		Cxm=Cx/(r(MN)*r(MN));
	 	kk=Cxm/sgm;

		out=fopen("resk.dat","a+");
		fprintf(out,"%lf %lf %lf %lf %u %d\n",alf,sgm,u(N),er,im,itt);
 		fprintf(out,"%lf %lf %lf %lf %lf\n",kk,Cx,Cxm,r(MN),z(MN));
		for(i=0;i<MN1;i++) fprintf(out,"%u %.12lf %.12lf\n",i,r(i),z(i));
		fclose(out);

		tk();
	
	        for(i=N,um=0.0;i<MN1;i++) um+=u(i);
	        um/=M+1;
		sgmi=umi*umi-1.0;
		sgma=uma*uma-1.0;
		sgm=um*um-1.0;
		Cx=fCx(sgm);  Cxm=Cx/(r(MN)*r(MN)); kk=Cxm/sgm;
	
		out=fopen("restk.dat","a+");
		fprintf(out,"%lf %lf %lf %lf\n",alf,sgm,sgma,sgmi);
	 	fprintf(out,"%lf %lf %lf\n",um,uma,umi);
	  	fprintf(out,"%lf %lf %lf %\n",Cx,Cxm,kk);
		fprintf(out,"%.20lf %.20lf\n",r(MN),z(MN));
	        for(i=0;i<MN1;i++) 
	        	fprintf(out,"%u %.12lf %.12lf %.12lf\n",i,u(i),r(i),z(i));
		fclose(out);
	
		out=fopen("ndt.dat","a+");
		for(i=0;i<MN1;i++) fprintf(out,"%.12lf %.12lf\n",r(i),z(i));
		fclose(out);
	}
/*
	free((void *) r);  free((void *) dr);free((void *) z); 
	free((void *) dz); free((void *) u); free((void *) fn); 
	free((void *) s);  free((void *) ds);free((void *) ka); 
	free((void *) kb); free((void *) kc);free((void *) b);
	free((void *) e0); free((void *) w1);free((void *) w2);
	free((void *) w11);free((void *) a); free((void *) w0);  
 	free((void *) e1); free((void *) s5);
*/
	unInitialize();
	printf("Total time %d sec %d usec\n",total_tv_sec,total_tv_usec);
	//  MPI
//	printf("Mpi finished\n");
//	MPI_Finalize();
	
	return 0;
}
