
			     /*  3  */
			/*  step.cpp  */

#include "timer.h"
#include "cav.h"
#include "tfun_structs.h"
#include <string.h>
#include <stdlib.h>
#include <math.h> 
#include <stdio.h>


extern double kdL(unsigned i, double x);
extern void gaus(unsigned i,unsigned j,int n,double r0,double z0,double z1);	                         
extern void nrnz(unsigned j,double x,double *nr,double *nz); 
extern void apgr();
extern void om(double *a, double *b,unsigned n);

extern double ag[],x1[],x2[],x3[];
extern double *r,*z,*dz,*dr,*ds,*s,*u,*ka,*kb,*kc,*fn,*a,*b,*e0,*w11,*w0,*w1,*w2,*e1,*s5;
 
extern int IT,nL;
extern double mpi,mpi_2;
extern unsigned N,MN,N1,mn1,mn2,K,k2,im,MN1;
extern int initialized;

KTimer tt("step",NULL,1);

tfun int remoteUpdate(UpdateData data)
{
	double a;
	int b;
//	printf("Updating data at node %d\n",ts::myRank);
	
	initialize(&a,&b);
	
	memcpy(ka,&data.ka,MN2*sizeof(double));
	memcpy(kb,&data.kb,MN2*sizeof(double));
	memcpy(kc,&data.kc,MN2*sizeof(double));
	memcpy(r,&data.r,MN2*sizeof(double));
	memcpy(dr,&data.dr,MN2*sizeof(double));
	memcpy(z,&data.z,MN2*sizeof(double));
	memcpy(dz,&data.dz,MN2*sizeof(double));
	memcpy(s5,&data.s5,MN2*sizeof(double));
	memcpy(ds,&data.ds,MN2*sizeof(double));
	memcpy(w0,&data.w0,MN2*sizeof(double));
	memcpy(w1,&data.w1,MN2*sizeof(double));
	memcpy(w2,&data.w2,MN2*sizeof(double));
	memcpy(w11,&data.w11,MN2*sizeof(double));
	memcpy(e0,&data.e0,MN2*sizeof(double));
	memcpy(e1,&data.e1,MN2*sizeof(double));
	memcpy(s,&data.s,MN2*sizeof(double));
	K=data.K;

//	printf("Updating data finished at node %d\n",ts::myRank);

	return 0;

}

void updateData(void)
{
	int rank,maxRank=ts::realsuperSize;
	UpdateData* data=new UpdateData;

	assert(ts::myRank==0);
		
	memcpy(data->ka,ka,MN2*sizeof(double));
	memcpy(data->kb,kb,MN2*sizeof(double));
	memcpy(data->kc,kc,MN2*sizeof(double));
	memcpy(data->r,r,MN2*sizeof(double));
	memcpy(data->dr,dr,MN2*sizeof(double));
	memcpy(data->z,z,MN2*sizeof(double));
	memcpy(data->dz,dz,MN2*sizeof(double));
	memcpy(data->s5,s5,MN2*sizeof(double));
	memcpy(data->ds,ds,MN2*sizeof(double));
	memcpy(data->w0,w0,MN2*sizeof(double));
	memcpy(data->w1,w1,MN2*sizeof(double));
	memcpy(data->w2,w2,MN2*sizeof(double));
	memcpy(data->w11,w11,MN2*sizeof(double));
	memcpy(data->e0,e0,MN2*sizeof(double));
	memcpy(data->e1,e1,MN2*sizeof(double));
	memcpy(data->s,s,MN2*sizeof(double));
	data->K=K;
	
	for (rank=0;rank<maxRank;rank++) {
		tct(atRank(rank));
		(int)remoteUpdate(*data);
	}
	delete data;
}


tfun RetData doAllWork(int _first,int _last)
{
	int i,j,k;
	double r0,z0,z1,d,d1,nr5,nz5,er1;
	RetData* sendToData= new RetData;
	tval RetData tmp;

//	printf("Fun first=%d last=%d rank=%d\n",_first,_last,ts::myRank);
	
	for(i=_first; i<_last; i++){
		d=0.125*ka(i)+0.25*kb(i)+0.5*kc(i);
		if(i<K) {
			r0=r(i)+0.5*dr(i);
			z0=z(i)+d;
		}
		else {
			r0=r(i)+d;
			z0=z(i)+0.5*dz(i);
		}
		z1=2.0*z(MN)-z0;
		for(j=0; j<MN1; j++)  
			a(i,j)=0.0; 
//		tt.startT();
		for(j=0; j<MN; j++)	
			gaus(i,j,nL,r0,z0,z1);
//		tt.stopT();
		for(k=0,b(i)=0.0;k<MN;k++) 
			b(i)+=w0(k);
		for(k=0,d=0.0;k<N1;k++) d+=e0(k);
	        b(i)+=sn*(d-e1(N))+0.5*(z(MN)-z0);
		for(j=N1;j<MN;j++) 	
			a(i,j)=e0(j)-e1(j)+e1(j-1);
                a(i,MN)=e1(mn1);
		for(k=0,d=0.0;k<N;k++) 
			d+=w2(k);
	        for(k=N,d1=0.0;k<MN;k++) 
			d1+=s(k)*w2(k)+w1(k);
		a(i,N)-=s(N)*d+d1;
		for(j=0;j<N;j++) {
		      	a(i,j)-=w1(j)-w11(j);
		        a(i,j+1)-=w11(j);
       		        for(k=j;k<N;k++) {
				 d=0.5*ds(k)*w2(j);
       				 a(i,k)+=d;
		                 a(i,k+1)+=d;
			}
		}                
		if(i<N) {
			d=0.5*s5(i); d1=d*d/ds(i);
		        a(i,i)-=d-d1;
			a(i,i+1)-=d1;
		        a(i,N)-=0.5*s(N);
	        	for(k=i;k<N;k++) {
	   			d1=0.25*ds(k);
	   	        	a(i,k)+=d1;
				a(i,k+1)+=d1;
   			}
		} else 
			a(i,N)-=0.5*(s(i)+s5(i));
		for(j=0;j<MN1;j++) 
			a(i,j)=a(i,j+1);
	}
	
	memcpy(sendToData->b,b+_first,(_last-_first)*sizeof(double));
	memcpy(sendToData->r,r+_first,(_last-_first)*sizeof(double));
	memcpy(sendToData->z,z+_first,(_last-_first)*sizeof(double));
	memcpy(sendToData->dr,dr+_first,(_last-_first)*sizeof(double));
	memcpy(sendToData->dz,dz+_first,(_last-_first)*sizeof(double));
	memcpy(sendToData->a,a+_first*MN1,(_last-_first)*MN1*sizeof(double));
	tmp=*sendToData;
	
	delete sendToData;
	return tmp;
}

double step(int *iter, double dif, double dmp)
{
       	unsigned i,j,k,cn;
        int it;
        double r0,z0,z1,d,d1,nr5,nz5,er1;
	int first,last;
	RetData* sendToData=new RetData;
	tval RetData retData[MPI_SIZE];
	
	it=0;
	do {
//	I	printf("Cycle\n");
		tt.startT();
		apgr(); 
		it++;
//    ,   
//  ,      : ka(), kb(), kc(), r(), dr(), z(), dz(),

		
		updateData();		
		for (cn=0;cn<MPI_SIZE;cn++)
		{
// Really we need atRank?
//			tct(atRank(cn%ts::realsuperSize));
			first=cn*MN;
			first/=MPI_SIZE;
			last=(cn+1)*MN;
			last/=MPI_SIZE;
			retData[cn]=doAllWork(first,last);
		}
		tt.stopT();
//      
//   a,b,z,r,dr		
		for (i=0;i<MPI_SIZE;i++) {
			first=i*MN;
			first/=MPI_SIZE;
			last=(i+1)*MN;
			last/=MPI_SIZE;
			*sendToData=retData[i];
			
			memcpy(b+first,sendToData->b,(last-first)*sizeof(double));
			memcpy(r+first,sendToData->r,(last-first)*sizeof(double));
			memcpy(z+first,sendToData->z,(last-first)*sizeof(double));
			memcpy(dr+first,sendToData->dr,(last-first)*sizeof(double));
			memcpy(dz+first,sendToData->dz,(last-first)*sizeof(double));
			memcpy(a+first*MN1,sendToData->a,(last-first)*MN1*sizeof(double));
		}
		tt.startT();
		{
			om(a,b,MN);
			for(i=0; i<N; i++)    
				u(i+1)=b(i);
			for(i=N; i<MN; i++)  
				fn(i+1)=b(i);
         		for(j=N,er1=0.0; j<MN; j++) {
			  	nrnz(j,0.5,&nr5,&nz5);
			  	d=s5(j)/ds(j);
	                  	w1(j)=fn(j)*(1-d)+fn(j+1)*d+nz5;
        	          	w2(j)=fabs(w1(j));
		          	if(w2(j)>er1)  { er1=w2(j);  im=j; }
         		}
//			printf("%lf\n",er1);
			if(er1<=dif)  {
                	        *iter=it;
			        return er1;
			}    	
	        	for(j=N; j<MN; j++) {  
                        	w2(j)=-dmp*atan(w1(j)/u(N));
          			if(dz(j)<0.0) 
					w2(j)+=mpi-atan(dz(j)/dr(j));
	      			else
		        		if(dz(j)==0.0) 
						w2(j)+=mpi_2;
		      			else 
		        			w2(j)+=atan(dr(j)/dz(j));
		      
	 		}
		       	for(j=N; j<MN; j++) {
              			nr5=sqrt(dr(j)*dr(j)+dz(j)*dz(j));
		        	r(j+1)=r(j)+nr5*sin(w2(j));
	 	        	z(j+1)=z(j)+nr5*cos(w2(j));
				if(r(j+1)<r(j)) {
					r(j+1)=1.00002*r(j); 
					dr(j)=0.00002*r(j);
                        		z(j+1)=z(j)+sqrt(nr5*nr5-dr(j)*dr(j));
				}
   	   		}
		}
		tt.stopT();
	} while(it<IT);
                        /* end operater do  */
	 *iter=it;
	delete sendToData;
	return er1;
}
