#include <stdio.h>
#include <string.h>
#include "timer.h"

struct timeval Timer::tv;
struct timezone Timer::tz;

Timer::Timer(const char* const fn)
{
	for (int i=0;i<TIME_SIZE;i++) 
		data[i].sec=data[i].u_sec=data[i].tmp_sec=data[i].tmp_u_sec=data[i].step_no=0;
	filename=new char[256];
	strcpy(filename,fn);
}
void Timer::setTimer(int counter)
{
	data[counter].sec=data[counter].u_sec=data[counter].tmp_sec=data[counter].tmp_u_sec=data[counter].step_no=0;
}
void Timer::startT(int counter)
{
	gettimeofday(&tv,&tz);
	data[counter].tmp_sec=tv.tv_sec;
	data[counter].tmp_u_sec=tv.tv_usec;
}
void Timer::stopT(int counter)
{
	gettimeofday(&tv,&tz);
	data[counter].sec+=tv.tv_sec-data[counter].tmp_sec;
	data[counter].u_sec+=tv.tv_usec-data[counter].tmp_u_sec;
	
#ifdef DEBUG 
	printf("Local time %d\n",(tv.tv_sec-data[counter].tmp_sec)*1000000+tv.tv_usec-data[counter].tmp_u_sec);
#endif
	data[counter].step_no++;
	if (data[counter].u_sec < 0){
		data[counter].u_sec+=1000000;
		data[counter].sec--;
	}
	if (data[counter].u_sec>1000000) {
		data[counter].u_sec-=1000000;
		data[counter].sec++;
	}
	data[counter].tmp_sec=data[counter].tmp_u_sec=0;
}
void Timer::showData(int counter) const
{
	printf("file=%s nomer=%d Total time: %d sec %d usec step_no=%d\n",filename,counter,data[counter].sec,data[counter].u_sec,data[counter].step_no);
}
void Timer::showAllData() const
{
	for (int i=0;i<TIME_SIZE;i++)
		showData(i);
}

Timer::~Timer()
{
	printf("Finishing\n");
	showAllData();
	delete filename;
}
/*
int main()
{
	Timer time;
	//	printf("%d %d\n",sizeof(Timer),sizeof(HighTimer));
}
*/

