
#ifndef __WWAppTimp___
#define __WWAppTimp___


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

//--------------INIT--------------
template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>::Init(int a,char **b)
    {
	argc=a;
	argv=b;

	SetWorkTime();
    
	return 0;
    };

template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>::SetWorkTime()
    {
	time_start=0.;
	time_end=0.;
	time_step=0.;
	
	return 0;
    };



//--------------Implementation-------------
template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>
	    ::Implement()
    {
	double ta;
	WWWndfldT *wf;
	WWBodyT *body;
	ta=time_start; 
	
	

	wf=new WWWndfldT;
	
	body=new WWBodyT;
	body->Initialize(time_start);

	SavePrepare();

//--------------------the main cycle-------------------
	while(ta<time_end)
	    {
		body->BuildSolveEquation(wf,time_step);
		body->CountFWinds();
		body->Update(ta,time_step);
		body->TransferNewInformation(wf);			
		wf->nprev=wf->n;
		wf->n+=wf->step;

		wf->center.x=wf->s.x;
		wf->center.y=wf->s.y;
		wf->source=wf->s.circ;

		wf->CountFreeWinds(time_step);		

		memcpy(wf->fwnd,wf->fwndnew,wf->n*sizeof(Wind));

		SaveStepResults(body,wf,ta);    

		ta+=time_step;
	    }//while(ta<time_end);
//------------------------------------------------------

		SaveResults(body,wf);
		
		delete body;	
		delete wf;

    return 0;
    };
    
template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>
			::SaveResults(WWBodyT *body,WWWndfldT *wf)
    {
    
	return 0;
    };


template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>::Abort(int errno)
    {
	exit(1);
    	return 0;
    };


template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>::
	SaveStepResults(WWBodyT *body,WWWndfldT *wf,double time)
    {
    return 0;
    };

template <class WWBodyT,class WWWndfldT>
int WWApplicationT<WWBodyT,WWWndfldT>::
	SavePrepare()
    {
    return 0;
    };


#endif
