//the implementation of class Body


#ifndef __WWBodyTimp___
#define __WWBodyTimp___

#include <math.h>
#include <string.h>
#include "windpoint.h"



#include "gauss.h"

//-------------------Initialization of the Body-------------------

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::Initialize(double time)
    {
	UserInit();
    
	CountCenter(time);

	CountWinds();
	CountPoints();
	CountNorms();

        return 0;
    };

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::UserInit()
    {
    	return 0;
    };

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::Update(double time,double ts)
    {

	al+=aldt*ts;
	aldtold=aldt;

	CountCenter(time);
	
	CountWinds();
	CountPoints();
	CountNorms();
        
    	return 0;
    };

//---------------------all other functions

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::CountWinds()
    {
    int i;
    
	switch(__choice_)
	    {
		case 0:			//with no source
		
		    for (i=0;i<__NP_+1;i++)
			{
			    awnd[i].x=0;
			    awnd[i].y=0;
			} 
		
		break;
		
		case 1:			//with a source 
		
		    for (i=0;i<__NP_;i++)
			{
			    awnd[i].x=0;
			    awnd[i].y=0;
			}
			
		break;
		
		default:break;
				        
	    }
    
    return 0;
    };
    
template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::CountPoints()
    {
	int i;
	
	    for (i=0;i<__NP_;i++)
		{
		    cpnt[i].x=0;
		    cpnt[i].y=0;
		}
    
	
	return 0;
    
    };
    
    
template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::CountFWinds()
    {
	int i;
	
	for (i=0;i<__nums_;i++)
	    afwnd[i]=awnd[inds[i]];

    return 0;
    };


template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::CountNorms()
    {
    int i;    
	for (i=0;i<__NP_;i++)
	    {
		norm[i].x=0;
		norm[i].y=0;
	    }
    
    
    return 0;
    };

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,WWWFieldT>::CountCenter(double time)
    {
	center.x=0;
	center.y=0;
	
	centerspeed.x=0;
	centerspeed.y=0;


	return 0;
    };


//-------------------Computation of the Matrix--------------------

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,
WWWFieldT>::BuildSolveEquation(WWWFieldT *wf,double ts)
    {
	int i,j,k,l,flag;	
	double wx,wy;
	double temp;
	double summ,summres;
    
	switch(__choice_)
	    {
		//----------the case with a source 
		case 0:
		    
		    // below is the code for creation of the matrix
		    // the result is in matrix a 
		k=0;
		for (i=0;i<__NP_;i++)
		    {
			for (j=0;j<__NP_;j++)
			{
			    wf->speed2(awnd[i].x,awnd[i].y,
					cpnt[j].x,cpnt[j].y,&wx,&wy);
			
				
		    	    a[k]=norm[j].x*wx+norm[j].y*wy;		    
			    k++;
			}	    
			a[k]=1;  k++;
			a[k]=rho*(center.x*awnd[i].x+center.y*awnd[i].y-
			    (awnd[i].x*awnd[i].x+awnd[i].y*awnd[i].y)/2);
			k++;
			    
		    }

		// for intensity of the source
		    for (j=0;j<__NP_;j++)
			{
			    wf->speedi(center.x,center.y,
					cpnt[j].x,cpnt[j].y,&wx,&wy);
				
			    a[k]=norm[j].x*wx+norm[j].y*wy;
			    k++;    
			}	
		
		    a[k]=0; k++;
		    a[k]=0; k++;
		
		    for (j=0;j<__NP_;j++)
			{
			    a[k]=norm[j].x*(cpnt[j].y-center.y)-
				    norm[j].y*(cpnt[j].x-center.x);
		    
			    k++;
			}
		
		    a[k]=0;k++;
		    a[k]=inertion; 
		//-----------------right side ----------------------
		
		    
		    for (j=0;j<__NP_;j++)
			{	    
			    x[j]=norm[j].x*centerspeed.x+
						norm[j].y*centerspeed.y;
			
			    			
			    for (k=0;k<wf->n;k++)
				{
				    wf->speedf(wf->fwnd[k].x,wf->fwnd[k].y,
					    cpnt[j].x,cpnt[j].y,&wx,&wy);
					
				    x[j]-=wf->fwnd[k].circ*(norm[j].x*wx+
							norm[j].y*wy);
				}
			
			}
			j=__NP_;
			x[j]=0;
			for (k=0;k<wf->n;k++)
				x[j]-=wf->fwnd[k].circ;
			
			j++;
			x[j]=0;
			for (i=0;i<__NP_;i++)
			    {
			    flag=0;
			    
			    for(l=0;l<__nums_;l++)
			    	if (i==inds[l]) flag=1;
			    
			    if (flag==0)
			    	{
			    temp=center.x*awnd[i].x+center.y*awnd[i].y-
				(awnd[i].x*awnd[i].x+awnd[i].y*awnd[i].y)/2+
				ts*(centerspeed.x*(awnd[i].x-center.x)+
				    centerspeed.y*(awnd[i].y-center.y));
			    x[j]+=temp*awnd[i].circ;
			    	}
			    }
			

			summ=0;
			summres=0;

//			for (k=(wf->n)*rank/p;k<(wf->n)*(rank+1)/p;k++)
			wf->getospeedvec(awnd,center,source);
			for (k=0;k<wf->n;k++)

			    {
			    
//			    wf->ospeed(wf->fwnd[k].x,wf->fwnd[k].y,awnd,
//				center,source,&wx,&wy);
			    
			    wf->ospeedvec[k].x=wx;
			    wf->ospeedvec[k].y=wy;
			    
			    summres+=wf->fwnd[k].circ*
				(wx*(wf->fwnd[k].x-center.x)+
				 wy*(wf->fwnd[k].y-center.y))*ts;
			    }
//			    summres=summ;
//		MPI_Allreduce(&summ,&summres,1,MPI_DOUBLE,MPI_SUM,
//						MPI_COMM_WORLD);
			    
//if (rank==0)		printf("\nsum=%5.25lf",summres);

			    x[j]+=summres;
			    
			    x[j]*=rho;
			    x[j]+=inertion*aldtold;
			
//		    printmatrix(a,__NP_+2);
		
		    Gauss(a,x,__NP_+2);
		    
		    
		    for (i=0;i<__NP_;i++) awnd[i].circ=x[i];
		    source=x[__NP_];
		    aldt=x[__NP_+1];		    			
		
			   
		break;
		//----------the case with no source
		case 1:

	    	k=0;
		for (i=0;i<__NP_+1;i++)
		    {
			for (j=0;j<__NP_;j++)
			{
			    wf->speed2(awnd[i].x,awnd[i].y,
					cpnt[j].x,cpnt[j].y,&wx,&wy);
				
		    	    a[k]=norm[j].x*wx+norm[j].y*wy;		    
			    k++;
			}	    
			a[k]=1; k++;
			a[k]=rho*(center.x*awnd[i].x+center.y*awnd[i].y-
			    (awnd[i].x*awnd[i].x+awnd[i].y*awnd[i].y)/2);
			k++;
			    
		    }

		    for (j=0;j<__NP_;j++)
			{
			    a[k]=norm[j].x*(cpnt[j].y-center.y)-
				    norm[j].y*(cpnt[j].x-center.x);
			    k++;
			}
		
		    a[k]=0;k++;
		    a[k]=inertion; 
		//-----------------right side ----------------------
		
		    
		    for (j=0;j<__NP_;j++)
			{	    
			    x[j]=norm[j].x*centerspeed.x+
						norm[j].y*centerspeed.y;
						
			    for (k=0;k<wf->n;k++)
				{
				    wf->speedf(wf->fwnd[k].x,wf->fwnd[k].y,
					    cpnt[j].x,cpnt[j].y,&wx,&wy);
					
				    x[j]-=wf->fwnd[k].circ*(norm[j].x*wx+
							norm[j].y*wy);
				}
			}
			j=__NP_;
			x[j]=0;
			for (k=0;k<wf->n;k++)
				x[j]-=wf->fwnd[k].circ;
			
			j++;
			x[j]=0;
			for (i=0;i<__NP_;i++)
			    {
			        flag=0;
			    
			    for(l=0;l<__nums_;l++)
			    	if (i==inds[l]) flag=1;
			    
			    if (flag==0)
			    	{
			    	temp=center.x*awnd[i].x+center.y*awnd[i].y-
				(awnd[i].x*awnd[i].x+awnd[i].y*awnd[i].y)/2+
				ts*(centerspeed.x*(awnd[i].x-center.x)+
				    centerspeed.y*(awnd[i].y-center.y));
			    x[j]+=temp*awnd[i].circ;
				}
			    }
			
			for (k=0;k<wf->n;k++)
			    {
			    
			    wf->ospeed(wf->fwnd[k].x,wf->fwnd[k].y,awnd,
					center,source,&wx,&wy);
			    
			    x[j]+=wf->fwnd[k].circ*
				(wx*(wf->fwnd[k].x-center.x)+
				 wy*(wf->fwnd[k].y-center.y))*ts;
			    }
			    
			    x[j]*=rho;
			    x[j]+=inertion*aldtold;
			
		    Gauss(a,x,__NP_+2);
		    
		    for (i=0;i<__NP_+1;i++) awnd[i].circ=x[i];
		    aldt=x[__NP_+1];		    			

		break;
		
		default: break;
	    }
        
    return 0;
    };
    

template <int __choice_,int __NP_,int __nums_,class WWWFieldT>
int WWBodyT<__choice_,__NP_,__nums_,
		WWWFieldT>::TransferNewInformation(WWWFieldT *wf)
    {
	memcpy(wf->awnd,awnd,(__NP_+__choice_)*sizeof(Wind));
	memcpy(&(wf->fwnd[wf->n]),afwnd,__nums_*sizeof(Wind));	
    
	wf->s.x=center.x;
	wf->s.y=center.y;
	wf->s.circ=source;


    	return 0;
    };

#endif
