
#ifndef __WWWindfldTimp___
#define __WWWindfldTimp___

#include <math.h>
#include "windpoint.h"
#include "consts.h"

template <int __choice_,int __NP_,int __step_,int __MAX_R_>
WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::WWWindFieldT()
    {
	n=0;
	nprev=0;
	NNP=__NP_+__choice_;
	step=__step_;

    };

template <int __choice_,int __NP_,int __step_,int __MAX_R_>
int WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
	CountFunc(int i,double ts,double vxx,double vyy)
    {
	    int j;

	double tmpx,tmpy;
	double r0,r1;
	double delta=ts;
	int in;
	Vector v0,v1;
	double sumphi,phi=0.;
	double scal,vect;
	double rmin;
	int min;



    //		ospeed(fwnd[i].x,fwnd[i].y,awnd,center,source,&vxx,&vyy);	    
//		vxx=ospeedvec[i].x;
//		vyy=ospeedvec[i].y;

		tmpx=fwnd[i].x+vxx*ts;
		tmpy=fwnd[i].y+vyy*ts;
		
		min=0;
		v0.x=awnd[0].x-tmpx;
		v0.y=awnd[0].y-tmpy;
		rmin=sqrt(v0.x*v0.x+v0.y*v0.y);
		
			
		j=0; sumphi=0; in=0;
		while (j<__NP_+__choice_)
		    {
			v0.x=awnd[j].x-tmpx;
			v0.y=awnd[j].y-tmpy;
			
			v1.x=awnd[(j+1)%(__NP_+__choice_)].x-tmpx;
			v1.y=awnd[(j+1)%(__NP_+__choice_)].y-tmpy;
			
			scal=v0.x*v1.x+v0.y*v1.y;
			vect=v0.x*v1.y-v1.x*v0.y;
		
			r0=sqrt(v0.x*v0.x+v0.y*v0.y);
			r1=sqrt(v1.x*v1.x+v1.y*v1.y);
			
			if ((scal>=0)&&(vect<=0)) 
				phi=-asin(fabs(vect)/(r0*r1));
				
			if ((scal<0)&&(vect<=0))
				phi=-M_PI+asin(fabs(vect)/(r0*r1));
		    
			if ((scal>=0)&&(vect>0))
				phi=asin(fabs(vect)/(r0*r1));
		    
			if ((scal<0)&&(vect>0))
				phi=M_PI-asin(fabs(vect)/(r0*r1));
		    
			sumphi+=phi;
			
		    	if (fabs(fabs(phi)-M_PI)<M_PI/30) in=1;
			
			if (r0<delta) in=1;
		    
			if (r0<rmin)
			    {
				rmin=r0;
				min=j;
			    }
			
			j++;    
		    }
		
		    if (fabs(sumphi)>M_PI) in=1;
		    
		    if (in==1) 
			{
			    v0.x=awnd[min].x-center.x;
			    v0.y=awnd[min].y-center.y;
			    
			    r0=sqrt(v0.x*v0.x+v0.y*v0.y);
			
			    tmpx=v0.x/r0*(r0+2*delta)+center.x;
			    tmpy=v0.y/r0*(r0+2*delta)+center.y;
			
			}
		
		
		fwndnew[i].x=tmpx;
		fwndnew[i].y=tmpy;
		fwndnew[i].circ=fwnd[i].circ;

    
    
    
    
	return 0;
    };
    



//#define DELTA	0.1

template <int __choice_,int __NP_,int __step_,int __MAX_R_>
int WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
	CountFreeWinds(double ts)
    {
	int i;
	double vxx,vyy;

	for (i=0;i<n;i++)
//	if ((i>=nprev*rank/p) && (i<nprev*(rank+1)/p))
	    {
		vxx=ospeedvec[i].x;
		vyy=ospeedvec[i].y;
		
		CountFunc(i,ts,vxx,vyy);
	    }

//	if (rank==(p-1))
	    for (i=nprev;i<n;i++)
		{
		ospeed(fwnd[i].x,fwnd[i].y,awnd,center,source,&vxx,&vyy);	    
    
		CountFunc(i,ts,vxx,vyy);
		}


	return 0;
    };
    
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
ospeed(double xx,double yy,
    Wind *awnd,Point center,double source,double *wxx,double *wyy)
    {
	int i;
	double vxx,vyy;
	*wxx=0;
	*wyy=0;
	
	switch(__choice_)
	    {
	    
		case 0: // with a source
		
		for (i=0;i<__NP_;i++)
		    {
			speed(awnd[i].x,awnd[i].y,xx,yy,&vxx,&vyy);
			
			*wxx+=awnd[i].circ*vxx;
			*wyy+=awnd[i].circ*vyy;		
		    }
		
		speedi(center.x,center.y,xx,yy,&vxx,&vyy);
		
		*wxx+=source*vxx;
		*wyy+=source*vyy;
		
		break;

		case 1:	//with no source
		
		for (i=0;i<__NP_+1;i++)
		    {
			speed(awnd[i].x,awnd[i].y,xx,yy,&vxx,&vyy);
			
			*wxx+=awnd[i].circ*vxx;
			*wyy+=awnd[i].circ*vyy;		
		    }
		break;
	    default:break;	
	}

	    for (i=0;i<n;i++)
		{
		    speedf(fwnd[i].x,fwnd[i].y,xx,yy,&vxx,&vyy);
		    
		    *wxx+=fwnd[i].circ*vxx;
		    *wyy+=fwnd[i].circ*vyy;
		}

	return;
    };


//------------------------------------------------------------------    
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
speed(double xv,double yv,
			double xt,double yt,double *vx,double *vy)
    {
	double r;
	double xm,ym;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	if (r>EPS*EPS)
	    {
		speed2(xv,yv,xt,yt,vx,vy);	    
	    }		
	else
	if (r>0.01*0.01)
	    {
		r=sqrt(r);
	    
		xm=xv+EPS/r*(xt-xv);
		ym=yv+EPS/r*(yt-yv);

		speed2(xv,yv,xm,ym,vx,vy);
	
		(*vx)*=r/EPS;
		(*vy)*=r/EPS;		
	    }
	else
	    {
		(*vx)=0.;
		(*vy)=0.;
	    }
	
	return;
    };
    
//--------------------------------------------------------------------
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
speed2(const double xv,const double yv,
			const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=-(yt-yv)/r/2./M_PI;
	*vy=(xt-xv)/r/2./M_PI;		

	return;
    };

template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
speedi(const double xv,const double yv,
			const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=(xt-xv)/r/2./M_PI;
	*vy=(yt-yv)/r/2./M_PI;		

	return;
    };

//---------------------------------------------------------------------
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
speedf(double xv,double yv,
		double xt,double yt,double *vx,double *vy)
    {
	
	double r;
	double xm,ym;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	if (r>EPS*EPS)
	    {
		speed2(xv,yv,xt,yt,vx,vy);	    
	    }		
	else
	if (r>0.01*0.01)
	    {
		r=sqrt(r);
	    
		xm=xv+EPS/r*(xt-xv);
		ym=yv+EPS/r*(yt-yv);

		speed2(xv,yv,xm,ym,vx,vy);
	
		(*vx)*=r/EPS;
		(*vy)*=r/EPS;		
	    }
	else
	    {
		(*vx)=0.;
		(*vy)=0.;
	    }
	return;
    };

//----------------------------------------------------------------------
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
speed2f(const double xv,const double yv,
		const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=-(yt-yv)/r/2./M_PI;
	*vy=(xt-xv)/r/2./M_PI;		

	return;
    };
    

#endif
