#include "consts.h"
#include <math.h>

/*
typedef WWWindFieldT<SOURCE,NP,NUMS,MAX_R> WindField;
template <int __choice_,int __NP_,int __step_,int __MAX_R_>
void WWWindFieldT<__choice_,__NP_,__step_,__MAX_R_>::
*/
inline	    void ospeed(double xx,double yy,Wind *awnd,Point center,
	    double source,double *wxx,double *wyy,Wind*,int);
			
	     void speedf(double,double,double,double,double*,double*);
	     void speed(double,double,double,double,double*,double*);
	     void speed2f(double,double,double,double,double*,double*);
	     void speed2(double,double,double,double,double*,double*);
	     void speedi(double,double,double,double,double*,double*);


inline void ospeed(double xx,double yy,
    Wind *awnd,Point center,double source,double *wxx,double *wyy,Wind*fwnd,int n)
    {
	int i;
	double vxx,vyy;
	*wxx=0;
	*wyy=0;
	
	switch(SOURCE)
	    {
	    
		case 0: // with a source
		
		for (i=0;i<NP;i++)
		    {
			speed(awnd[i].x,awnd[i].y,xx,yy,&vxx,&vyy);
			
			*wxx+=awnd[i].circ*vxx;
			*wyy+=awnd[i].circ*vyy;		
		    }
		
		speedi(center.x,center.y,xx,yy,&vxx,&vyy);
		
		*wxx+=source*vxx;
		*wyy+=source*vyy;
		
		break;

		case 1:	//with no source
		
		for (i=0;i<NP+1;i++)
		    {
			speed(awnd[i].x,awnd[i].y,xx,yy,&vxx,&vyy);
			
			*wxx+=awnd[i].circ*vxx;
			*wyy+=awnd[i].circ*vyy;		
		    }
		break;
	    default:break;	
	}

	    for (i=0;i<n;i++)
		{
		    speedf(fwnd[i].x,fwnd[i].y,xx,yy,&vxx,&vyy);
		    
		    *wxx+=fwnd[i].circ*vxx;
		    *wyy+=fwnd[i].circ*vyy;
		}

	return;
    };


//------------------------------------------------------------------    
void speed(double xv,double yv,
			double xt,double yt,double *vx,double *vy)
    {
	double r;
	double xm,ym;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	if (r>EPS*EPS)
	    {
		speed2(xv,yv,xt,yt,vx,vy);	    
	    }		
	else
	if (r>0.01*0.01)
	    {
		r=sqrt(r);
	    
		xm=xv+EPS/r*(xt-xv);
		ym=yv+EPS/r*(yt-yv);

		speed2(xv,yv,xm,ym,vx,vy);
	
		(*vx)*=r/EPS;
		(*vy)*=r/EPS;		
	    }
	else
	    {
		(*vx)=0.;
		(*vy)=0.;
	    }
	
	return;
    };
    
//--------------------------------------------------------------------
void speed2(const double xv,const double yv,
			const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=-(yt-yv)/r/2./M_PI;
	*vy=(xt-xv)/r/2./M_PI;		

	return;
    };

void speedi(const double xv,const double yv,
			const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=(xt-xv)/r/2./M_PI;
	*vy=(yt-yv)/r/2./M_PI;		

	return;
    };

//---------------------------------------------------------------------
void speedf(double xv,double yv,
		double xt,double yt,double *vx,double *vy)
    {
	
	double r;
	double xm,ym;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	if (r>EPS*EPS)
	    {
		speed2(xv,yv,xt,yt,vx,vy);	    
	    }		
	else
	if (r>0.01*0.01)
	    {
		r=sqrt(r);
	    
		xm=xv+EPS/r*(xt-xv);
		ym=yv+EPS/r*(yt-yv);

		speed2(xv,yv,xm,ym,vx,vy);
	
		(*vx)*=r/EPS;
		(*vy)*=r/EPS;		
	    }
	else
	    {
		(*vx)=0.;
		(*vy)=0.;
	    }
	return;
    };

//----------------------------------------------------------------------
void speed2f(const double xv,const double yv,
		const double xt,const double yt,double *vx,double *vy)
    {
	double r;
	
	r=(xv-xt)*(xv-xt)+(yv-yt)*(yv-yt);
	
	*vx=-(yt-yv)/r/2./M_PI;
	*vy=(xt-xv)/r/2./M_PI;		

	return;
    };
    


tfun short t_getfield(int rank,int n,tval short fwnd_,tval short awnd_,Point center,double source)
{
#define S1 MAX((NP+SOURCE)*sizeof(Wind),n*sizeof(Wind))
	tct(extraSize(S1));
	tval short res_=0;
	Vector* res=(Vector*)&(short&)res_;
	Wind* awnd=(Wind*)&(short&)awnd_;
	Wind* fwnd=(Wind*)&(short&)fwnd_;
	int i;
	int start=rank*n/R, stop=(rank+1)*n/R;

	for (i=start;i<stop;i++)
	ospeed(fwnd[i].x,fwnd[i].y,awnd,center,source,&(res[i].x),&(res[i].y),fwnd,n);

	return res_;
}

