#include <tc.h>

#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
//#include <math.h>

#include "rc.h"

int globalnframe = 0;
myframes *globalptr;

tfun void calculate_data(myframes *fr, tout int *_res) {
  int nframe;
  float prevplaatje = 0.0;
  float plaat;
  float speed = 0;
  float prevspeed = speed;


  for(nframe = 0; nframe < NFRAMES; nframe++) {

    fr->ptr[nframe] = (myframe *)talloc(sizeof(myframe)); 

    speed = calc_speed(prevspeed, prevplaatje, nframe);
    plaat = calc_plaatje(prevspeed, prevplaatje);
    
    fr->ptr[nframe]->angle2 = nframe*4*PI/503;
    fr->ptr[nframe]->angle3 = nframe*6*PI/503;

    fr->ptr[nframe]->speed = prevspeed = speed;

    fr->ptr[nframe]->plaatje = prevplaatje = plaat;
  }
  *_res = nframe;
}

tfun void calc_frames(myframes *fr, tout int *_res) {
  int nframe;
  
  float speed = 0;

  for(nframe = 0; nframe < NFRAMES; nframe++) {
    calc_frame(nframe, fr->ptr[nframe]);
  }
  printf("%d frames computed succesfully\n", nframe);

  *_res = nframe;
}

void display(void)
{  
  if(globalnframe < NFRAMES) {//return;

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    /* new                            */
    glDrawPixels(WIN_SIZE, WIN_SIZE, GL_RGBA, GL_INT, globalptr->ptr[globalnframe]->data);
    /* end of new                     */
    glutSwapBuffers();
    printf("display %d frame.\n", globalnframe);
  }
}


void Animate(void)
{
  if(globalnframe < NFRAMES)
    printf("Animate %d frame.\n", globalnframe);

    glutPostRedisplay();
    globalnframe++;
}

//void tfun init_data(int _sz, tout int *_res) {
void tfun init_data(tout int *_res) {
  //myinit_data(_sz);
  myinit_data();

  *_res = 1;
}

void tfun main_loop(myframes *fr, tout int *_res) {
  globalptr = fr;
  glutMainLoop();

  *_res = 1;
}


int tmain(int argc, char *argv[])
{
  //int sz;
    int nframe;

    tval int res0, res;

    myframes *fr = (myframes *)talloc(sizeof(*fr));
    /*
    if (argc > 1)
	sz = atoi(argv[1]);
    else
	sz = 200;
    
    if(sz > WIN_SIZE)
      sz = WIN_SIZE;
    */
    //TCALL((init_data(sz, &res0)),(0));
    TCALL((init_data(&res0)),(0));
    (volatile int)res0; // wait for init completion

    TCALL((calculate_data(fr, &res)),(0));
    (volatile int)res;

    TCALL((calc_frames(fr, &res)),(0));
    (volatile int)res;

    TCALL((main_loop(fr, &res)),(0));
    (volatile int)res;

    return 0;             /* ANSI C requires main to return int. */
}
