#include <tc.h>

#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
//#include <math.h>

#include "rc.h"

int globalnframe = 0;
myframes *globalptr;

tfun void calculate_data(tout myframes *res) {
  int nframe;
  float prevplaatje = 0.0;
  float plaat;
  float speed = 0;
  float prevspeed = speed;


  for(nframe = 0; nframe < NFRAMES; nframe++) {

    res->ptr[nframe] = (myframe *)talloc(sizeof(myframe)); 

    speed = calc_speed(prevspeed, prevplaatje, nframe);
    plaat = calc_plaatje(prevspeed, prevplaatje);
    
    res->ptr[nframe]->angle2 = nframe*4*PI/503;
    res->ptr[nframe]->angle3 = nframe*6*PI/503;

    res->ptr[nframe]->speed = prevspeed = speed;

    res->ptr[nframe]->plaatje = prevplaatje = plaat;
  }  
}

tfun void calc_frames(tout myframes *res) {
  int nframe;
  
  float speed = 0;

  for(nframe = 0; nframe < NFRAMES; nframe++) {
    calc_frame(nframe, res->ptr[nframe]);
  }
  printf("%d frames computed succesfully\n", nframe);
}

void display(void)
{  
  if(globalnframe >= NFRAMES) return;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  /* new                            */
  glDrawPixels(WIN_SIZE, WIN_SIZE, GL_RGBA, GL_INT, globalptr->ptr[globalnframe]->data);
  /* end of new                     */
  glutSwapBuffers();
}


void Animate(void)
{
    if(globalnframe >= NFRAMES)
      return;

    printf("Animate %d frame.\n", globalnframe);

    glutPostRedisplay();
    globalnframe++;
}


tfun void init_data(int sz, tout int *_res) {
    myinit_data(sz);

    *_res = 1;
}

int tmain(int argc, char *argv[])
{
    int sz;
    int nframe;

    tval int res0;

    //tval myframes *res = (myframes *)talloc(sizeof(*res));
    tval myframes res;

    if (argc > 1)
	sz = atoi(argv[1]);
    else
	sz = 200;
    
    if(sz > WIN_SIZE)
      sz = WIN_SIZE;

    TCALL((init_data(sz, &res0)),(0));
    (volatile int)res0; // wait for init completion

    TCALL((calculate_data(&res)),(0));
    (volatile myframes)res;

    TCALL((calc_frames(&res)),(0));
    (volatile myframes)res;
    
    globalptr = (myframes *)talloc(sizeof(*globalptr));
    for(nframe = 0; nframe < NFRAMES; nframe++) {
      globalptr->ptr[nframe] = res.ptr[nframe];
    }
 
    glutMainLoop();

    return 0;             /* ANSI C requires main to return int. */
}
