#ifndef _OUTPUT_H_
#define _OUTPUT_H_

#ifdef __cplusplus
extern "C" {
#endif

struct pixel {
	//double r, g, b;
	char r,g,b;
};

enum out_type {
	out_type_tga,
	out_type_sock,
};

struct rect {
	int left;
	int top;
	int width;
	int height;
};

struct out_handler;

struct out_descr {
	int fd;
	enum out_type type;
	int width;
	int height;
	int frames;
	int frame;
	const struct out_handler *handler; 
	const char *name;
};

int out_open (struct out_descr*, const char *name, enum out_type type, int width, int height, int frames);
int out_fragment (struct out_descr *desc, struct rect, const struct pixel *);
int out_next (struct out_descr *desc);
int out_close (struct out_descr *desc);

#ifdef __cplusplus
};
#endif

#endif
