#include "output.h"
#include "rt.h"

#define MAX_JOB_SIZE 256

static struct params loc_params;

int fragment (struct rect r, struct pixel *pxl)
{
	int x, y;
	
	for (y = 0; y < r.height; y++) {
		for (x = 0; x < r.width; x++) {
			struct pixel p;
			int yr;
			p = render (r.left+x, r.top+y, &loc_params);
			/*
			yr = (int)(0.3*p.r + 0.59*p.g + 0.11*p.b);
			p.r = p.g = p.b = yr;
			switch (ts::myRank) {
			case 0: p.r = 128; break;
			case 1: p.b = 128; break;
			case 2: p.r = p.g = 128; break;
			case 3: p.r = p.b = 128; break;
			default: p.g = 128;
			}
			*/
			*(pxl++) = p;
		}
	}
	return 1;
}

struct out_data {
	struct rect rect;
	struct pixel px[MAX_JOB_SIZE];
};

struct tree {
	struct rect r;
	int node;
	tptr struct tree left;
	tptr struct tree right;
	tptr struct out_data od;
};

tfun struct out_data do_out (struct rect r, int ppp)
{
	struct out_data od;
			
	od.rect = r;
	fragment(r, od.px);
/*
	if (ppp != ts::myRank) {
		fprintf(stderr, "[%d]<-[%d] %s (%d,%d)-(%d,%d)\n",
				ts::myRank, ppp, __FUNCTION__,
				r.left, r.top, r.width, r.height);
	}
*/	
	return od;
}

tfun tree h_tree (struct rect r, int ppp)
{
	struct tree res;

	enum dmeth {
		no_div,
		vert_div,
		hor_div,
	} div_method;

	if (r.width*r.height <= MAX_JOB_SIZE) div_method = no_div;
	else div_method = (r.width > r.height)?hor_div:vert_div;
//	else div_method = (1 >= r.height)?hor_div:vert_div;
/*
	if (ppp != ts::myRank) {
		fprintf(stderr, "[%d]<-[%d] %s (%d,%d)-(%d,%d)\n",
				ts::myRank, ppp, __FUNCTION__,
				r.left, r.top, r.width, r.height);
	}
*/
	res.r = r;
	res.node = ts::myRank;
	
	switch (div_method) {
	case hor_div:
		{
			tval tree t1;
			tval tree t2;
			struct rect r1 = r;
			struct rect r2 = r;
			int w2 = r.width/2;
		
			r1.width = w2;
		
			r2.width -= w2;
			r2.left += w2;
		
			t1 = h_tree(r1, ts::myRank);
			res.left = &t1;
			t2 = h_tree(r2, ts::myRank);
			res.right = &t2;
			res.od = NULL;
		
			return res;
		}
	case vert_div:
		{
			tval tree t1;
			tval tree t2;
			struct rect r1 = r;
			struct rect r2 = r;
			int h2 = r.height/2;
		
			r1.height = h2;
		
			r2.height -= h2;
			r2.top += h2;
			
			t1 = h_tree(r1, ts::myRank);
			res.left = &t1;
			t2 = h_tree(r2, ts::myRank);
			res.right = &t2;
			res.od = NULL;
		
			return res;
		}
	case no_div:
		{
			tval struct out_data pd;

			pd = do_out (r, ts::myRank);
			
			res.left = NULL;
			res.right = NULL;
			res.od = &pd;
			
			return res;
		}
	default:
		fprintf(stderr, "BUG\n");
	}
	return 0;
}

static struct out_descr desc;

int consumer (struct tree *t)
{
	int total = 0;
	while (t) {
		struct out_data *p;
		struct tree	*t1;
	
		//fprintf(stderr, "[%d] (%d,%d)-(%d,%d)\n", t->node,
		//		t->r.left, t->r.top, t->r.width, t->r.height);
	
		p = t->od;
		//fprintf(stderr, "next\n");
		if (p) {
			out_fragment (&desc, p->rect, p->px);
			total += t->r.width * t->r.height;
		}
		
		t1 = t->left;
		//fprintf(stderr, "next\n");
		total += consumer(t1);
		t = t->right;
	}
	return total;
}


TFUNDEF(int, sendParams, (int low, int high, ts::TFrz<struct params> par),
		/*static*/, int low; int high; ts::TPtr<struct params> par;,
		_tf->low = low ; _tf->high = high ; _tf->par = par ;, , , 0)
TFUNIMPL(int, sendParams, (int low, int high, ts::TFrz<struct params> par),
		/*static*/, int low; int high; ts::TPtr<struct params> par ;,
		_tf->low = low ; _tf->high = high ; _tf->par = par ;, , , 0)	
//tfun int sendParams(int low, int high, ts::TPtr<struct params> par)
{
	//fprintf (stderr, "[%d] got scene [%d,%d) \n", ts::myRank, low, high);
	if (high-low > 1) {
		tval int w0;
		tval int w1;
		int mid = (high+low)/2;
		{
			tct(atRank(low));
	//fprintf (stderr, "[%d] send scene [%d,%d) \n", ts::myRank, low, mid);
			w0 = sendParams(low, mid, par);
		}
		ts::sleep(0);
		{
			tct(atRank(mid));
	//fprintf (stderr, "[%d] send scene [%d,%d) \n", ts::myRank, mid, high);
			w1 = sendParams(mid, high, par);
		}
		return ((int)w0)+((int)w1);
	} else {
		// download data
		struct params *p;
		p = par;
		//fprintf (stderr, "[%d] got scene \n", ts::myRank);
		memcpy (&loc_params, p, sizeof (struct params));
	}
	return 1;
}

tfun int main (int argc , char *argv[])
{
	int sk = 0;
	int total = 0;
	struct rect r;
	r.left = 0;
	r.top = 0;
	r.width = 512;
	r.height = 512;
	char fname[256] = "rt";

	int i;

	for (i = 1; i < argc; i++) {
		if (!strcmp(argv[i],"-width")) {
			r.width = atoi(argv[++i]);
		} else
		if (!strcmp(argv[i],"-height")) {
			r.height = atoi(argv[++i]);
		} else
		if (!strcmp(argv[i],"-sock")) {
			strncpy(fname, argv[++i], 256);
			sk = 1;
		} else
		if (!strcmp(argv[i],"-output")) {
			strncpy(fname, argv[++i], 256);
			sk = 0;
		} else
		if (!strcmp(argv[i],"--")) {
			i++;
			break;
		} else break;
	}

	parse_cmdline (i, argc, argv);
	
	if (!sk) out_open (&desc, fname, out_type_tga, r.width, r.height, 1);
	else out_open (&desc, fname, out_type_sock, r.width, r.height, 1);
	{
		ts::TPtr<struct params> par = new ts::TObj<struct params>;
		struct params *ppar;
		struct tree t;
		tval int w;

		ppar = par;
		make_params(ppar, r, 0);
		{
			tct(atRank(0));
			w = sendParams(0, ts::realsuperSize, par);
		}
		tdrop(par);
		fprintf(stderr, "Wait\n");
		(int)w;
		fprintf(stderr, "Go..\n");
		t = h_tree (r, ts::myRank);
		total = consumer (&t);
		out_next(&desc);
	}
	
	fprintf(stderr, "Leak: %d\n", total-(r.width*r.height));
	
	return 0;
}
