#ifndef __TRACER__
#define __TRACER__

#include <math.h>

#include "geometry.h"

#ifdef __cplusplus
extern "C" {
#endif

#define _INFINITY   30000

const struct solid *s_scene_isect (const struct scene *s,
		const struct ray *r, double *t);
void set_camera (struct sc_set *, const struct vector*,
		const struct vector*, const struct vector*);
void set_med (struct medium *, const double, const double);
void camera (const struct sc_set *, const double, const double, struct ray*);
double trace (const struct scene*, const struct medium, const double,
		const struct ray*, struct vector*, const int level);
void shade (const struct scene *, const struct medium, const double,
		const struct vector*, const struct vector*,
		const struct solid *, struct vector *, const int level);

#ifdef __cplusplus
};
#endif


#endif
