DO_SUBDIRS	= $(foreach dir,$(SUBDIRS),$(MAKE) -C $(dir) TOPDIR=$(TOPDIR)/.. \
		SUBDIR=$(SUBDIR)/$(dir) PUB=$(PUB) DIST=$(DIST) $@ || exit 1 ; )

DO_SUBDIRS_DEF	= $(foreach dir,$(SUBDIRS),$(MAKE) -C $(dir) TOPDIR=$(TOPDIR)/.. \
		SUBDIR=$(SUBDIR)/$(dir) PUB=$(PUB) DIST=$(DIST) || exit 1 ; )
		
.PHONY		: all depend clean install uninstall dist pub
.SUFFIXES	: .c .tc .o .dep .tex .bib .aux .bbl .dvi .ps .gz .png .mp .mpx .eps .dot

DISTDIR	= $(TOPDIR)/$(DIST)/$(SUBDIR)
PUBDIR	= $(TOPDIR)/$(PUB)

#MAKEFLAGS	+= "-r"

#MAINDEPS	= Makefile $(TOPDIR)/Makefile $(TOPDIR)/rules.mk $(TOPDIR)/config.mk

all		::
		$(DO_SUBDIRS_DEF)

depend		::
		$(DO_SUBDIRS)

clean		::
		$(DO_SUBDIRS)

distclean	:: clean
		$(DO_SUBDIRS)
		
install		::
		$(DO_SUBDIRS)

uninstall	::
		$(DO_SUBDIRS)

dist		:: $(DISTFILES)
		mkdir -p $(DISTDIR)
		$(DO_SUBDIRS)
		if [ x"$(DISTFILES)" != x ] ; then cp -rv $(DISTFILES) $(DISTDIR) ; fi

pub		:: all $(PUBFILES)
		$(DO_SUBDIRS)
		if [ x"$(PUBFILES)" != x ] ; then cp -rv $(PUBFILES) $(PUBDIR) ; fi

%.gz		: % $(MAINDEPS)
		gzip -c $< > $@

%.ps		: %.dot $(MAINDEPS)
		dot -Tps $< > $@

%.ps		: %.dvi $(MAINDEPS)
		dvips -q $< -o $@

%.bbl		: %.tex %.bib %.aux $(MAINDEPS)
		bibtex $(<:.tex=)
		
%.ind		: %.tex %.aux $(MAINDEPS)
		makeindex $(<:.tex=)

%.aux		: %.tex $(MAINDEPS)
		latex $< --interaction batchmode

%.dvi		: %.tex %.aux %.bbl %.ind $(MAINDEPS)
		latex $< --interaction batchmode
		latex $< --interaction batchmode

#%.o		: %.c %.dep $(MAINDEPS)
#		$(CC) $< -o $@

#%.dep		:%.c Makefile $(TOPDIR)/rules.mk
#		
