typedef unsigned char uchar;
uchar cnt[0x100];

inline uchar mfilter_init(const uchar *p, int *delta, uchar *mval) {
  int x, y;
  memset(cnt,0,sizeof(cnt));
  for (x = 0; x < MDIM; x++)
    for (y = 0; y < MDIM; y++) cnt[p[x+y*XDIM]]++;
  *delta = cnt[*mval=0] - (MDIM*MDIM/2+1); 
  while ((*delta) < 0) (*delta) += cnt[++*mval];
  return *mval;
}

inline uchar mfilter_step(const uchar *p, int *delta, uchar *mval) {
  uchar enter, leave;
  int i;
  for (i = 0; i < MDIM; i++) {
    leave = p[0];
    enter = p[MDIM];
    (*delta) -= leave <= (*mval); 
    (*delta) += enter <= (*mval);
    cnt[leave]--; 
    cnt[enter]++; 
    p += XDIM;  
  }
  while ((*delta) < 0)           (*delta) += cnt[++(*mval)];
  while ((*delta) >= cnt[*mval]) (*delta) -= cnt[(*mval)--];  
  return *mval;
}

void mfilter(const uchar *in, uchar *out) {
  int x, y;
  for (y = 0; y <= YDIM-MDIM; y++) {
    int delta;
    uchar mval;
    const uchar *p = in +XDIM*y;
    uchar *q = out+XDIM*y +XDIM*(MDIM/2) +MDIM/2;
    *q++ = mfilter_init(p,&delta,&mval);
    for (x = 0; x < XDIM-MDIM; x++) {
     	    *q++ = mfilter_step(p++,&delta,&mval);
    } 
  }
}

