#include <unistd.h>
#include <sys/socket.h>
#include <netdb.h>
#include "xprof.h"

/********************************************************************/

int xprof_com_server()
{
  int server_fd = socket(PF_INET, SOCK_STREAM, 0);
  if (server_fd == -1)
    return errno;

  struct hostent *server_info = gethostbyname(env.server);
  if (server_info == NULL) {
    close(server_fd);
    return h_errno;
  }

  struct sockaddr_in server_addr;
  server_addr.sin_family = AF_INET;
  server_addr.sin_addr = *((struct in_addr *) server_info->h_addr);
  server_addr.sin_port = htons(env.port);
  if (bind(server_fd, (struct sockaddr *) &server_addr, sizeof(struct sockaddr_in)) == -1) {
    close(server_fd);
    return errno;
  }

  if (listen(server_fd, 1) == -1) {
    close(server_fd);
    return errno;
  }

  int close_com = 0;
  while (!close_com) {
    struct sockaddr_in client_addr;
    socklen_t client_addr_len;
    int message_len;

    int client_fd = accept(server_fd, (struct sockaddr *) &client_addr, &client_addr_len);
    if (client_fd != -1) { 
      while (env.row_data[0] != '\0')
        ;

      if (read(client_fd, &message_len, sizeof(message_len)) != sizeof(message_len)) {
        close(client_fd);
        continue;
      }
      if (read(client_fd, env.row_data, message_len) != message_len) {
        close(client_fd);
        continue;
      }
      close(client_fd);
      env.row_data[message_len]='\0';
      if (!strcmp(env.row_data, "close"))
        close_com = 1;
      else
        kill(env.parent, SIGUSR1);
    }
  }
  close(server_fd);
  return 0;
}

/********************************************************************/

int xprof_com_client(char *message)
{
  int client_fd = socket(PF_INET, SOCK_STREAM, 0);
  if (client_fd == -1)
    return errno;

  struct hostent *server_info = gethostbyname(env.server);
  if (server_info == NULL) {
    close(client_fd);
    return h_errno;
  }

  struct sockaddr_in client_addr;
  client_addr.sin_family = AF_INET;
  client_addr.sin_addr = *((struct in_addr *) server_info->h_addr);
  client_addr.sin_port = htons(env.port);
  if (connect(client_fd, (struct sockaddr *) &client_addr, sizeof(struct sockaddr_in)) == -1) {
    close(client_fd);
    return errno;
  }

  int message_len = strlen(message) + 1;
  if (write(client_fd, &message_len, sizeof(message_len)) == -1 || write(client_fd, message, message_len) == -1) {
    close(client_fd);
    return errno;
  }
  close(client_fd);  
  return 0;
}
