
typedef struct LIST
{
    int x;
    tptr struct LIST next;
} list;


tfun int producer(int n, tout list head)
{
	tptr list ptr;

	ptr = &head;

	while (n>0) {
		// create new list entry
		ptr->x = n;
		tptr list newObj;
		{
			tval list tmp;
			newObj = &tmp;
		}
		if (n > 1) {
			ptr->next = newObj;
		} else {
			ptr->next = 0;
		}
		// write debug info
		printf("Produced %d at rank %d\n",n, ts::myRank);
		printf("before drop\n");
		tdrop(ptr);
		printf("after drop\n");
		// go to next
		ptr = newObj;
		// wait
		ts::sleep(0.1); //(1)
		n--;
	}
	return 0;
}

tfun int consumer(list x, int id)
{
    printf("in consumer %d\n", id);
    list *cur = &x;
    while (cur) {
	    fprintf(stderr, "{%d} consume %d at rank %d\n", id, cur->x, ts::myRank);
	    cur = cur->next;
	    fprintf(stderr, "{%d} got next\n", id);
    }
    return 1;
}


int test(int n, int m)
{
    fprintf(stderr, "\nTEST %d, %d\n",n, m);
    tval list ttt;
    {
	    tct(atRank(ts::realsuperSize - 1));
	    producer(n, ttt);
    }
    tval int a[m];
    for (int i = 0; i < m; i++) {
	    {
		    tct(atRank(rand() % ts::realsuperSize));
		    a[i] = consumer(ttt, i);
	    }
    }
    for (int i = 0; i < m; i++) {
	    (int)a[i];
    }
    printf("after test\n");
}

tfun int main(int argc,char *argv[])
{
	int n = 10;
	int m = 3;
	if (argc > 1) n = atoi(argv[1]);
	if (argc > 2) m = atoi(argv[2]);
	test(n, m);
    return 0;
}
