#include <unistd.h>
#include <fcntl.h>
#include <setjmp.h>

extern jmp_buf env;

/********************************************************************/

static void restore_heap(int fd)
{
  int heap_chunks_count;
  void *addr;
  long size;
  int i;

  read(fd, &heap_chunks_count, sizeof(int));
  for(i = 0; i < heap_chunks_count; i ++) {
    read(fd, (void *) &addr, sizeof(void *)); 
    read(fd, &size, sizeof(long)); 
    read(fd, (void *) addr, size); 
  }
}

/********************************************************************/

static void restore_stack(int fd, void *stack_top_addr)
{
  int dummy;
  void *cur_stack;
  long size;

  cur_stack = (void *) &dummy;
  if(cur_stack >= stack_top_addr)
    restore_stack(fd, stack_top_addr);

  read(fd, &size, sizeof(long));
  read(fd, (void *)stack_top_addr, size);
  
  close(fd);  
  longjmp(env, 1);
}

/********************************************************************/

int restart(char *filename)
{
  void *sbrk_addr, *stack_top_addr;
  int fd;
  
  fd = open(filename, O_RDONLY, 0644);

  read(fd, (void *) &sbrk_addr, sizeof(void *));
  brk(sbrk_addr);
  restore_heap(fd);

  read(fd, (void *) &stack_top_addr, sizeof(void *));
  restore_stack(fd, stack_top_addr);
  
  return 0;
}
