#include <stdio.h>
#include "mop.h"

#include "token.h"
#include "ptree.h"
#include "classwalk.h"
#include "cbodywalk.h"

#include <ext/hash_map>
using namespace std;



class TXX : public Class {
 public:
  static int tfunCounter;
  virtual void TranslateClass(Environment *env);
  virtual void TranslateMemberFunction(Environment *env, Member &m);
  virtual Ptree* TranslatedMemberFunctionDeclarationReplacement();
  static Ptree* declReplacement;
  //  virtual Ptree* TranslateMemberRead(Environment *env, Ptree *m);
  //  virtual Ptree* TranslateMemberWrite(Environment *env, Ptree *m);
#if 0
  virtual Ptree* TranslateNew(Environment*,
			      Ptree* header, Ptree* new_operator,
			      Ptree* placement, Ptree* type_name,
			      Ptree* arglist);
#endif
// Translate New Type
  virtual Ptree* TranslateExpression(Environment*, Ptree* expr);
  static bool Initialize();
  static Ptree* FinalizeClass();
};

bool contains (Ptree *p, const char *s) {
  if (!p) return false;
  if (p->IsLeaf()) return p->Eq((char*)s);
  return contains(p->Car(),s) || contains(p->Cdr(),s);
}

bool containsOutsideCompound (Ptree *p, const char *s) {
  if (!p) return false;
  if (p->IsLeaf()) return p->Eq((char*)s);
  return containsOutsideCompound(p->Car(),s) || 
    (!(p->Car() && p->Car()->IsLeaf() && p->Car()->Eq("{")) && containsOutsideCompound(p->Cdr(),s));
}

bool itWasTFunctionDeclFlag = false; // HACK: Used to recognize TFunBody
char userTFunName[0x100];
bool itWasTFunctionDecl () {
  bool result = itWasTFunctionDeclFlag;
  itWasTFunctionDeclFlag = false;
  return result;
}

Ptree* TXX::declReplacement = NULL;
Ptree* TXX::TranslatedMemberFunctionDeclarationReplacement() {
  Ptree *result = declReplacement;
  declReplacement = NULL;
  if (result) itWasTFunctionDeclFlag = true;
  return result;
}

#if 0
Ptree* fixArgType(Ptree *tree) {
  return 
}
#endif

// FIXME: incorrect!
Ptree* getLast(Ptree *tree) {

  //  fprintf(stderr, "\n\n%s: ", __FUNCTION__); tree->Display();

  if (tree->IsLeaf()) return tree;
  else {
    if (tree->Cdr() && !tree->Cdr()->IsLeaf()) {
      //FIXME: id[]
      if (tree->Cdr()->Car() && tree->Cdr()->Car()->IsLeaf() && *(tree->Cdr()->Car()->ToString()) == '[') {
	tree->SetCdr(Ptree::List(tree->Car() ) );
	tree->SetCar(Ptree::Make("*"));
	return tree->Cdr()->Car();
      }

      return getLast(tree->Cdr());
    } else
      return getLast(tree->Car());
  }
}

Ptree* getArgType(Ptree *tree) {
  //  fprintf(stderr, "\n\n%s: ", __FUNCTION__); tree->Display();
  //return Ptree::List(tree->Car());
  return Ptree::List(tree->Cdr()->Car()); //FIXME: HACK
}

Ptree* getIdentifier(Ptree *tree) {
  //  fprintf(stderr, "\n\n%s: ", __FUNCTION__); tree->Display();
  return (tree && !tree->IsLeaf() && tree->Car() && !tree->Car()->IsLeaf()) ? tree->Car()->Car() : getLast(tree);
}

Ptree* transOut(Ptree *tree) {
  return Ptree::List(Ptree::Make("ts::TOut"),Ptree::Make("<"),getArgType(tree),Ptree::Make(">"),getLast(tree));
}

Ptree* transOutToVar(Ptree *tree) {
  return Ptree::List(Ptree::Make("ts::TObj"),Ptree::Make("<"),getArgType(tree),Ptree::Make(">&"),getLast(tree));
}


Ptree* transVar(Ptree *tree) {
  return Ptree::List(Ptree::Make("ts::TVar"),Ptree::Make("<"),tree->Car(),Ptree::Make(">"),getLast(tree));
}

Ptree* transPtr(Ptree *tree) {
  return Ptree::List(Ptree::Make("ts::TPtr"),Ptree::Make("<"),tree->Car(),Ptree::Make(">"),getLast(tree));
}

Ptree* transNoOut(Ptree *tree) {
  if (tree->IsLeaf())
    return tree;
  else if (contains(tree->Car(),"tval"))
    return transVar(tree);
  else if (contains(tree->Car(),"tptr"))
    return transPtr(tree);
  else
    return 
      tree->Cdr() && !tree->Cdr()->IsLeaf() && !tree->Cdr()->Car()->IsLeaf() && 
      tree->Cdr()->Car()->Car()->IsLeaf() && tree->Cdr()->Car()->Car()->Eq("&") ?
      Ptree::List(tree->Car(), getLast(tree))    :    tree; // remove '&' at start of identifier prefixes
}


Ptree* transIn(Ptree *tree) {
  return Ptree::List(Ptree::Make("ts::TFrz"),Ptree::Make("<"),tree->Car(),Ptree::Make(">"),getLast(tree));
}

Ptree* transNoOutToIn(Ptree *tree) {
  if (tree->IsLeaf())
    return tree;
  else if (contains(tree->Car(),"tval"))
    return transIn(tree);
  else if (contains(tree->Car(),"tptr"))
    return transIn(tree);
  else 
    return tree;
}

Ptree* transOuts(Ptree *tree) {
  if (!tree) return tree;
  return Ptree::Cons(contains(tree->Car(),"tout") ? 
		     transOutToVar(tree->Car()) : transNoOutToIn(tree->Car()), transOuts(tree->Cdr()));
}

static bool showProtoVar = false;
Ptree* mayBeAsn(Ptree* tree, bool out, bool hasout, bool asn) {
  if (!asn) return out ? transOut(tree) : transNoOut(tree);

  Ptree *v = getLast(tree);
  char *vName = v->ToString();

  Ptree *inAsn  = Ptree::Make("_tf->%s = %s", vName, vName);

  Ptree *outDef = Ptree::List(Ptree::Make("ts::TFrz<"),
			      getArgType(tree),
			      Ptree::Make("> __%s(_tf->%s)",vName, vName));

  Ptree *outAsn = Ptree::Make("%s = __%s()", vName, vName);

  if (out==hasout && out && showProtoVar) cout << "  tout " << getArgType(tree)->ToString() << " " << vName << ";";

  return out ? 
    (hasout==out ? outAsn : Ptree::Make(""))
    :
    (hasout==out ? inAsn  : outDef);
}

Ptree* selectDef(Ptree* tree, bool out, bool asn) {
  if (!tree) return tree;
  if (tree->Car()->Eq(",")) {
    return selectDef(tree->Cdr(), out, asn);
  }

  bool hasout = contains(tree->Car()->Car(),"tout");

  return ((hasout == out) || (!out && asn)) ?
    Ptree::Cons(Ptree::List(mayBeAsn(tree->Car(),out,hasout,asn),Ptree::Make(";")),  selectDef(tree->Cdr(), out, asn))
    :
    selectDef(tree->Cdr(), out, asn);
}

const char* selectDefStr(Ptree* tree, bool out, bool asn) {
  Ptree *t = selectDef(tree, out, asn);
  return t ? t->ToString() : "";
}

struct EqStr {
  bool operator()(const char* s1, const char* s2) const { return !strcmp(s1,s2); }
};
__gnu_cxx::hash_map<const char*, bool, __gnu_cxx::hash<const char*>, EqStr> tfundefs;
 
void TXX::TranslateMemberFunction(Environment *env, Member &m) {
  // See classwalker::TranslateFunctionImplementation
  Ptree* sspec = m.GetImplementation()->First();
  Ptree* tspec = m.GetImplementation()->Second();
  Ptree* decl  = m.GetImplementation()->Third();

  char *name = decl->Car()->ToString();
  bool isMain = !strcmp(name,"main");

  if (contains(sspec, "tfun")) {
    name = strdup(name); // Safety 
    snprintf(userTFunName,sizeof(userTFunName)-1,"\"[tfun] %s\"",name);

    cout << "\n  tfun " << tspec->ToString() << " " << name << ":";
    if (isMain) name = "tfunmain"; // masquarade 'main'

    //decl->Cdr()->Display();
    Ptree *tfundef = Ptree::Make("TFUNDEF(%s, %s, (%s), %s, %s, %s, %s, %s, 0)\t",
				 tspec ? tspec->ToString() : "", name, 
				 decl->Cdr()->Cdr()->Car() ? transOuts(decl->Cdr()->Cdr()->Car())->ToString() : "", 
				 "/*static*/",
				 selectDefStr(decl->Cdr()->Cdr()->Car(),false,false),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),false,true),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),true,false),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),true,true));
 
    showProtoVar = true;
    Ptree *tfunimpl= Ptree::Make("TFUNIMPL(%s, %s, (%s), %s, %s, %s, %s, %s, 0)\t",
				 tspec ? tspec->ToString() : "", name, 
				 decl->Cdr()->Cdr()->Car() ? transOuts(decl->Cdr()->Cdr()->Car())->ToString() : "", 
				 "/*static*/",
				 selectDefStr(decl->Cdr()->Cdr()->Car(),false,false),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),false,true),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),true,false),
				 selectDefStr(decl->Cdr()->Cdr()->Car(),true,true));
    showProtoVar = false;

    if (!isMain && !tfundefs[name]) {
      declReplacement = Ptree::List(tfundef, tfunimpl);
      tfundefs[name]  = true;
    } else {
      declReplacement = Ptree::List(tfunimpl);
    }

    cout << "\n";
    tfunCounter++;

  } else {
    if (isMain) cerr << "WARNING: main *is not* declared as tfunction!\n";
  }

}

int  TXX::tfunCounter = 0;

Ptree* TXXTranslateDeclaration(ClassWalker *self, Ptree* def) {
  Ptree* decls = Ptree::Third(def);
  if(decls->IsA(ntDeclarator))        // if it is a function
    return self->TranslateFunctionImplementation(def);
  else{
    // if it is a function prototype or a variable declaration.
    Ptree* decls2;
    Ptree* sspec = Ptree::First(def);
    Ptree* sspec2 = self->TranslateStorageSpecifiers(sspec);
    Ptree* tspec = Ptree::Second(def);
    Ptree* tspec2 = self->TranslateTypespecifier(tspec);


    if (containsOutsideCompound(def,"tfun")) { // Is it tfun proto ?
      char *name = strdup(decls->Car()->Car()->ToString());
      cout << "\n  [prototype] tfun " << tspec->ToString() << " " << name << ":";
      if (tfundefs[name]) {
	return Ptree::List(Ptree::Make("/* "), def, Ptree::Make(" */"));
      } else {
	Ptree *decl = decls->Car();
	//decl->Display(); 
	//FIXME: code duplication
	Ptree *tfundef = Ptree::Make("TFUNDEF(%s, %s, (%s), %s, %s, %s, %s, %s, 0)\t",
				     tspec ? tspec->ToString() : "", name, 
				     decl->Cdr()->Cdr()->Car() ? transOuts(decl->Cdr()->Cdr()->Car())->ToString() : "", 
				     "/*static*/",
				     selectDefStr(decl->Cdr()->Cdr()->Car(),false,false),
				     selectDefStr(decl->Cdr()->Cdr()->Car(),false,true),
				     selectDefStr(decl->Cdr()->Cdr()->Car(),true,false),
				     selectDefStr(decl->Cdr()->Cdr()->Car(),true,true));
	tfundefs[name] = true;
	return tfundef;
      }
    }

    //VAR
    if (containsOutsideCompound(def,"tval")) {
      cout << "  tval " << getIdentifier(decls)->ToString() << ";";
      tspec2 = Ptree::List(Ptree::Make("ts::TVar"),Ptree::Make("<"),tspec2,Ptree::Make(">"));
    }

    if (containsOutsideCompound(def,"tptr")) {
      cout << "  tptr " << getIdentifier(decls)->ToString() << ";";
      tspec2 = Ptree::List(Ptree::Make("ts::TPtr"),Ptree::Make("<"),tspec2,Ptree::Make(">"));
    }

    if(decls->IsLeaf())     // if it is ";"
      decls2 = decls;
    else
      decls2 = self->TranslateDeclarators(decls);
    
    if(sspec == sspec2 && tspec == tspec2 && decls == decls2)
      return def;
    else if(decls2 == nil)
      return new PtreeDeclaration(nil, Ptree::List(nil,
						   Class::semicolon_t));
    else
      return new PtreeDeclaration(sspec2,
				  Ptree::ShallowSubst(tspec2, tspec,
						      decls2, decls,
						      def->Cdr()));
  }
}

Ptree* TFunBodyFixup(Ptree *body) {
  if (body == nil || body->IsLeaf()) return body;

  Ptree *car = body->Car();
  Ptree *cdr = body->Cdr();

  if (car != nil && car->IsLeaf()) { 
    //car->Display();
    if (car->Eq("__FUNCTION__")) {
      car = Ptree::Make(userTFunName);
      //car->Display();
    }
  } else {
    car = TFunBodyFixup(car);
  }
  cdr = TFunBodyFixup(cdr);

  if (car == body->Car() && cdr == body->Cdr()) 
    return body;
  else   
    return Ptree::Cons(car,cdr);
}

Ptree* TXXTranslateFunctionBody(ClassWalker *self, Ptree* body) {
  Ptree *origTrans = self->Translate(body);
  return itWasTFunctionDecl() ? TFunBodyFixup(origTrans) : origTrans;
}

class TXXClassWalker : public ClassWalker {
 public:
  Ptree* TranslateDeclaration(Ptree* def)   { return TXXTranslateDeclaration(this,def); } 
  Ptree* TranslateFunctionBody(Ptree* body) { return TXXTranslateFunctionBody(this,body); } 

  TXXClassWalker(Parser* p) : ClassWalker(p) {}
  static ClassWalker* makeFromParser(Parser* p) { return new TXXClassWalker(p); }
  TXXClassWalker(Walker* w) : ClassWalker(w) {}
  static ClassWalker* makeFromWalker(Walker* w) { return new TXXClassWalker(w); }

  virtual ~TXXClassWalker() {}
};

class TXXClassBodyWalker : public ClassBodyWalker {
 public:
  Ptree* TranslateDeclaration(Ptree* def)   { return TXXTranslateDeclaration(this,def); } 
  Ptree* TranslateFunctionBody(Ptree* body) { return TXXTranslateFunctionBody(this,body); } 

  TXXClassBodyWalker(Walker* w, PtreeArray* tlist) : ClassBodyWalker(w,tlist) {}
  static ClassBodyWalker* make(Walker* w, PtreeArray* tlist) { return new TXXClassBodyWalker(w,tlist); }

  virtual ~TXXClassBodyWalker() {}
};

  

#if 0

// TranslateMemberRead / TranslateMemberWrite
Ptree*  TXX::TranslateMemberRead(Environment *env, Ptree *m) {
  //m->Write(cerr); cerr<<"; ";
  return m;
}

Ptree*  TXX::TranslateMemberWrite(Environment *env, Ptree *m) {
  return TranslateMemberRead(env,m);
}

Ptree* TXX::TranslateNew(Environment* env,
			 Ptree* header, Ptree* op,
			 Ptree* placement, Ptree* tname,
			 Ptree* arglist) {
//  fprintf(stderr, "Called %s!\n", __PRETTY_FUNCTION__);
// Code 

    Ptree* exp2;

    if(header != nil && !header->Eq("::"))
        ErrorMessage(env, "unsupported user keyword: ", header, op);

    Ptree* tname2 = TranslateNewType(env, tname);
    if(arglist == nil)
        exp2 = Ptree::List(TranslateArguments(env, placement), tname2);
    else
        exp2 = Ptree::List(TranslateArguments(env, placement), tname2,
                           TranslateArguments(env, arglist));

    if(header == nil)
        return new PtreeNewExpr(op, exp2);
    else
        return new PtreeNewExpr(header, Ptree::Cons(op, exp2));

}
#endif

Ptree* TXX::TranslateExpression(Environment*, Ptree* expr) {
  expr->Write(cerr); cerr<<"; ";
  return expr;
}


void TXX::TranslateClass(Environment *env) {
//  fprintf(stderr, "Called %s!\n", __PRETTY_FUNCTION__);
};

bool TXX::Initialize() {
  //fprintf(stderr, "Called %s!\n", __PRETTY_FUNCTION__);

  RegisterNewSuffix(".tc");	
  RegisterNewSuffix(".tcc");	
  RegisterNewSuffix(".txx");	
  RegisterNewSuffix(".tpp");	

  ChangeDefaultMetaclass("TXX");
  SetMetaclassForFunctions("TXX");
  CustomClassWalker::Set(TXXClassWalker::makeFromParser, TXXClassWalker::makeFromWalker);
  CustomClassBodyWalker::Set(TXXClassBodyWalker::make);

  RegisterNewMemberModifier("tfun");
  RegisterNewMemberModifier("tval");
  RegisterNewMemberModifier("tptr");

  //FIXME: why ?
  RegisterNewModifier("tout");

  ////RegisterNewModifier("tval");


  return true;
}

Ptree* TXX::FinalizeClass() {
  if (tfunCounter) cout << "\n: " << tfunCounter << " tfunction" << (tfunCounter>1 ? "s":"") << "\n";
  return nil;
}
