//                                                          
//           0,1,0 o-----------o 1,1,0        y
//                 |\          |\            ^
//                 | \         | \           |
//           0,1,1 |  o-----------o 1,1,1    |
//                 |  |        |  |          |
//                 |  |        |  |          |
//           0,0,0 o--|--------o  | 1,0,0    o---------->x                   
//                  \ |         \ |           \         
//                   \|          \|            \            
//              0,0,1 o-----------o 1,0,1       \
//                                               \ z

#include <stdio.h>

struct cubeNode {
       cubeNode tptr x;
       cubeNode tptr y;
       cubeNode tptr z;
       tval int data;
};

int 
cubeShow(cubeNode cube[][2][2])
{
  printf("Index access:\n");
  printf("    %4d o-----------o %-4d\n", cube[0][1][0].data, cube[1][1][0].data); 
  printf("         |\\          |\\\n");       
  printf("         | \\         | \\\n");           
  printf("    %4d |  o-----------o %-4d\n", cube[0][1][1].data, cube[1][1][1].data);    
  printf("         |  |        |  |\n");
  printf("         |  |        |  |\n");
  printf("    %4d o--|--------o  | %-4d\n", cube[0][0][0].data, cube[1][0][0].data);                  
  printf("          \\ |         \\ |\n");        
  printf("           \\|          \\|\n");            
  printf("       %4d o-----------o %-4d\n", cube[0][0][1].data, cube[1][0][1].data);
  printf("\n");
  
  return(0);
}

int 
cubeShowTptr(cubeNode cube[][2][2])
{
  printf("Reference (tptr) access:\n");
  printf("    %4d o-----------o %-4d\n", (*(cube[0][0][0].y)).data, (*(cube[0][1][0].x)).data);
  printf("         |\\          |\\\n");       
  printf("         | \\         | \\\n");           
  printf("    %4d |  o-----------o %-4d\n", (*(cube[0][0][1].y)).data, (*(cube[1][1][0].z)).data);
  printf("         |  |        |  |\n");
  printf("         |  |        |  |\n");
  printf("    %4d o--|--------o  | %-4d\n", (*(cube[0][0][1].z)).data, (*(cube[0][0][0].x)).data);
  printf("          \\ |         \\ |\n");        
  printf("           \\|          \\|\n");            
  printf("       %4d o-----------o %-4d\n", (*(cube[0][0][0].z)).data, (*(cube[1][1][1].y)).data);
  printf("\n");
  
  return(0);
}

tfun int 
tfn(tval cubeNode cubeNd[][2][2])
{
  cubeShow(cubeNd);

  return(0);  
}

tfun int 
tfn1(tval cubeNode cubeNod[][2][2])
{
  cubeShowTptr(cubeNod);

  return 0;
}

tfun int 
modifyCube(tout cubeNode pcube[][2][2])
{
  for (int i = 0; i < 2; i++)
   for (int j = 0; j < 2; j++)
    for (int k = 0; k < 2; k++) {
         pcube[i][j][k].data = 1000*i + 100*j + 10*k;
    }
  return 0;
}

tfun int 
main(int argc, char *argv[])
{
  tval cubeNode cn[2][2][2];
   
  for (int i = 0; i < 2; i++)
   for (int j = 0; j < 2; j++)
    for (int k = 0; k < 2; k++) {
         cn[i][j][k].x = &cn[1-i][j][k];       
         cn[i][j][k].y = &cn[i][1-j][k];
         cn[i][j][k].z = &cn[i][j][1-k];
         cn[i][j][k].data = i + j + k;
    }

  tfn(cn);
  tfn1(cn);
  modifyCube(cn);
  tfn(cn);
  tfn1(cn);
        
  return(0); 
}
