#include <stdio.h>
#include <string.h>

static long getMemFree();

static long 
getMemFree()
{
  FILE *fp;
  char buffer[1024], *p;
  size_t n;
  long mfvalue = 0;

  fp = fopen("/proc/meminfo", "r");
  if (fp == NULL) return(-1);
  n = fread(buffer, 1, sizeof(buffer), fp);
  fclose(fp);
  if (n == 0 || n == sizeof(buffer)) return(-1);
  buffer[n] = '\0';
  p = strstr(buffer, "MemFree:");
  if (p == NULL) return(-1);
  sscanf(p, "MemFree: %ld", &mfvalue);

  return(mfvalue);  
}

tfun int 
tfunc(int ii)
{
  int tptr x = new tval int [10000];
  
  for (int i = 0; i < 10000; i++) {
       x[i] = i;
  }
  delete[] x;
  
  return(ii);
}

tfun int 
main(int argc, char *argv[])
{
  tval int a[10000]; 
  int i;
  
  printf("Stress test in progress ...\n");  
  printf("Free Memory is %ld kB\n", getMemFree());
  for (i = 0; i < 10000; i++) {
       a[i] = tfunc(i);
  }
  for (i = 0; i < 10000; i++) {
       if (a[i] != i) {
           printf("Incorrect a[%d]=%d\n", i, (int)a[i]); 
       } 
  }
  printf("Free Memory is %ld kB\n", getMemFree());
  
  return(0); 
}
