// test26.tcc
//     t-  ,   
//    t-.

//   .
// insertItem    -       ,  
//                        
//                   'info'.
// deleteItem    -     ,     .
// modifyItem    -     ,     
//                  (       
//                     'info'.)
// isItemPresent - ,      .
// isEmptyList   - :     ?
// displayList   -      .
// destroyList   -  ,  .

#include <stdio.h>
#include <string.h>

struct node {
       node tptr next;
       char tptr info;
};

//       ,    
//        'info'.
int 
insertItem(node **head, char *pnewinfo)
{
  node *n, *pnewnode, *nsave;
  int insertfl;

  if (*head == NULL) {
      pnewnode = new node;
      pnewnode->info = pnewinfo;
      pnewnode->next = NULL;
      *head = pnewnode;
      return(0);
  }
  
  for (n = *head, insertfl = 0; n != NULL; n = n->next) {
       if (strcmp(pnewinfo, n->info) <= 0) {
           pnewnode = new node;
           pnewnode->info = pnewinfo;
           if (n == *head) {
               pnewnode->next = n;
               *head = pnewnode;
           } else {
                   pnewnode->next = n;
                   nsave->next = pnewnode;
             }
           insertfl = 1;             
           break;
       }
       nsave = n;    
  }
  if (!insertfl) {
      pnewnode = new node;
      pnewnode->info = pnewinfo;
      pnewnode->next = NULL;
      nsave->next = pnewnode;
  }
  return(0);
}

//     ,     .
int 
deleteItem(node **head, char *pinfo)
{
  node *n, *nsave;

  if (*head == NULL) { return(0); }
  
  for (n = *head; n != NULL; n = n->next) {
       if (!strcmp(n->info, pinfo)) {
           if (n == *head) {
               (*head) = n->next;
               delete n;
               n = NULL;
           } else {
                   nsave->next = n->next;
                   delete n;
                   n = NULL; 
             }
           break;             
       }
       nsave = n; 
  }
  return(0);
}

// ,      .
// :
//     0 -   ,
//     1 -  .
int 
isItemPresent(node **head, char *pinfo)
{
  node *n;
  int foundfl;
  if (*head == NULL) { return(0); }

  for (n = *head, foundfl = 0; n != NULL; n = n->next) {
       if (!strcmp(n->info, pinfo)) {
           foundfl = 1;
           break;  
        }
  }
  return(foundfl ? 1 : 0); 
}

//     ,     .
//          
//   'info'.
int 
modifyItem(node **head, char *pinfo, char *pnewinfo)
{
  int foundfl = isItemPresent(head, pinfo);
  if (foundfl) {
      deleteItem(head, pinfo);
      insertItem(head, pnewinfo); 
  }
  return(foundfl);
}

// :     ?
// :
//     0 -   ,
//     1 -  .
int 
isEmptyList(node **head)
{
  return((*head == NULL) ? 1 : 0);
}

//   .
int 
displayList(node **head)
{
  node *p;
  int i = 0;
  if (*head == NULL) { printf("The list is empty.\n"); return(0); }
  else {
        for (p = *head; p != NULL; p = p->next, i++) {
             printf("%d item is '%s'.\n", i, p->info);
        }
  }
  return(0);
}

//  ,  .
int 
destroyList(node **head)
{
  node *n;
  int i = 0;

  while (*head != NULL) {
         n = *head;
         (*head) = (*head)->next;
         delete n;
         n = NULL;
         i++;
  }
  printf("%d item(s) destroyed in the list.\n", i);
  return(0);
}

tfun int tf2_printList(node tptr tptr phead)
{
  displayList(phead);
  return(0);
}

tfun int tf1_initList(tout node tptr tptr phead)
{
  insertItem(phead, "apple");
  insertItem(phead, "orange");
  insertItem(phead, "tomato");
  return(0);
}

tfun int main(int argc, char *argv[])
{
  node tptr head = NULL;

  tf1_initList(&head);
  tf2_printList(&head);
  destroyList(&head);

  return(0);
}
