######################
# Development layout #
######################


# Thread library
#PTHLIBDIR=$(TOP)/pth/.libs
#PTHCFLAGS=-I$(TOP)/pth
#PTHLDFLAGS=-L$(PTHLIBDIR) -lpth
#PTHLIB:
#	@make -C $(TOP)/pth

# Visualization preprocessor
VPP=$(TOP)/debug/viz/vpp

# Signal handling library
# FIXME: Wad - build static library
# FIXME: Wad supports source trace!
WADLDFLAGS=-L$(TOP)/debug/Wad $(TOP)/debug/Wad/wad_init.o -lwad 
WADLIB:
	@make -C $(TOP)/debug/Wad

# Dynamic MPI selection library
DMPICFLAGS=-I$(TOP)/dmpi
DMPILDFLAGS=-L$(TOP)/dmpi -ldmpi
DMPILDSODIR=$(TOP)/dmpi
DMPILIB:
	@make -C $(TOP)/dmpi build

# T-Superstructure
OPENTSSCFLAGS=-I$(TOP)/opentss
OPENTSSLDFLAGS=-L$(TOP)/opentss -ltrt
OPENTSS:
	@make -C $(TOP)/opentss build

# Converter T++->(C++,TSS)
OPENTPP=$(TOP)/opentxx/txx/t++
OPENTXXSODIR=$(TOP)/opentxx/txx
OPENTXX=$(TOP)/opentxx/txx/tt1plus
OPENTXX:
	@make -C $(TOP)/opentxx 

# Memory check library
NJAMDLIB:
	@make -C $(TOP)/debug/njamd 

# Additional libraries
# pstl, ...


#####################
# Production layout #
#####################

SKIFROOT:=$(shell ([ ! -z "$$SKIFROOT" ] && echo -n "$$SKIFROOT") || echo -n "$$HOME/SKIFsoft")
$(SKIFROOT):
	mkdir -p $(SKIFROOT)
	mkdir -p $(SKIFROOT)/usr/include	# public headers
	mkdir -p $(SKIFROOT)/usr/lib		# public libs
	mkdir -p $(SKIFROOT)/usr/share/opents 	# public shareds
	mkdir -p $(SKIFROOT)/usr/share/doc/opents  # public docs
	mkdir -p $(SKIFROOT)/usr/bin         	# public binaries
	mkdir -p $(SKIFROOT)/usr/bin/opents     # specific binaries

DEVROOT=$(SKIFROOT)/usr/src
$(DEVROOT): 
	mkdir -p $(DEVROOT)/BUILD		# build dir
	mkdir -p $(DEVROOT)/SOURCE		# source tar dir 
	mkdir -p $(DEVROOT)/SOURCE/HTML		# some HTML'ized source 
	mkdir -p $(DEVROOT)/SPECS		# specfiles
	mkdir -p $(DEVROOT)/RPMS		# RPMs
	mkdir -p $(DEVROOT)/SRPMS		# SRPMs
	mkdir -p $(DEVROOT)/BINTAR		# binary distrib
	mkdir -p $(DEVROOT)/DEBIAN		# debian packs

RPMINSTALL= if [ "x$$DESTDIR" = "x" ]; then ROOT=$(SKIFROOT)/usr; else ROOT="$$DESTDIR"; fi; \
        SPEC="$(DEVROOT)/SPECS/_.spec"; \
        export ROOT SPEC; $(TOP)/wizard/rpminstall

HTMLINSTALL= ROOT=$(SKIFROOT)/usr; export ROOT SPEC ; $(TOP)/wizard/htmlinstall

